$include "shlwapi.inc"
$include "stdio.inc"
$include "mswsock.inc"
$include "commctrl.inc"
$include "resource.inc"
$include "tchar.inc"
$include "mmsystem.inc"
autodefine "OFF"
$use "msvcrt.lib"

type DIVSTRUCT
	int Quotient
	int Remainder
endtype


type ASMCOMMANDS
	int name ' 3 or 4 characters
	FARPROC handler
	int arguments
endtype

enum CLIENT_FLAGS
	CLIENTFLAG_PASSIVE = 1
	CLIENTFLAG_LOGGEDOUT = 2
	CLIENTFLAG_TRANSFERING_DATA = 4
	CLIENTFLAG_ABORT = 8
endenum

const NOT_CLIENTFLAG_ABORT = 0xFFFFFFFF - CLIENTFLAG_ABORT

enum SERVER_FLAGS
	SERVERFLAG_ALLOW_ANONYMOUS = 1
endenum

'////////////////////////////////
type TCPLISTENSOCK
	int ip   ' [IN]
	int port ' [IN,OUT]
	SOCKET s ' [OUT]
endtype

'////////////////////////////////
type sockaddr_in_accept
	sockaddr_in sa
	char extra [16]
endtype

type ACCEPTDATA
	sockaddr_in_accept sa[2]
endtype

'////////////////////////////////
class CBase
	declare CBase()
	declare _CBase()
	declare AddRef()
	declare virtual Release()

	pointer m_next
	int    m_refcount
endclass

'////////////////////////////////
class CUser, CBase
	declare CUser()
	declare SetUserName(LPSTR name)
	declare SetPassword(LPSTR pass)
	declare SetHomeDir(LPSTR homedir)
	declare SetAccessMask(ACCESS_MASK mask) ' GENERIC_READ | GENERIC_WRITE | _DELETE
	declare virtual Release()

	' all BSTR's here are ansi strings
	BSTR        m_name
	BSTR        m_pass
	BSTR        m_homedir
	ACCESS_MASK m_accessmask
	UINT        m_codepage ' initial encoding (ansi)
endclass

'////////////////////////////////
class CServer, CBase
	declare CServer()
	declare _CServer()
	declare virtual Release()

	declare Listen(DWORD dwInterface, USHORT port),DWORD ' WSA error code

	declare InitiateAccept(),DWORD
	declare OnAccept(BOOLEAN TimerOrWaitFired)
	declare OnClientConnected(SOCKET client)
	declare Terminate()
	declare Lock()
	declare Unlock()
	declare GetAnonUser(pointer ppv),BOOL

	' users
	declare AddUser(LPSTR name, LPSTR pass, LPSTR homedir, ACCESS_MASK accessmask),pointer 'returns CUser*
	declare FindUser(LPSTR name, LPSTR pass, pointer ppv),BOOL
	declare DeleteAllUsers()

	declare AddClient(CBase client)
	declare RemoveClient(pointer client)
	declare DeleteAllClients()

	SOCKET  m_sock
	SOCKET  m_client
	HANDLE  m_hMutex
	pointer m_clients   ' CBase
	pointer m_users     ' CUser
	pointer m_anonymous ' CUser

	SERVER_FLAGS m_flags

	HANDLE     m_hWait
	OVERLAPPED m_ov
	ACCEPTDATA m_accdata
endclass

'////////////////////////////////
class CClient, CBase
	declare CClient()
	declare SetDefaultHomeDir()

	declare _CClient()
	declare Cleanup()
	declare ReleaseUser() ' m_user

	declare ClientThread()
	declare virtual Release()
	declare OnPacketReceived(pointer pdata, int size)
	declare GetFullPath(LPSTR pszFullPath, LPSTR pszFile),BOOL
	declare GetFullPathW(LPWSTR pszFullPath, LPSTR pszFile),BOOL ' uses m_codepage
	declare IsLoggedIn(),BOOL
	declare DataSocketOpened(),BOOL
	declare CheckPermissions(ACCESS_MASK perms),BOOL

	declare SendText(SOCKET s, LPSTR text)
	declare SendErrorCode(SOCKET s, UINT code, ...)
	declare SendBinary(SOCKET s, LPSTR pdata, int size)

	' login
	declare OnCommand_USER(LPSTR name)
	declare OnCommand_PASS(LPSTR pass)
	declare OnCommand_REIN()

	declare OnCommand_SYST()
	declare OnCommand_TYPE(string pdata)
	declare OnCommand_PORT(string pdata)
	declare OnCommand_OPTS(string pdata)
	declare OnCommand_PASV()
	declare OnCommand_FEAT() ' missing documentation
	declare OnCommand_NOOP()
	declare OnCommand_QUIT()

	' directory operations
	declare OnCommand_PWD()
	declare OnCommand_CWD(string dir)
	declare OnCommand_CDUP()
	declare OnCommand_LIST(LPSTR pathname) ' abortable
	declare OnCommand_NLST(LPSTR pathname) ' abortable
	declare OnCommand_RMD(string pathname)
	declare OnCommand_MKD(string pathname)

	' file operations
	declare OnCommand_DELE(string pathname)
	declare OnCommand_RETR(string szFileName) ' abortable
	declare OnCommand_STOR(string szFileName) ' abortable
	declare OnCommand_APPE(string szFileName) ' abortable
	declare OnCommand_RNFR(string szFileName)
	declare OnCommand_RNTO(string szFileName)
	declare OnCommand_SIZE(string szFileName) ' missing documentation
	declare OnCommand_ABOR()

	' PASV elper
	declare OnClientConnectedToDataPort(BOOLEAN TimerOrWaitFired)
	' PORT helper
	declare OnConnectedToClientDataPort(BOOLEAN TimerOrWaitFired)
	' STOR, APPE helper
	declare ReceiveFileLoop(HANDLE hFile)
	' ABORT
	declare Aborted(),BOOL
	declare ClearAbortFlag()

	SOCKET       m_sock
	SOCKET       m_listenSocket
	SOCKET       m_dataSocket
	HANDLE       m_hThread
	DWORD        m_localIp
	CLIENT_FLAGS m_flags
	pointer      m_server     ' CServer automatic reference
	HANDLE       m_hStopEvent ' if set, do not call m_server->RemoveClient
	UINT         m_codepage   ' initial encoding (ansi)
	'
	LPSTR      m_username   ' USER+PASS
	pointer    m_user       ' CUser ReleaseUser() valid after PASS
	istring    m_homedir[MAX_PATH]
	istring    m_curdir[MAX_PATH]
	istring    m_szType[2]
	' PASV, STOR
	OVERLAPPED m_ov
	ACCEPTDATA m_accdata
	HANDLE     m_hWaitClientDataPort
	' rename
	LPSTR      m_pszRenameFrom ' RNFR+RNTO
endclass

' http://swiftp.googlecode.com/svn/trunk/src/org/swiftp/

$ifndef _mainb_
declare extern logprintf(...)
extern ConnectEx  as UINT
extern Xsprintf   as UINT
extern X_snprintf as UINT
$endif

$ifndef _util_
declare extern CreateOverlappedTcpSocket(pointer ppv),BOOL
declare extern CreateListeningTcpSocket(TCPLISTENSOCK p, int backlog),DWORD
declare extern AcceptConnection(SOCKET listening, SOCKET client, OVERLAPPED pov, ACCEPTDATA paccdata),BOOL
declare extern CreateManualResetEvent(pointer ppv),HANDLE
declare extern InitializeOverlappedStruct(OVERLAPPED ov),HANDLE
declare extern MyCloseSocket(SOCKET s byref)
declare extern MyCloseHandle(HANDLE h byref)
declare extern MyUnregisterWait(HANDLE h byref)
declare extern MySysFreeString(pointer ppv)
declare extern StringReplaceAll(LPSTR p, char find, char replace)
$endif
