/*++
Copyright(c)1989-1997	Microsoft Corporation
Module Name:
	mswsock.h
Abstract:
	This module contains the Microsoft-specific extensions to the Windows Sockets API.
Author:
	Keith Moore(keithmo)06-Oct-1995(Separated from WINSOCK.H).
--*/

$ifndef __mswsock_inc__
$define __mswsock_inc__

$use "Mswsock.lib"
$use "custom\\sdkincludes.lib"

'Options for connect and disconnect data and options. Used only by non-TCP/IP transports such as DECNet, OSI TP4, etc.
$define SO_CONNDATA	0x7000
$define SO_CONNOPT	0x7001
$define SO_DISCDATA	0x7002
$define SO_DISCOPT	0x7003
$define SO_CONNDATALEN	0x7004
$define SO_CONNOPTLEN	0x7005
$define SO_DISCDATALEN	0x7006
$define SO_DISCOPTLEN	0x7007

' Option for opening sockets for synchronous access.
$define SO_OPENTYPE	0x7008

$define SO_SYNCHRONOUS_ALERT	0x10
$define SO_SYNCHRONOUS_NONALERT	0x20

' Other NT-specific options.
$define SO_MAXDG	0x7009
$define SO_MAXPATHDG	0x700A
$define SO_UPDATE_ACCEPT_CONTEXT	0x700B
$define SO_CONNECT_TIME	0x700C

' TCP options.
$define TCP_BSDURGENT	0x7000

' MS Transport Provider IOCTL to control reporting PORT_UNREACHABLE messages on UDP sockets
' via recv/WSARecv/etc. Path TRUE in input buffer to enable(default if supported), FALSE to disable.
$define SIO_UDP_CONNRESET	0x9800000C

/*
*	MS Transport Provider IOCTL to request
*	notification when a given socket is closed.
*	Input buffer must be a pointer to the socket handle.
*	Input buffer size must be exactly sizeof(HANDLE).
*	Output buffer and output buffer length must be
*	NULL and 0 respectively. This IOCTL must always
*	be issued with an overlapped structure.
 */
$define SIO_SOCKET_CLOSE_NOTIFY	0x9800000D

' Microsoft extended APIs.
declare import,WSARecvEx(SOCKET s,pointer buf,int _len,pointer flags),int

type TRANSMIT_FILE_BUFFERS
	LPVOID Head
	DWORD HeadLength
	LPVOID Tail
	DWORD TailLength
endtype

$define TF_DISCONNECT	0x01
$define TF_REUSE_SOCKET	0x02
$define TF_WRITE_BEHIND	0x04
$define TF_USE_DEFAULT_WORKER 0x00
$define TF_USE_SYSTEM_THREAD	0x10
$define TF_USE_KERNEL_APC	0x20

declare import,TransmitFile(SOCKET hSocket,HANDLE hFile,DWORD nNumberOfBytesToWrite,DWORD nNumberOfBytesPerSend,pointer lpOverlapped,pointer lpTransmitBuffers,DWORD dwReserved),BOOL
declare import,AcceptEx(SOCKET sListenSocket,SOCKET sAcceptSocket,PVOID lpOutputBuffer,DWORD dwReceiveDataLength,DWORD dwLocalAddressLength,DWORD dwRemoteAddressLength,pointer lpdwBytesReceived,pointer lpOverlapped),BOOL
declare import,GetAcceptExSockaddrs(PVOID lpOutputBuffer,DWORD dwReceiveDataLength,DWORD dwLocalAddressLength,DWORD dwRemoteAddressLength,pointer LocalSockaddr,pointer LocalSockaddrLength,pointer RemoteSockaddr,pointer RemoteSockaddrLength)

' "QueryInterface" versions of the above APIs.
declare LPFN_TRANSMITFILE(SOCKET hSocket,HANDLE hFile,DWORD nNumberOfBytesToWrite,DWORD nNumberOfBytesPerSend,pointer lpOverlapped,pointer lpTransmitBuffers,DWORD dwReserved),BOOL
'$define WSAID_TRANSMITFILE {0xb5367df0,0xcbac,0x11cf,{0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92}}
extern _WSAID_TRANSMITFILE as GUID

declare LPFN_ACCEPTEX(SOCKET sListenSocket,SOCKET sAcceptSocket,PVOID lpOutputBuffer,DWORD dwReceiveDataLength,DWORD dwLocalAddressLength,DWORD dwRemoteAddressLength,pointer lpdwBytesReceived,pointer lpOverlapped),BOOL
'$define WSAID_ACCEPTEX {0xb5367df1,0xcbac,0x11cf,{0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92}}
extern _WSAID_ACCEPTEX as GUID

declare LPFN_GETACCEPTEXSOCKADDRS(PVOID lpOutputBuffer,DWORD dwReceiveDataLength,DWORD dwLocalAddressLength,DWORD dwRemoteAddressLength,pointer LocalSockaddr,pointer LocalSockaddrLength,pointer RemoteSockaddr,pointer RemoteSockaddrLength)
'$define WSAID_GETACCEPTEXSOCKADDRS {0xb5367df2,0xcbac,0x11cf,{0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92}}
extern _WSAID_GETACCEPTEXSOCKADDRS as GUID

$define TP_ELEMENT_MEMORY	1
$define TP_ELEMENT_FILE	2
$define TP_ELEMENT_EOP	4

type TRANSMIT_PACKETS_ELEMENT
	ULONG dwElFlags
	ULONG cLength
'	union
		PVOID	pBuffer[0]
'	struct
		LARGE_INTEGER nFileOffset
		HANDLE	hFile
'	}
'	}
endtype

$define TP_DISCONNECT	TF_DISCONNECT
$define TP_REUSE_SOCKET	TF_REUSE_SOCKET
$define TP_USE_DEFAULT_WORKER	TF_USE_DEFAULT_WORKER
$define TP_USE_SYSTEM_THREAD	TF_USE_SYSTEM_THREAD
$define TP_USE_KERNEL_APC	TF_USE_KERNEL_APC

declare LPFN_TRANSMITPACKETS(SOCKET hSocket, pointer lpPacketArray, DWORD nElementCount, DWORD nSendSize, pointer lpOverlapped, DWORD dwFlags),BOOL
extern _WSAID_TRANSMITPACKETS as GUID'	{0xd9689da0,0x1f90,0x11d3,{0x99,0x71,0x00,0xc0,0x4f,0x68,0xc8,0x76}}

declare LPFN_CONNECTEX (SOCKET s,pointer name,int namelen,PVOID lpSendBuffer,DWORD dwSendDataLength,pointer lpdwBytesSent,pointer lpOverlapped),BOOL
extern _WSAID_CONNECTEX as GUID'	{0x25a207b9,0xddf3,0x4660,{0x8e,0xe9,0x76,0xe5,0x8c,0x74,0x06,0x3e}}
/*
sapero:
declare *ConnectEx(SOCKET s,sockaddr *name,int namelen,PVOID lpSendBuffer,DWORD dwSendDataLength,DWORD *lpdwBytesSent,OVERLAPPED *lpOverlapped),BOOL;
int BytesReturned;
WSAIoctl(SocketHandle, SIO_GET_EXTENSION_FUNCTION_POINTER, _WSAID_CONNECTEX, sizeof(GUID), &ConnectEx, 4, &BytesReturned, 0, 0);
*/

declare LPFN_DISCONNECTEX(SOCKET s,pointer lpOverlapped,DWORD dwFlags,DWORD dwReserved),BOOL
extern _WSAID_DISCONNECTEX as GUID'	{0x7fda2e11,0x8630,0x436f,{0xa0, 0x31, 0xf5, 0x36, 0xa6, 0xee, 0xc1, 0x57}}

$define DE_REUSE_SOCKET TF_REUSE_SOCKET

/*
*	Network-location awareness -- Name registration values for use
*	with WSASetService and other structures.
 */

' {6642243A-3BA8-4aa6-BAA5-2E0BD71FDD83}
extern _NLA_NAMESPACE_GUID as GUID'	{0x6642243a,0x3ba8,0x4aa6,{0xba,0xa5,0x2e,0xb,0xd7,0x1f,0xdd,0x83}}

' {6642243A-3BA8-4aa6-BAA5-2E0BD71FDD83}
extern _NLA_SERVICE_CLASS_GUID as GUID'	{0x37e515,0xb5c9,0x4a43,{0xba,0xda,0x8b,0x48,0xa8,0x7a,0xd2,0x39}}

$define NLA_ALLUSERS_NETWORK	0x00000001
$define NLA_FRIENDLY_NAME	0x00000002

typedef NLA_BLOB_DATA_TYPE int
$define NLA_RAW_DATA	0
$define NLA_INTERFACE	1
$define NLA_802_1X_LOCATION	2
$define NLA_CONNECTIVITY	3
$define NLA_ICS	4

typedef NLA_CONNECTIVITY_TYPE int
$define NLA_NETWORK_AD_HOC	0
$define NLA_NETWORK_MANAGED	1
$define NLA_NETWORK_UNMANAGED	2
$define NLA_NETWORK_UNKNOWN	3

typedef NLA_INTERNET int
$define NLA_INTERNET_UNKNOWN	0
$define NLA_INTERNET_NO	1
$define NLA_INTERNET_YES	2

type NLA_BLOB_header
	NLA_BLOB_DATA_TYPE _type
	DWORD dwSize
	DWORD nextOffset
endtype
type NLA_BLOB_interfaceData
	DWORD dwType
	DWORD dwSpeed
	istring adapterName[1]
endtype
type NLA_BLOB_locationData
	istring information[1]
endtype
type NLA_BLOB_connectivity
	NLA_CONNECTIVITY_TYPE _type
	NLA_INTERNET internet
endtype
type NLA_BLOB_remote
	DWORD speed
	DWORD _type
	DWORD state
	iwstring machineName[256]
	iwstring sharedAdapterName[256]
endtype
type NLA_BLOB_ICS
	NLA_BLOB_remote remote
endtype

type NLA_BLOB

	NLA_BLOB_header header

	union

		' header.type -> NLA_RAW_DATA
		CHAR rawData[1]

		' header.type -> NLA_INTERFACE
		NLA_BLOB_interfaceData interfaceData

		' header.type -> NLA_802_1X_LOCATION
		NLA_BLOB_locationData locationData

		' header.type -> NLA_CONNECTIVITY
		NLA_BLOB_connectivity connectivity

		' header.type -> NLA_ICS
		NLA_BLOB_ICS ICS

	endunion

endtype
$ifndef u_short
typedef u_short USHORT
$endif
type sockaddr
	u_short sa_family	/* address family */
	char	sa_data[14]	/* up to 14 bytes of direct address */
endtype

$ifndef u_long
typedef u_long UINT
$endif
type WSABUF
	u_long	_len	/* the length of the buffer */
	pointer	buf	/* the pointer to the buffer */
endtype

type WSAMSG
	pointer	name	/* Remote address */
	INT	namelen	/* Remote address length */
	pointer	lpBuffers	/* Data buffer array */
	DWORD	dwBufferCount	/* Number of elements the array */
	WSABUF	_Control	/* Control buffer */
	DWORD	dwFlags	/* Flags */
endtype

/*
*	Layout of ancillary data objects the control buffer
 */
type WSACMSGHDR
	SIZE_T	cmsg_len
	INT	cmsg_level
	INT	cmsg_type
	/* followed by UCHAR cmsg_data[] */
endtype

/*
*	Alignment macros for header and data members of
*	the control buffer.
*	/
$define WSA_CMSGHDR_ALIGN(length)	\
		(((length)+ TYPE_ALIGNMENT(WSACMSGHDR)-1)&	\
		(~(TYPE_ALIGNMENT(WSACMSGHDR)-1)))	\

$define WSA_CMSGDATA_ALIGN(length)	\
		(((length)+ MAX_NATURAL_ALIGNMENT-1)&	\
		(~(MAX_NATURAL_ALIGNMENT-1)))
*/
/*
*	WSA_CMSG_FIRSTHDR
*
*	Returns a pointer to the first ancillary data object,
*	or a null pointer if there is no ancillary data the
*	control buffer of the WSAMSG structure.
*
*	LPCMSGHDR
*	WSA_CMSG_FIRSTHDR(_
*	LPWSAMSG	msg
*	)
*	/
$define WSA_CMSG_FIRSTHDR(msg)\
	(((msg)->Control.len >= sizeof(WSACMSGHDR))	\
		?(LPWSACMSGHDR)(msg)->Control.buf	\
		:(LPWSACMSGHDR)NULL)
*/
/*
*	WSA_CMSG_NXTHDR
*
*	Returns a pointer to the next ancillary data object,
*	or a null if there are no more data objects.
*
*	LPCMSGHDR
*	WSA_CMSG_NEXTHDR(_
*	LPWSAMSG	msg,
*	LPWSACMSGHDR	cmsg
*	)
*	/
$define WSA_CMSG_NXTHDR(msg, cmsg)	\
	(((cmsg)== NULL)	\
		? WSA_CMSG_FIRSTHDR(msg)	\
		:((((u_char*)(cmsg)+	\
		WSA_CMSGHDR_ALIGN((cmsg)->cmsg_len)+	\
		sizeof(WSACMSGHDR))>	\
		(u_char*)((msg)->Control.buf)+	\
		(msg)->Control.len)	\
		?(LPWSACMSGHDR)NULL	\
		:(LPWSACMSGHDR)((u_char*)(cmsg)+	\
		WSA_CMSGHDR_ALIGN((cmsg)->cmsg_len))))
*/
/*
*	WSA_CMSG_DATA
*
*	Returns a pointer to the first byte of data(what is referred
*	to as the cmsg_data member though it is not defined
*	the structure).
*
*	u_char*
*	WSA_CMSG_DATA(_
*	LPWSACMSGHDR	pcmsg
*	)
 */
'$define WSA_CMSG_DATA(cmsg)((u_char*)(cmsg)+ WSA_CMSGDATA_ALIGN(sizeof(WSACMSGHDR)))

/*
*	WSA_CMSG_SPACE
*
*	Returns total size of an ancillary data object given
*	the amount of data. Used to allocate the correct amount
*	of space.
*
*	SIZE_T
*	WSA_CMSG_SPACE(_
*	SIZE_T length
*	)
 */
'$define WSA_CMSG_SPACE(length)	(WSA_CMSGDATA_ALIGN(sizeof(WSACMSGHDR)+ WSA_CMSGHDR_ALIGN(length)))

/*
*	WSA_CMSG_LEN
*
*	Returns the value to store cmsg_len given the amount of data.
*
*	SIZE_T
*	WSA_CMSG_LEN(_
*	SIZE_T length
*	)
 */
'$define WSA_CMSG_LEN(length)	(WSA_CMSGDATA_ALIGN(sizeof(WSACMSGHDR))+ length)

/*
*	Definition for flags member of the WSAMSG structure
*	This is addition to other MSG_xxx flags defined
*	for recv/recvfrom/send/sendto.
 */
$define MSG_TRUNC	0x0100
$define MSG_CTRUNC	0x0200
$define MSG_BCAST	0x0400
$define MSG_MCAST	0x0800

typedef LPFN_WSARECVMSG pointer
/*INT
(pointer LPFN_WSARECVMSG)(SOCKET s,
	LPWSAMSG lpMsg,
	LPDWORD lpdwNumberOfBytesRecvd,
	LPWSAOVERLAPPED lpOverlapped,
	LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
	);*/

extern _WSAID_WSARECVMSG as GUID'{0xf689d7c8,0x6f1f,0x436b,{0x8a,0x53,0xe5,0x4f,0xe3,0x51,0xc3,0x22}}

$endif

