/***
*stdio.inc - definitions/declarations for standard I/O routines
*
*	Copyright(c)1985-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*	This file defines the structures, values, macros, and functions
*	used by the level 2 I/O("standard I/O")routines.
*	[ANSI/System V]
*
*	[Public]
*
****/

$ifndef __stdio_inc__
$define __stdio_inc__

$use "_crtdll.lib"
$ifndef __stdlib_inc__
$include "stdlib.inc"
$endif


$ifndef _SIZE_T_DEFINED
typedef size_t UINT
$define _SIZE_T_DEFINED
$endif


$ifndef _MAC

$ifndef _WCHAR_T_DEFINED
typedef wchar_t USHORT
$define _WCHAR_T_DEFINED
$endif

$ifndef _WCTYPE_T_DEFINED
typedef wint_t wchar_t
typedef wctype_t wchar_t
$define _WCTYPE_T_DEFINED
$endif

$endif


$ifndef _VA_LIST_DEFINED
'# ifdef	_M_ALPHA
'struct /*removed {*/
'	pointer a0	/* pointer to first homed integer argument */
'	int offset	/* byte offset of next parameter */
'} va_list
'# else
typedef va_list pointer
'# endif
$define _VA_LIST_DEFINED
$endif


/* Buffered I/O macros */

'# if	defined(_M_MPPC)
'$define BUFSIZ	4096
'# else	/* defined(_M_MPPC)*/
$define BUFSIZ	512
'# endif /* defined(_M_MPPC)*/


/*
*	Default number of supported streams. _NFILE is confusing and obsolete, but
*	supported anyway for backwards compatibility.
 */
'$define _NFILE	_NSTREAM_


$define _NSTREAM_	512

/*
*	Number of entries in _iob[](declared below). Note that _NSTREAM_ must be
*	greater than or equal to _IOB_ENTRIES.
 */
$define _IOB_ENTRIES 20





$define _EOF	(-1)


$ifndef _FILE_DEFINED
type _iobuf
	pointer _ptr
	int	_cnt
	pointer _base
	int	_flag
	int	_file
	int	_charbuf
	int	_bufsiz
	pointer _tmpfname
endtype
type _FILE
	pointer _ptr
	int	_cnt
	pointer _base
	int	_flag
	int	_file
	int	_charbuf
	int	_bufsiz
	pointer _tmpfname
endtype
$define _FILE_DEFINED
$endif


'# ifndef _MAC

/* Directory where temporary files may be created.

# ifdef	_POSIX_
$define _P_tmpdir	"/"
$define _wP_tmpdir	L"/"
# else
$define _P_tmpdir	"\\"
$define _wP_tmpdir	L"\\"
# endif
*/
/* L_tmpnam = size of P_tmpdir
*	+ 1(in case P_tmpdir does not end in "/")
*	+ 12(for the filename string)
*	+ 1(for the null terminator)
 */
'# define L_tmpnam sizeof(_P_tmpdir)+12

'# else	/* def _MAC */

$define L_tmpnam 255

'# endif	/* _MAC */


$ifdef	_POSIX_
$define L_ctermid	9
$define L_cuserid	32
$endif


/* Seek method constants */

$define SEEK_CUR	1
$define SEEK_END	2
$define SEEK_SET	0


$define FILENAME_MAX	260
$define FOPEN_MAX	20
$define _SYS_OPEN	20
$define TMP_MAX	32767

/* Declare _iob[] array */

$ifndef _STDIO_DEFINED
'_CRTIMP extern FILE _iob[]
declare import, _iob()'[_IOB_ENTRIES] as _FILE
' pointer iob	= &_iob
' pointer stdin	= &*<_FILE>iob[0]
' pointer stdout = &*<_FILE>iob[1]
' pointer stderr = &*<_FILE>iob[2]
$endif


/* Define file position type */

$ifndef _FPOS_T_DEFINED
'# undef _FPOSOFF

$ifdef _POSIX_
typedef fpos_t long
$else

'# if	!__STDC__ && _INTEGRAL_MAX_BITS >= 64
typedef fpos_t int64
'# define _FPOSOFF(fp)((long)(fp))
'# else
'struct fpos_t /*removed {*/
'	UINT lopart
'	int	hipart
'	} fpos_t
'# define _FPOSOFF(fp)((long)(fp).lopart)
'# endif
$endif

$define _FPOS_T_DEFINED
$endif


'$define stdin	(&_iob[0])
'$define stdout(&_iob[1])
'$define stderr(&_iob[2])
'extern _stdin as int
'extern _stdout as int
'extern _stderr as int

'extern stdin as pointer ' _FILE*
'extern stdout as pointer ' _FILE*
'extern stderr as pointer ' _FILE*

$define _IOREAD	0x0001
$define _IOWRT	0x0002

$define _IOFBF	0x0000
$define _IOLBF	0x0040
$define _IONBF	0x0004

$define _IOMYBUF	0x0008
$define _IOEOF	0x0010
$define _IOERR	0x0020
$define _IOSTRG	0x0040
$define _IORW	0x0080
$ifdef _POSIX_
$define _IOAPPEND	0x0200
$endif


/* Function prototypes */

$ifndef _STDIO_DEFINED

declare cdecl import, _filbuf(pointer p),int
declare cdecl import, _flsbuf(int i,pointer p),int

$ifdef	_POSIX_
declare cdecl import, _fsopen(pointer p,pointer p),pointer
declare cdecl import, fdopen alias _fdopen(int i,pointer p),pointer
declare cdecl import, fileno alias _fileno(pointer p),int
$else
declare cdecl import, _fsopen(pointer p,pointer p, int i),pointer
declare cdecl import, _fdopen(int i,pointer p),pointer
declare cdecl import, _fileno(pointer p),int
$endif

declare cdecl import, clearerr(pointer p)
declare cdecl import, fclose(pointer p),int
declare cdecl import, _fcloseall(),int

declare cdecl import, feof(pointer p),int
declare cdecl import, ferror(pointer p),int
declare cdecl import, fflush(pointer p),int
declare cdecl import, fgetc(pointer p),int
declare cdecl import, _fgetchar(),int
declare cdecl import, fgetpos(pointer p, pointer p),int
declare cdecl import, fgets(pointer p, int i,pointer p),pointer

declare cdecl import, _flushall(),int
declare cdecl import, fopen(pointer p,pointer p),pointer
declare cdecl import, fprintf(pointer p,pointer p, ...),int
declare cdecl import, fputc(int i,pointer p),int
declare cdecl import, _fputchar(int i),int
declare cdecl import, fputs(pointer p,pointer p),int
declare cdecl import, fread(pointer p, size_t i, size_t i,pointer p),size_t
declare cdecl import, freopen(pointer p,pointer p,pointer p),pointer
declare cdecl import, fscanf(pointer p,pointer p, ...),int
declare cdecl import, fsetpos(pointer p, pointer p),int
declare cdecl import, fseek(pointer p, long i, int i),int
declare cdecl import, ftell(pointer p),int
declare cdecl import, fwrite(pointer p, size_t i, size_t i,pointer p),size_t
declare cdecl import, getc(pointer p),int
declare cdecl import, getchar(),int
declare cdecl import, _getmaxstdio(),int
declare cdecl import, gets(pointer p),pointer
declare cdecl import, _getw(pointer p),int

$ifndef __stdlib_inc__
declare cdecl import, perror(pointer p)
$endif

declare cdecl import, _pclose(pointer p),int
declare cdecl import, _popen(pointer p,pointer p),pointer
declare cdecl import, printf(...),int
declare cdecl import, putc(int i,pointer p),int
declare cdecl import, putchar(int i),int
declare cdecl import, puts(pointer p),int
declare cdecl import, _putw(int i,pointer p),int
declare cdecl import, _rmtmp(),int
declare cdecl import, scanf(pointer p, ...),int
declare cdecl import, setbuf(pointer p,pointer p)
declare cdecl import, _setmaxstdio(int i),int
declare cdecl import, setvbuf(pointer p,pointer p, int i, size_t i),int
declare cdecl import, _snprintf(pointer p, size_t i,pointer p, ...),int
declare cdecl import, sprintf(pointer p,pointer p, ...),int
declare cdecl import, sscanf(pointer p,pointer p, ...),int
declare cdecl import, _tempnam(pointer p,pointer p),pointer
declare cdecl import, tmpfile(),pointer
declare cdecl import, tmpnam(pointer p),pointer
declare cdecl import, ungetc(int i,pointer p),int

$ifndef __io_inc__
declare cdecl import, rename(pointer p,pointer p),int
declare cdecl import, remove(pointer p),int
declare cdecl import, rewind(pointer p)
declare cdecl import, _unlink(pointer p),int
$endif

declare cdecl import, vfprintf(pointer p,pointer p, va_list p),int
declare cdecl import, vprintf(pointer p, va_list p),int
declare cdecl import, _vsnprintf(pointer p, size_t i,pointer p, va_list p),int
declare cdecl import, vsprintf(pointer p,pointer p, va_list p),int
declare cdecl import, _vscprintf(pointer _Format, va_list _ArgList),int
declare cdecl import, _vscwprintf(pointer _Format, va_list _ArgList),int

$ifndef _MAC
$ifndef _WSTDIO_DEFINED

/* wide function prototypes, also declared in wchar.inc	*/

$ifndef WEOF
$define WEOF(0xFFFF)
$endif

$ifdef	_POSIX_
declare cdecl import, _wfsopen(pointer p, pointer p),pointer
$else
declare cdecl import, _wfsopen(pointer p, pointer p, int i),pointer
$endif

declare cdecl import, fgetwc(pointer p),wint_t
declare cdecl import, _fgetwchar(),wint_t
declare cdecl import, fputwc(wint_t w,pointer p),wint_t
declare cdecl import, _fputwchar(wint_t w),wint_t
declare cdecl import, getwc alias fgetwc(pointer p),wint_t
declare cdecl import, getwchar alias fgetwc(pointer p),wint_t
declare cdecl import, putwc(wint_t w,pointer p),wint_t
declare cdecl import, putwchar(wint_t w),wint_t
declare cdecl import, ungetwc(wint_t w,pointer p),wint_t

declare cdecl import, fgetws(pointer p, int i,pointer p),pointer ' pointer
declare cdecl import, fputws(pointer p,pointer p),int
declare cdecl import, _getws(pointer p),pointer ' pointer
declare cdecl import, _putws(pointer p),int

declare cdecl import, fwprintf(pointer p, pointer p, ...),int
declare cdecl import, wprintf(...),int
declare cdecl import, _snwprintf(pointer p, size_t i, pointer p, ...),int
declare cdecl import, swprintf(pointer p, pointer p, ...),int
declare cdecl import, vfwprintf(pointer p, pointer p, va_list p),int
declare cdecl import, vwprintf(pointer p, va_list p),int
declare cdecl import, _vsnwprintf(pointer p, size_t i, pointer p, va_list p),int
declare cdecl import, vswprintf(pointer p, pointer p, va_list p),int
declare cdecl import, fwscanf(pointer p, pointer p, ...),int
declare cdecl import, swscanf(pointer p, pointer p, ...),int
declare cdecl import, wscanf(pointer p, ...),int

'# ifndef __stdlib_inc__
'declare cdecl import, getwchar alias fgetwc(pointer p),wint_t
'declare cdecl import, putwchar alias fputwc(wint_t w,pointer p),wint_t
'declare cdecl import, getwc	alias fgetwc(pointer p),wint_t
'declare cdecl import, putwc	alias fputwc(wint_t w,pointer p),wint_t
'# endif

declare cdecl import, _wfdopen(int i, pointer p),pointer
declare cdecl import, _wfopen(pointer p, pointer p),pointer
declare cdecl import, _wfreopen(pointer p, pointer p,pointer p),pointer
$ifndef __stdlib_inc__
declare cdecl import, _wperror(pointer p)
$endif
declare cdecl import, _wpopen(pointer p, pointer p),pointer
declare cdecl import, _wremove(pointer p),int
declare cdecl import, _wtempnam(pointer p, pointer p),pointer
declare cdecl import, _wtmpnam(pointer p),pointer


$define _WSTDIO_DEFINED
$endif
/* _WSTDIO_DEFINED */
$endif
/* ndef _MAC */

$define _STDIO_DEFINED
$endif
/* _STDIO_DEFINED */


/* Macro definitions

$define feof(_stream)	((_stream)->_flag & _IOEOF)
$define ferror(_stream)	((_stream)->_flag & _IOERR)
$define _fileno(_stream)	((_stream)->_file)
$define getc(_stream)	(--(_stream)->_cnt >= 0 \
		? 0xff &*(_stream)->_ptr++ : _filbuf(_stream))
$define putc(_c,_stream)	(--(_stream)->_cnt >= 0 \
		? 0xff &(*(_stream)->_ptr++ =(char)(_c)):	_flsbuf((_c),(_stream)))
				*/
'# ifndef __stdlib_inc__
'declare cdecl import, getchar alias getc(pointer p)
'declare cdecl import, putchar alias putc(int i,pointer p)
'# endif

'# ifdef	_MT
'# undef	getc
'# undef	putc
'# undef	getchar
'# undef	putchar
'# endif

'# if	!__STDC__ && !defined(_POSIX_)

/* Non-ANSI names for compatibility */

'# define P_tmpdir	_P_tmpdir
$define SYS_OPEN	_SYS_OPEN

declare cdecl import, fcloseall alias _fcloseall(),int
declare cdecl import, fdopen alias _fdopen(int i,pointer p),pointer
declare cdecl import, fgetchar alias _fgetchar(),int
declare cdecl import, fileno alias _fileno(pointer p),int
declare cdecl import, flushall alias _flushall(),int
declare cdecl import, fputchar alias _fputchar(int i),int
declare cdecl import, getw alias _getw(pointer p),int
declare cdecl import, putw alias _putw(int i,pointer p),int
declare cdecl import, rmtmp alias _rmtmp(),int
declare cdecl import, tempnam alias _tempnam(pointer p,pointer p),pointer
declare cdecl import, unlink alias _unlink(pointer p),int

'# endif	/* __STDC__ */



$endif
