/***
*tchar.h - definitions for generic international text functions
*
*	Copyright(c)1991-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*	Definitions for generic international functions, mostly defines
*	which map string/formatted-io/ctype functions to char, wchar_t, or
*	MBCS versions.	To be used for compatibility between single-byte,
*	multi-byte and Unicode text models.
*
*	[Public]
*
****/

$ifndef __tchar_inc__
$define __tchar_inc__
$define _INC_TCHAR

$ifndef _TIME_T_DEFINED
typedef time_t int	/* time value */
$define _TIME_T_DEFINED	/* avoid multiple def's of time_t */
$endif

$ifndef _FSIZE_T_DEFINED
typedef _fsize_t UINT /* Could be 64 bits for Win32 */
$define _FSIZE_T_DEFINED
$endif

$ifndef _DEV_T_DEFINED
typedef _dev_t UINT	/* device code */
typedef dev_t UINT
$define _DEV_T_DEFINED
$endif

$ifndef _INO_T_DEFINED
typedef _ino_t word	/* i-node number(not used on DOS)*/
typedef ino_t word
$define _INO_T_DEFINED
$endif

$ifndef _OFF_T_DEFINED
typedef _off_t int	/* file offset value */
typedef off_t int
$define _OFF_T_DEFINED
$endif

typedef short sword

$ifdef	UNICODE
/* ++++++++++++++++++++ UNICODE ++++++++++++++++++++ */
$ifndef __wchar_inc__
$include "wchar.inc"
$endif

$ifndef _WCTYPE_T_DEFINED
typedef wint_t wchar_t
typedef wctype_t wchar_t
$define _WCTYPE_T_DEFINED
$endif

$ifndef __TCHAR_DEFINED
typedef	_TCHAR wchar_t
typedef	_TSCHAR wchar_t
typedef	_TUCHAR wchar_t
typedef	_TXCHAR wchar_t
typedef	_TINT wint_t
$define __TCHAR_DEFINED
$endif

$ifndef _TCHAR_DEFINED
$ifndef __STDC__
typedef	TCHAR wchar_t
$endif
$define _TCHAR_DEFINED
$endif

'$define _TEOF	EOF
'$define	WEOF _TEOF

'$define __T(x)	L ## x

/* Program */
/*
$define _tmain	wmain
$define _tWinMain	wWinMain
$define _tenviron	_wenviron
$define __targv	__wargv
*/
/* Formatted i/o */
declare cdecl import, _tprintf alias wprintf(pointer p, ...),int
declare cdecl import, _ftprintf alias fwprintf(pointer p, pointer p, ...),int
declare cdecl import, _stprintf alias swprintf(pointer p, pointer p, ...),int
declare cdecl import, _sntprintf alias _snwprintf(pointer p, size_t i, pointer p, ...),int
declare cdecl import, _vtprintf alias vwprintf(pointer p, va_list p),int
declare cdecl import, _vftprintf alias vfwprintf(pointer p, pointer p, va_list p),int
declare cdecl import, _vstprintf alias vswprintf(pointer p, pointer p, va_list p),int
declare cdecl import, _vsntprintf alias _vsnwprintf(pointer p, size_t i, pointer p, va_list p),int
declare cdecl import, _tscanf alias wscanf(pointer p, ...),int
declare cdecl import, _ftscanf alias fwscanf(pointer p, pointer p, ...),int
declare cdecl import, _stscanf alias swscanf(pointer p, pointer p, ...),int

declare cdecl import, _vsctprintf alias _vscwprintf(pointer _Format, va_list _ArgList),int

/* Unformatted i/o */
declare cdecl import, _fgettc alias fgetwc(pointer p),wint_t
declare cdecl import, _fgettchar alias _fgetwchar(),wint_t
declare cdecl import, _fgetts alias fgetws(pointer p, int i,pointer p),pointer
declare cdecl import, _fputtc alias fputwc(wint_t w,pointer p),wint_t
declare cdecl import, _fputtchar alias _fputwchar(wint_t w),wint_t
declare cdecl import, _fputts alias fputws(pointer p,pointer p),int
declare cdecl import, _gettc alias getwc(pointer p),wint_t
declare cdecl import, _gettchar alias getwchar(),wint_t
declare cdecl import, _getts alias _getws(pointer p),pointer
declare cdecl import, _puttc alias putwc(wint_t w,pointer p),wint_t
declare cdecl import, _puttchar alias putwchar(wint_t w),wint_t
declare cdecl import, _putts alias _putws(pointer p),int
declare cdecl import, _ungettc alias ungetwc(wint_t w,pointer p),wint_t

/* String conversion functions */
declare cdecl import, _tcstod alias wcstod(pointer p, pointer p),double
declare cdecl import, _tcstol alias wcstol(pointer p, pointer p, int i),int
declare cdecl import, _tcstoul alias wcstoul(pointer p, pointer p, int i),UINT
declare cdecl import, _itot alias _itow(int i, pointer p, int i),pointer
declare cdecl import, _ltot alias _ltow(int l, pointer p, int i),pointer
declare cdecl import, _ultot alias _ultow(UINT i, pointer p, int i),pointer
declare cdecl import, _ttoi alias _wtoi(pointer p),int
declare cdecl import, _ttol alias _wtol(pointer p),int
declare cdecl import, _ttoi64 alias _wtoi64(pointer p),int64
declare cdecl import, _i64tot alias _i64tow(int64 i, pointer p, int i),pointer
declare cdecl import, _ui64tot alias _ui64tow(uint64 i, pointer p, int i),pointer

/* String functions */

declare cdecl import, _tcscat alias wcscat(pointer p, pointer p),pointer
declare cdecl import, _ftcscat alias wcscat(pointer p, pointer p),pointer
declare cdecl import, _tcscpy alias wcscpy(pointer p, pointer p),pointer
declare cdecl import, _ftcscpy alias wcscpy(pointer p, pointer p),pointer
declare cdecl import, _tcschr alias wcschr(pointer p, wchar_t w),pointer
declare cdecl import, _ftcschr alias wcschr(pointer p, wchar_t w),pointer
declare cdecl import, _tcscspn alias wcscspn(pointer p, pointer p),size_t
declare cdecl import, _ftcscspn alias wcscspn(pointer p, pointer p),size_t
declare cdecl import, _tcsncat alias wcsncat(pointer p, pointer p, size_t i),pointer
declare cdecl import, _ftcsncat alias wcsncat(pointer p, pointer p, size_t i),pointer
declare cdecl import, _tcsncpy alias wcsncpy(pointer p, pointer p, size_t i),pointer
declare cdecl import, _ftcsncpy alias wcsncpy(pointer p, pointer p, size_t i),pointer
declare cdecl import, _tcspbrk alias wcspbrk(pointer p, pointer p),pointer
declare cdecl import, _ftcspbrk alias wcspbrk(pointer p, pointer p),pointer
declare cdecl import, _tcsrchr alias wcsrchr(pointer p, wchar_t w),pointer
declare cdecl import, _ftcsrchr alias wcsrchr(pointer p, wchar_t w),pointer
declare cdecl import, _tcsspn alias wcsspn(pointer p, pointer p),size_t
declare cdecl import, _ftcsspn alias wcsspn(pointer p, pointer p),size_t
declare cdecl import, _tcsstr alias wcsstr(pointer p, pointer p),pointer
declare cdecl import, _ftcsstr alias wcsstr(pointer p, pointer p),pointer
declare cdecl import, _tcstok alias wcstok(pointer p, pointer p),pointer
declare cdecl import, _ftcstok alias wcstok(pointer p, pointer p),pointer
declare cdecl import, _tcsdup alias _wcsdup(pointer p),pointer
declare cdecl import, _ftcsdup alias _wcsdup(pointer p),pointer
declare cdecl import, _tcsnset alias _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, _ftcsnset alias _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, _tcsrev alias _wcsrev(pointer p),pointer
declare cdecl import, _ftcsrev alias _wcsrev(pointer p),pointer
declare cdecl import, _tcsset alias _wcsset(pointer p, wchar_t w),pointer
declare cdecl import, _ftcsset alias _wcsset(pointer p, wchar_t w),pointer
declare cdecl import, _tcscmp alias wcscmp(pointer p, pointer p),int
declare cdecl import, _ftcscmp alias wcscmp(pointer p, pointer p),int
declare cdecl import, _tcsicmp alias _wcsicmp(pointer p, pointer p),int
declare cdecl import, _ftcsicmp alias _wcsicmp(pointer p, pointer p),int
declare cdecl import, _tcsnccmp alias wcsncmp(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsnccmp alias wcsncmp(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsncmp alias wcsncmp(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsncmp alias wcsncmp(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsncicmp alias _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsncicmp alias _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsnicmp alias _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsnicmp alias _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, _tcscoll alias wcscoll(pointer p, pointer p),int
declare cdecl import, _ftcscoll alias wcscoll(pointer p, pointer p),int
declare cdecl import, _tcsicoll alias _wcsicoll(pointer p, pointer p),int
declare cdecl import, _ftcsicoll alias _wcsicoll(pointer p, pointer p),int
declare cdecl import, _tcsnccoll alias _wcsncoll(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsnccoll alias _wcsncoll(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsncoll alias _wcsncoll(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsncoll alias _wcsncoll(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsncicoll alias _wcsnicoll(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsncicoll alias _wcsnicoll(pointer p, pointer p, size_t i),int
declare cdecl import, _tcsnicoll alias _wcsnicoll(pointer p, pointer p, size_t i),int
declare cdecl import, _ftcsnicoll alias _wcsnicoll(pointer p, pointer p, size_t i),int
declare cdecl import, _tcslen alias wcslen(pointer p),size_t
declare cdecl import, _ftcslen alias wcslen(pointer p),size_t

' Execute functions

declare cdecl import, _texecl alias _wexecl(pointer p, pointer p, ...),int
declare cdecl import, _texecle alias _wexecle(pointer p, pointer p, ...),int
declare cdecl import, _texeclp alias _wexeclp(pointer p, pointer p, ...),int
declare cdecl import, _texeclpe alias _wexeclpe(pointer p, pointer p, ...),int
declare cdecl import, _texecv alias _wexecv(pointer p, pointer p),int
declare cdecl import, _texecve alias _wexecve(pointer p, pointer p, pointer p),int
declare cdecl import, _texecvp alias _wexecvp(pointer p, pointer p),int
declare cdecl import, _texecvpe alias _wexecvpe(pointer p, pointer p, pointer p),int
declare cdecl import, _tspawnl alias _wspawnl(int i, pointer p, pointer p, ...),int
declare cdecl import, _tspawnle alias _wspawnle(int i, pointer p, pointer p, ...),int
declare cdecl import, _tspawnlp alias _wspawnlp(int i, pointer p, pointer p, ...),int
declare cdecl import, _tspawnlpe alias _wspawnlpe(int i, pointer p, pointer p, ...),int
declare cdecl import, _tspawnv alias _wspawnv(int i, pointer p, pointer p),int
declare cdecl import, _tspawnve alias _wspawnve(int i, pointer p, pointer p, pointer p),int
declare cdecl import, _tspawnvp alias _wspawnvp(int i, pointer p, pointer p),int
declare cdecl import, _tspawnvpe alias _wspawnvpe(int i, pointer p, pointer p, pointer p),int
declare cdecl import, _tsystem alias _wsystem(pointer p),int

' Time functions
declare cdecl import, _tasctime alias _wasctime(pointer p),pointer
declare cdecl import, _tctime alias _wctime(pointer p),pointer
declare cdecl import, _tstrdate alias _wstrdate(pointer p),pointer
declare cdecl import, _tstrtime alias _wstrtime(pointer p),pointer
declare cdecl import, _tutime alias _wutime(pointer filename, pointer times),int
declare cdecl import, _tcsftime alias wcsftime(pointer p, size_t i, pointer p,pointer p),size_t

' Directory functions

declare cdecl import, _tchdir alias _wchdir(pointer p),int
declare cdecl import, _tgetcwd alias _wgetcwd(pointer p, int i),pointer
declare cdecl import, _tgetdcwd alias _wgetdcwd(int i, pointer p, int i),pointer
declare cdecl import, _tmkdir alias _wmkdir(pointer p),int
declare cdecl import, _trmdir alias _wrmdir(pointer p),int

' Environment/Path functions
declare cdecl import, _tfullpath alias _wfullpath(pointer p, pointer p, size_t i),pointer
declare cdecl import, _tgetenv	alias _wgetenv(pointer p),pointer
declare cdecl import, _tmakepath alias _wmakepath(pointer p, pointer p, pointer p, pointer p, pointer p)
declare cdecl import, _tputenv	alias _wputenv(pointer p),int
declare cdecl import, _tsearchenv alias _wsearchenv(pointer p, pointer p, pointer p)
declare cdecl import, _tsplitpath alias _wsplitpath(pointer p, pointer p, pointer p, pointer p, pointer p)

/* Stdio functions */
declare cdecl import, _tfdopen alias _wfdopen(int i, pointer p),pointer
declare cdecl import, _tfsopen alias _wfsopen(pointer p, pointer p),pointer
declare cdecl import, _tfopen alias _wfopen(pointer p, pointer p),pointer
declare cdecl import, _tfreopen alias _wfreopen(pointer p, pointer p,pointer p),pointer
declare cdecl import, _tperror alias _wperror(pointer p)
declare cdecl import, _tpopen alias _wpopen(pointer p, pointer p),pointer
declare cdecl import, _ttempnam alias _wtempnam(pointer p, pointer p),pointer
declare cdecl import, _ttmpnam alias _wtmpnam(pointer p),pointer

/* Io functions */
declare cdecl import, _taccess alias _waccess(pointer p, int i),int
declare cdecl import, _tchmod alias _wchmod(pointer p, int i),int
declare cdecl import, _tcreat alias _wcreat(pointer p, int i),int
declare cdecl import, _tfindfirst alias _wfindfirst(pointer p, pointer p),int
declare cdecl import, _tfindfirsti64 alias _wfindfirsti64(pointer p, pointer p),int
declare cdecl import, _tfindnext alias _wfindnext(int l, pointer p),int
declare cdecl import, _tfindnexti64 alias _wfindnexti64(int l, pointer p),int
declare cdecl import, _tmktemp alias _wmktemp(pointer p),pointer
declare cdecl import, _topen alias _wopen(pointer p, int i, ...),int
declare cdecl import, _tremove alias _wremove(pointer p),int
declare cdecl import, _trename alias _wrename(pointer p, pointer p),int
declare cdecl import, _tsopen alias _wsopen(pointer p, int i, int i, ...),int
declare cdecl import, _tunlink alias _wunlink(pointer p),int

type _tfinddata_t
	UINT attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	_fsize_t size
	iwstring	name[260]
endtype
type _tfinddatai64_t
	UINT attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	int64	size
	iwstring	name[260]
endtype

/* Stat functions */
declare cdecl import, _tstat alias _wstat(pointer p, pointer p),int
declare cdecl import, _tstati64 alias _wstati64(pointer p, pointer p),int

/* Setlocale functions */
declare cdecl import, _tsetlocale alias _wsetlocale(int i, pointer p),pointer

/* Redundant "logical-character" mappings */
declare cdecl import, _tcsclen alias wcslen(pointer p),size_t
declare cdecl import, _ftcsclen alias wcslen(pointer p),size_t
declare cdecl import, _tcsnccat alias wcsncat(pointer p, pointer p, size_t i),pointer
declare cdecl import, _ftcsnccat alias wcsncat(pointer p, pointer p, size_t i),pointer
declare cdecl import, _tcsnccpy alias wcsncpy(pointer p, pointer p, size_t i),pointer
declare cdecl import, _ftcsnccpy alias wcsncpy(pointer p, pointer p, size_t i),pointer
declare cdecl import, _tcsncset alias _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, _ftcsncset alias _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, _tcslwr alias _wcslwr(pointer p),pointer
declare cdecl import, _ftcslwr alias _wcslwr(pointer p),pointer
declare cdecl import, _tcsupr alias _wcsupr(pointer p),pointer
declare cdecl import, _ftcsupr alias _wcsupr(pointer p),pointer
declare cdecl import, _tcsxfrm alias wcsxfrm(pointer p, pointer p, size_t i),size_t
/*
$define _tcsdec	_wcsdec
$define _tcsinc	_wcsinc
$define _tcsnbcnt	_wcsncnt
$define _tcsnccnt	_wcsncnt

$define _tcsnextc	_wcsnextc
$define _tcsninc	_wcsninc
$define _tcsspnp	_wcsspnp
*/
/*
# if	(__STDC__ || defined(_NO_INLINING))&& !defined(_M_M68K)
$define _tclen(_pc)(1)
$define _tccpy(_pc1,_cpc2)((*(_pc1)=*(_cpc2)))
$define _tccmp(_cpc1,_cpc2)((*(_cpc1))-(*(_cpc2)))
# else
__inline size_t cdecl _tclen(pointer _cpc){ return(_cpc,1); }
__inline void cdecl _tccpy(pointer _pc1, pointer _cpc2){* _pc1 =(wchar_t)*_cpc2; }
__inline int cdecl _tccmp(pointer _cpc1, pointer _cpc2){ return(int i)((*_cpc1)-(*_cpc2)); }
# endif
*/

/* ctype functions */
declare cdecl import, _istalnum alias iswalnum(wint_t w),int
declare cdecl import, _istalpha alias iswalpha(wint_t w),int
declare cdecl import, _istascii alias iswascii(wint_t w),int
declare cdecl import, _istcntrl alias iswcntrl(wint_t w),int
declare cdecl import, _istdigit alias iswdigit(wint_t w),int
declare cdecl import, _istgraph alias iswgraph(wint_t w),int
declare cdecl import, _istlower alias iswlower(wint_t w),int
declare cdecl import, _istprint alias iswprint(wint_t w),int
declare cdecl import, _istpunct alias iswpunct(wint_t w),int
declare cdecl import, _istspace alias iswspace(wint_t w),int
declare cdecl import, _istupper alias iswupper(wint_t w),int
declare cdecl import, _istxdigit alias iswxdigit(wint_t w),int
declare cdecl import, _totupper alias towupper(wchar_t w),wchar_t
declare cdecl import, _totlower alias towlower(wchar_t w),wchar_t
/*
$define _istlegal(_c)	(1)
$define _istlead(_c)	(0)
$define _istleadbyte(_c)	(0)
*/
/*
# if	(__STDC__ || defined(_NO_INLINING))&& !defined(_M_M68K)
$define _wcsdec(_cpc1, _cpc2)((_cpc1)>=(_cpc2)? NULL :(_cpc2)-1)
$define _wcsinc(_pc)	((_pc)+1)
$define _wcsnextc(_cpc)((UINT)*(_cpc))
$define _wcsninc(_pc, _sz)(((_pc)+(_sz)))
$define _wcsncnt(_cpc, _sz)((wcslen(_cpc)>_sz)? _sz : wcslen(_cpc))
$define _wcsspnp(_cpc1, _cpc2)((*((_cpc1)+wcsspn(_cpc1,_cpc2)))?((_cpc1)+wcsspn(_cpc1,_cpc2)): NULL)
# else
__inline pointer	cdecl _wcsdec(pointer	_cpc1, pointer	_cpc2){ return(pointer p)((_cpc1)>=(_cpc2)? NULL :((_cpc2)-1)); }
__inline pointer	cdecl _wcsinc(pointer	_pc){ return(pointer p)(_pc+1); }
__inline UINT cdecl _wcsnextc(pointer	_cpc){ return(UINT)*_cpc; }
__inline pointer	cdecl _wcsninc(pointer	_pc, size_t _sz){ return(pointer p)(_pc+_sz); }
__inline size_t cdecl _wcsncnt(pointer	_cpc, size_t _sz){ size_t len; len = wcslen(_cpc); return(len>_sz)? _sz : len; }
__inline pointer	cdecl _wcsspnp(pointer	_cpc1, pointer	_cpc2){ return(*(_cpc1 += wcsspn(_cpc1,_cpc2))!='\0')?(pointerp)_cpc1 : NULL; }
# endif
*/

$else
/* ndef UNICODE */

/* ++++++++++++++++++++ SBCS and MBCS ++++++++++++++++++++ */

$ifndef __string_inc__
$include "string.inc"
$endif

'$define _TEOF	EOF

'$define __T(x)	x

/* Program */
/*
$define _tmain	main
$define _tWinMain	WinMain
# ifdef	_POSIX_
$define _tenviron	environ
# else
$define _tenviron	_environ
# endif
$define __targv	__argv
*/

/* Formatted i/o */
declare cdecl import, _tprintf alias printf(...),int
declare cdecl import, _ftprintf alias fprintf(pointer p,pointer p, ...),int
declare cdecl import, _stprintf alias sprintf(pointer p,pointer p, ...),int
declare cdecl import, _sntprintf alias _snprintf(pointer p, size_t i,pointer p, ...),int
declare cdecl import, _vtprintf alias vprintf(pointer p, va_list p),int
declare cdecl import, _vftprintf alias vfprintf(pointer p,pointer p, va_list p),int
declare cdecl import, _vstprintf alias vsprintf(pointer p,pointer p, va_list p),int
declare cdecl import, _vsntprintf alias _vsnprintf(pointer p, size_t i,pointer p, va_list p),int
declare cdecl import, _tscanf alias scanf(pointer p, ...),int
declare cdecl import, _ftscanf alias fscanf(pointer p,pointer p, ...),int
declare cdecl import, _stscanf alias sscanf(pointer p,pointer p, ...),int
declare cdecl import, _vsctprintf alias _vscprintf(pointer _Format, va_list _ArgList),int

/* Unformatted i/o */
declare cdecl import, _fgettc alias fgetc(pointer p),int
declare cdecl import, _fgettchar alias _fgetchar(),int
declare cdecl import, _fgetts alias fgets(pointer p, int i,pointer p),pointer
declare cdecl import, _fputtc alias fputc(int i,pointer p),int
declare cdecl import, _fputtchar alias _fputchar(int i),int
declare cdecl import, _fputts alias fputs(pointer p,pointer p),int
declare cdecl import, _gettc alias getc(pointer p),int
declare cdecl import, _gettchar alias getchar(),int
declare cdecl import, _getts alias gets(pointer p),pointer
declare cdecl import, _puttc alias putc(int i,pointer p),int
declare cdecl import, _puttchar alias putchar(int i),int
declare cdecl import, _putts alias puts(pointer p),int
declare cdecl import, _ungettc alias ungetc(int i,pointer p),int

/* String conversion functions */
declare cdecl import, _tcstod alias ustrtod(pointer c,pointer c),double
declare cdecl import, _tcstol alias ustrtol(pointer c,pointer c, int i),int
declare cdecl import, _tcstoul alias ustrtoul(pointer c,pointer c, int i),UINT

declare cdecl import, _itot	alias _itoa(int i,pointer c, int i),pointer
declare cdecl import, _ltot	alias _ltoa(int l,pointer c, int i),pointer
declare cdecl import, _ultot	alias _ultoa(UINT i,pointer c, int i),pointer
declare cdecl import, _ttoi	alias atoi(pointer c),int
declare cdecl import, _ttol	alias atol(pointer c),int
declare cdecl import, _ttoi64	alias _atoi64(pointer c),int64 ' msvcrt
declare cdecl import, _i64tot	alias _i64toa(int64 i,pointer c, int i),pointer
declare cdecl import, _ui64tot alias _ui64toa(uint64 i,pointer c, int i),pointer

/* String functions */

/* Note that _mbscat, _mbscpy and _mbsdup are functionally equivalent to
	strcat, strcpy and strdup, respectively. */
declare cdecl import, _tcsdup	alias _strdup(pointer q),pointer
declare cdecl import, _ftcsdup alias _strdup(pointer q),pointer
declare cdecl import, _tcscpy	alias strcpy(pointer a,pointer b),pointer
declare cdecl import, _ftcscpy alias strcpy(pointer a,pointer b),pointer
declare cdecl import, _tcscat	alias strcat(pointer a,pointer b),pointer
declare cdecl import, _ftcscat alias strcat(pointer a,pointer b),pointer
declare cdecl import, _tcslen	alias strlen(pointer a),int
declare cdecl import, _ftcslen alias strlen(pointer a),int
declare cdecl import, _tcsxfrm alias strxfrm(pointer q,pointer w, size_t e),int

$ifndef __string_inc__
declare cdecl import, strlen(pointer s),int
declare cdecl import, strcpy(pointer s,pointer s),int
$endif
/* Execute functions */
declare cdecl import, _texecl	alias _execl(pointer p,pointer p, ...),int
declare cdecl import, _texecle	alias _execlp(pointer p,pointer p, ...),int
declare cdecl import, _texeclp	alias _execlp(pointer p,pointer p, ...),int
declare cdecl import, _texeclpe alias _execlpe(pointer p,pointer p, ...),int
declare cdecl import, _texecv	alias _execv(pointer p,pointer p),int
declare cdecl import, _texecve	alias _execve(pointer p,pointer p,pointer p),int
declare cdecl import, _texecvp	alias _execvp(pointer p,pointer p),int
declare cdecl import, _texecvpe alias _execvpe(pointer p,pointer p,pointer p),int
declare cdecl import, _tspawnl	alias _spawnl(int i,pointer p,pointer p, ...),int
declare cdecl import, _tspawnle alias _spawnle(int i,pointer p,pointer p, ...),int
declare cdecl import, _tspawnlp alias _spawnlp(int i,pointer p,pointer p, ...),int
declare cdecl import, _tspawnlpe alias _spawnlpe(int i,pointer p,pointer p, ...),int
declare cdecl import, _tspawnv	alias _spawnv(int i,pointer p,pointer p),int
declare cdecl import, _tspawnve alias _spawnve(int i,pointer p,pointer p,pointer p),int
declare cdecl import, _tspawnvp alias _spawnvp(int i,pointer p,pointer p),int
declare cdecl import, _tspawnvpe alias _spawnvpe(int i,pointer p,pointer p,pointer p),int
declare cdecl import, _tsystem	alias system(pointer p),int

/* Time functions */
declare cdecl import, _tasctime alias asctime(pointer t),pointer
declare cdecl import, _tctime alias ctime(pointer t),pointer
declare cdecl import, _tstrdate alias _strdate(pointer c),pointer
declare cdecl import, _tstrtime alias _strtime(pointer c),pointer
declare cdecl import, _tutime alias _utime(pointer filename, pointer times),int
declare cdecl import, _tcsftime alias strftime(pointer c, size_t s,pointer c,pointer t),size_t

/* Directory functions */
declare cdecl import, _tchdir alias _chdir(pointer p),int
declare cdecl import, _tgetcwd alias _getcwd(pointer p, int i),pointer
declare cdecl import, _tgetdcwd alias _getdcwd(int i,pointer p, int i),pointer
declare cdecl import, _tmkdir alias _mkdir(pointer p),int
declare cdecl import, _trmdir alias _rmdir(pointer p),int

/* Environment/Path functions */
declare cdecl import, _tfullpath alias _fullpath(pointer c,pointer c, size_t s),pointer
declare cdecl import, _tgetenv alias getenv(pointer c),pointer
declare cdecl import, _tmakepath alias _makepath(pointer c,pointer c,pointer c,pointer c,pointer c)
declare cdecl import, _tputenv alias _putenv(pointer c),int
declare cdecl import, _tsearchenv alias _searchenv(pointer c,pointer c,pointer c)
declare cdecl import, _tsplitpath alias _splitpath(pointer c,pointer c,pointer c,pointer c,pointer c)

/* Stdio functions */
declare cdecl import, _tfdopen alias _fdopen(int i,pointer p),pointer
declare cdecl import, _tfsopen alias _fsopen(pointer p,pointer p),pointer
declare cdecl import, _tfreopen alias freopen(pointer p,pointer p,pointer p),pointer

declare cdecl import, _tperror alias perror(pointer p)
declare cdecl import, _tpopen alias _popen(pointer p,pointer p),pointer
declare cdecl import, _tfopen alias fopen(pointer p,pointer p),pointer
declare cdecl import, _ttempnam alias _tempnam(pointer p,pointer p),pointer
declare cdecl import, _ttmpnam alias tmpnam(pointer p),pointer

/* Io functions */
declare cdecl import, _tchmod alias _chmod(pointer p, int i),int
declare cdecl import, _tcreat alias _creat(pointer p, int i),int
declare cdecl import, _tfindfirst alias _findfirst(pointer p, pointer p),int
declare cdecl import, _tfindfirsti64 alias _findfirsti64(pointer p, pointer p),int
declare cdecl import, _tfindnext alias _findnexti64(int l, pointer p),int
declare cdecl import, _tfindnexti64 alias _findnexti64(int l, pointer p),int
declare cdecl import, _tmktemp alias _mktemp(pointer p),pointer
declare cdecl import, _topen alias _open(pointer p, int i, ...),int
declare cdecl import, _taccess alias _access(pointer p, int i),int
declare cdecl import, _tremove alias remove(pointer p),int
declare cdecl import, _trename alias rename(pointer p,pointer p),int
declare cdecl import, _tsopen alias _sopen(pointer p, int i, int i, ...),int
declare cdecl import, _tunlink alias _unlink(pointer p),int

type _tfinddata_t
	UINT	attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	_fsize_t	size
	istring	name[260]
endtype
type _tfinddatai64_t
	UINT attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	int64	size
	istring	name[260]
endtype

/* ctype functions */
declare cdecl import, _istascii alias __isascii(int i),int
declare cdecl import, _istcntrl alias iscntrl(int i),int
declare cdecl import, _istxdigit alias isxdigit(int i),int

/* Stat functions */
type _tstat
	_dev_t st_dev
	_ino_t st_ino
	word st_mode
	short st_nlink
	short st_uid
	short st_gid
	_dev_t st_rdev
	_off_t st_size
	time_t st_atime
	time_t st_mtime
	time_t st_ctime
endtype
type _tstati64
	_dev_t st_dev
	_ino_t st_ino
	word st_mode
	short st_nlink
	short st_uid
	short st_gid
	_dev_t st_rdev
	int64 st_size
	time_t st_atime
	time_t st_mtime
	time_t st_ctime
endtype

/* Setlocale functions */
declare cdecl import, _tsetlocale alias setlocale(int i,pointer p),pointer

$ifdef	_MBCS

/* ++++++++++++++++++++ MBCS ++++++++++++++++++++ */
$ifndef __mbstring_inc__
$include "mbstring.inc"
$endif

$ifndef __TCHAR_DEFINED
typedef _TCHAR	byte
typedef _TSCHAR byte
typedef _TUCHAR UCHAR
typedef _TXCHAR UCHAR
typedef _TINT	UINT
$define __TCHAR_DEFINED
$endif

$ifndef _TCHAR_DEFINED
$ifndef __STDC__
typedef	TCHAR byte
$endif
$define _TCHAR_DEFINED
$endif

/* use mb functions directly - types must match */

/* String functions */
declare cdecl import, _tcschr alias _mbschr(pointer p, UINT i),pointer
declare cdecl import, _ftcschr alias _mbschr(pointer p, UINT i),pointer
declare cdecl import, _tcscspn alias _mbscspn(pointer p,pointer p),int
declare cdecl import, _ftcscspn alias _mbscspn(pointer p,pointer p),int
declare cdecl import, _tcsncat alias _mbsnbcat(pointer p,pointer p, size_t i),pointer
declare cdecl import, _ftcsncat alias _mbsnbcat(pointer p,pointer p, size_t i),pointer
declare cdecl import, _tcsncpy alias _mbsnbcpy(pointer p,pointer p, size_t i),pointer
declare cdecl import, _ftcsncpy alias _mbsnbcpy(pointer p,pointer p, size_t i),pointer
declare cdecl import, _tcspbrk alias _mbspbrk(pointer p,pointer p),pointer
declare cdecl import, _ftcspbrk alias _mbspbrk(pointer p,pointer p),pointer
declare cdecl import, _tcsrchr alias _mbsrchr(pointer p, UINT i),pointer
declare cdecl import, _ftcsrchr alias _mbsrchr(pointer p, UINT i),pointer
declare cdecl import, _tcsspn alias _mbsspn(pointer p,pointer p),int
declare cdecl import, _ftcsspn alias _mbsspn(pointer p,pointer p),int
declare cdecl import, _tcsstr alias _mbsstr(pointer p,pointer p),pointer
declare cdecl import, _ftcsstr alias _mbsstr(pointer p,pointer p),pointer
declare cdecl import, _tcstok alias _mbstok(pointer p,pointer p),pointer
declare cdecl import, _ftcstok alias _mbstok(pointer p,pointer p),pointer
declare cdecl import, _tcsnset alias _mbsnbset(pointer p, UINT i, size_t i),pointer
declare cdecl import, _ftcsnset alias _mbsnbset(pointer p, UINT i, size_t i),pointer
declare cdecl import, _tcsrev alias _mbsrev(pointer p),pointer
declare cdecl import, _ftcsrev alias _mbsrev(pointer p),pointer
declare cdecl import, _tcsset alias _mbsset(pointer p, UINT i),pointer
declare cdecl import, _ftcsset alias _mbsset(pointer p, UINT i),pointer
declare cdecl import, _tcscmp alias _mbscmp(pointer p,pointer p),int
declare cdecl import, _ftcscmp alias _mbscmp(pointer p,pointer p),int
declare cdecl import, _tcsicmp alias _mbsicmp(pointer p,pointer p),int
declare cdecl import, _ftcsicmp alias _mbsicmp(pointer p,pointer p),int
declare cdecl import, _tcsnccmp alias _mbsncmp(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsnccmp alias _mbsncmp(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsncmp alias _mbsnbcmp(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsncmp alias _mbsnbcmp(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsncicmp alias _mbsnicmp(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsncicmp alias _mbsnicmp(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsnicmp alias _mbsnbicmp(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsnicmp alias _mbsnbicmp(pointer p,pointer p, size_t i),int
declare cdecl import, _tcscoll alias _mbscoll(pointer p,pointer p),int
declare cdecl import, _ftcscoll alias _mbscoll(pointer p,pointer p),int
declare cdecl import, _tcsicoll alias _mbsicoll(pointer p,pointer p),int
declare cdecl import, _ftcsicoll alias _mbsicoll(pointer p,pointer p),int
declare cdecl import, _tcsnccoll alias _mbsncoll(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsnccoll alias _mbsncoll(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsncoll alias _mbsnbcoll(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsncoll alias _mbsnbcoll(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsncicoll alias _mbsnicoll(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsncicoll alias _mbsnicoll(pointer p,pointer p, size_t i),int
declare cdecl import, _tcsnicoll alias _mbsnbicoll(pointer p,pointer p, size_t i),int
declare cdecl import, _ftcsnicoll alias _mbsnbicoll(pointer p,pointer p, size_t i),int

/* "logical-character" mappings */
declare cdecl import, _tcsclen alias _mbslen(pointer p),int
declare cdecl import, _ftcsclen alias _mbslen(pointer p),int
declare cdecl import, _tcsnccat alias _mbsncat(pointer p,pointer p, size_t i),pointer
declare cdecl import, _ftcsnccat alias _mbsncat(pointer p,pointer p, size_t i),pointer
declare cdecl import, _tcsnccpy alias _mbsncpy(pointer p,pointer p, size_t i),pointer
declare cdecl import, _ftcsnccpy alias _mbsncpy(pointer p,pointer p, size_t i),pointer
declare cdecl import, _tcsncset alias _mbsnset(pointer p, UINT i, size_t i),pointer
declare cdecl import, _ftcsncset alias _mbsnset(pointer p, UINT i, size_t i),pointer

/* MBCS-specific mappings */
declare cdecl import, _tcsdec alias _mbsdec(pointer p,pointer p),pointer
declare cdecl import, _ftcsdec alias _mbsdec(pointer p,pointer p),pointer
declare cdecl import, _tcsinc alias _mbsinc(pointer p),pointer
declare cdecl import, _ftcsinc alias _mbsinc(pointer p),pointer
declare cdecl import, _tcsnbcnt alias _mbsnbcnt(pointer p, size_t i),int
declare cdecl import, _ftcsnbcnt alias _mbsnbcnt(pointer p, size_t i),int
declare cdecl import, _tcsnccnt alias _mbsnccnt(pointer p, size_t i),int
declare cdecl import, _ftcsnccnt alias _mbsnccnt(pointer p, size_t i),int
declare cdecl import, _tcsnextc alias _mbsnextc(pointer p),UINT
declare cdecl import, _ftcsnextc alias _mbsnextc(pointer p),UINT
declare cdecl import, _tcsninc alias _mbsninc(pointer p, size_t i),pointer
declare cdecl import, _ftcsninc alias _mbsninc(pointer p, size_t i),pointer
declare cdecl import, _tcsspnp alias _mbsspnp(pointer p,pointer p),pointer
declare cdecl import, _ftcsspnp alias _mbsspnp(pointer p,pointer p),pointer
declare cdecl import, _tcslwr alias _mbslwr(pointer p),pointer
declare cdecl import, _ftcslwr alias _mbslwr(pointer p),pointer
declare cdecl import, _tcsupr alias _mbsupr(pointer p),pointer
declare cdecl import, _ftcsupr alias _mbsupr(pointer p),pointer
declare cdecl import, _tclen alias _mbclen(pointer p),int
declare cdecl import, _ftclen alias _mbclen(pointer p),int
declare cdecl import, _tccpy alias _mbccpy(pointer p,pointer p)
declare cdecl import, _ftccpy alias _mbccpy(pointer p,pointer p)

'$define _tccmp(_cpuc1,_cpuc2)	_tcsnccmp(_cpuc1,_cpuc2,1)
declare cdecl import, _tccmp alias _mbsncmp(pointer p,pointer p, size_t i),int
declare cdecl import, _ftccmp alias _mbsncmp(pointer p,pointer p, size_t i),int

/* MBCS-specific mappings */

'$define _tccmp(_cp1,_cp2)	_tcsnccmp(_cp1,_cp2,1)

/* ctype functions */
declare cdecl import, _istalnum alias _ismbcalnum(UINT i),int
declare cdecl import, _istalpha alias _ismbcalpha(UINT i),int
declare cdecl import, _istdigit alias _ismbcdigit(UINT i),int
declare cdecl import, _istgraph alias _ismbcgraph(UINT i),int
declare cdecl import, _istlegal alias _ismbclegal(UINT i),int
declare cdecl import, _istlower alias _ismbclower(UINT i),int
declare cdecl import, _istprint alias _ismbcprint(UINT i),int
declare cdecl import, _istpunct alias _ismbcpunct(UINT i),int
declare cdecl import, _istspace alias _ismbcspace(UINT i),int
declare cdecl import, _istupper alias _ismbcupper(UINT i),int
declare cdecl import, _totupper alias _mbctoupper(UINT i),UINT
declare cdecl import, _totlower alias _mbctolower(UINT i),UINT
declare cdecl import, _istlead alias _ismbblead(UINT i),int
declare cdecl import, _istleadbyte alias isleadbyte(int i),int

$else
/* !_MBCS */

/* ++++++++++++++++++++ SBCS ++++++++++++++++++++ */

$ifndef __TCHAR_DEFINED
typedef _TCHAR	char
typedef _TSCHAR char
typedef _TUCHAR char
typedef _TXCHAR char
typedef _TINT	int
$define __TCHAR_DEFINED
$endif

$ifndef _TCHAR_DEFINED
$ifndef __STDC__
typedef	TCHAR char
$endif
$define _TCHAR_DEFINED
$endif

/* String functions */
declare cdecl import, _tcschr alias strchr(pointer q, int w),pointer
declare cdecl import, _ftcschr alias strchr(pointer q, int w),pointer
declare cdecl import, _tcscspn alias strcspn(pointer q,pointer w),int
declare cdecl import, _ftcscspn alias strcspn(pointer q,pointer w),int
declare cdecl import, _tcsncat alias strncat(pointer q,pointer w, size_t e),pointer
declare cdecl import, _ftcsncat alias strncat(pointer q,pointer w, size_t e),pointer
declare cdecl import, _tcsncpy alias strncpy(pointer q,pointer w, size_t e),pointer
declare cdecl import, _ftcsncpy alias strncpy(pointer q,pointer w, size_t e),pointer
declare cdecl import, _tcspbrk alias strpbrk(pointer q,pointer w),pointer
declare cdecl import, _ftcspbrk alias strpbrk(pointer q,pointer w),pointer
declare cdecl import, _tcsrchr alias strrchr(pointer q, int w),pointer
declare cdecl import, _ftcsrchr alias strrchr(pointer q, int w),pointer
declare cdecl import, _tcsspn alias strspn(pointer q,pointer w),int
declare cdecl import, _ftcsspn alias strspn(pointer q,pointer w),int
declare cdecl import, _tcsstr alias strstr(pointer q,pointer w),pointer
declare cdecl import, _ftcsstr alias strstr(pointer q,pointer w),pointer
declare cdecl import, _tcstok alias strtok(pointer q,pointer w),pointer
declare cdecl import, _ftcstok alias strtok(pointer q,pointer w),pointer
declare cdecl import, _tcsnset alias _strnset(pointer q, int w, size_t e),pointer
declare cdecl import, _ftcsnset alias _strnset(pointer q, int w, size_t e),pointer
declare cdecl import, _tcsrev alias _strrev(pointer q),pointer
declare cdecl import, _ftcsrev alias _strrev(pointer q),pointer
declare cdecl import, _tcsset alias _strset(pointer a, int b),pointer
declare cdecl import, _ftcsset alias _strset(pointer a, int b),pointer
declare cdecl import, _tcscmp alias strcmp(pointer a,pointer b),int
declare cdecl import, _ftcscmp alias strcmp(pointer a,pointer b),int
declare cdecl import, _tcsicmp alias _stricmp(pointer q,pointer w),int
declare cdecl import, _ftcsicmp alias _stricmp(pointer q,pointer w),int
declare cdecl import, _tcsnccmp alias strncmp(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsnccmp alias strncmp(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsncmp alias strncmp(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsncmp alias strncmp(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsncicmp alias _strnicmp(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsncicmp alias _strnicmp(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsnicmp alias _strnicmp(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsnicmp alias _strnicmp(pointer q,pointer w, size_t e),int
declare cdecl import, _tcscoll alias strcoll(pointer q,pointer w),int
declare cdecl import, _ftcscoll alias strcoll(pointer q,pointer w),int
declare cdecl import, _tcsicoll alias _stricoll(pointer q,pointer w),int
declare cdecl import, _ftcsicoll alias _stricoll(pointer q,pointer w),int
declare cdecl import, _tcsnccoll alias _strncoll(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsnccoll alias _strncoll(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsncoll alias _strncoll(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsncoll alias _strncoll(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsncicoll alias _strnicoll(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsncicoll alias _strnicoll(pointer q,pointer w, size_t e),int
declare cdecl import, _tcsnicoll alias _strnicoll(pointer q,pointer w, size_t e),int
declare cdecl import, _ftcsnicoll alias _strnicoll(pointer q,pointer w, size_t e),int

/* "logical-character" mappings */
declare cdecl import, _tcsclen alias strlen(pointer a),int
declare cdecl import, _ftcsclen alias strlen(pointer a),int
declare cdecl import, _tcsnccat alias strncat(pointer q,pointer w, size_t e),pointer
declare cdecl import, _ftcsnccat alias strncat(pointer q,pointer w, size_t e),pointer
declare cdecl import, _tcsnccpy alias strncpy(pointer q,pointer w, size_t e),pointer
declare cdecl import, _ftcsnccpy alias strncpy(pointer q,pointer w, size_t e),pointer
declare cdecl import, _tcsncset alias _strnset(pointer q, int w, size_t e),pointer
declare cdecl import, _ftcsncset alias _strnset(pointer q, int w, size_t e),pointer

/* MBCS-specific functions */
declare cdecl import, _tcsdec alias _strdec(pointer _cpc1,pointer _cpc2),pointer
declare cdecl import, _ftcsdec alias _strdec(pointer _cpc1,pointer _cpc2),pointer
declare cdecl import, _tcsinc alias _strinc(pointer current, int locale),pointer
declare cdecl import, _ftcsinc alias _strinc(pointer current, int locale),pointer
declare cdecl import, _tcsnbcnt alias _strncnt(pointer str,size_t count),size_t
declare cdecl import, _ftcsnbcnt alias _strncnt(pointer str,size_t count),size_t
declare cdecl import, _tcsnccnt alias _strncnt(pointer str,size_t count),size_t
declare cdecl import, _ftcsnccnt alias _strncnt(pointer str,size_t count),size_t
declare cdecl import, _tcsnextc alias _strnextc(pointer str),UINT
declare cdecl import, _ftcsnextc alias _strnextc(pointer str),UINT
declare cdecl import, _tcsninc alias _strninc(pointer str,size_t count),pointer
declare cdecl import, _ftcsninc alias _strninc(pointer str,size_t count),pointer
declare cdecl import, _tcsspnp alias _strspnp(pointer str,pointer charset),pointer
declare cdecl import, _ftcsspnp alias _strspnp(pointer str,pointer charset),pointer
declare cdecl import, _tcslwr alias _strlwr(pointer q),pointer
declare cdecl import, _ftcslwr alias _strlwr(pointer q),pointer
declare cdecl import, _tcsupr alias _strupr(pointer q),pointer
declare cdecl import, _ftcsupr alias _strupr(pointer q),pointer
'declare cdecl import, _tcsxfrm alias strxfrm(pointer q,pointer w, size_t e),int
/*
$define _istlead(_c)	(0)
$define _istleadbyte(_c)	(0)
*/

/*
# if	(__STDC__ || defined(_NO_INLINING))&& !defined(_M_M68K)
$define _tclen(_pc)(1)
$define _tccpy(_pc1,_cpc2)(*(_pc1)=*(_cpc2))
$define _tccmp(_cpc1,_cpc2)(((char)*(_cpc1))-((char)*(_cpc2)))
# else
__inline size_t cdecl _tclen(pointer _cpc){ return(_cpc,1); }
__inline void cdecl _tccpy(pointer _pc1,pointer _cpc2){* _pc1 =* _cpc2; }
__inline int cdecl _tccmp(pointer _cpc1,pointer _cpc2){ return(int i)(((char)*_cpc1)-((char)*_cpc2)); }
# endif
*/

/* ctype-functions */
declare cdecl import, _istalnum alias isalnum(int i),int
declare cdecl import, _istalpha alias isalpha(int i),int
declare cdecl import, _istdigit alias isdigit(int i),int
declare cdecl import, _istgraph alias isgraph(int i),int
declare cdecl import, _istlower alias islower(int i),int
declare cdecl import, _istprint alias isprint(int i),int
declare cdecl import, _istpunct alias ispunct(int i),int
declare cdecl import, _istspace alias isspace(int i),int
declare cdecl import, _istupper alias isupper(int i),int
declare cdecl import, _totupper alias toupper(int i),int
declare cdecl import, _totlower alias tolower(int i),int

'$define _istlegal(_c)	(1)

/* the following is optional if functional versions are available */

/*
# if	(__STDC__ || defined(_NO_INLINING))&& !defined(_M_M68K)
$define _strdec(_cpc1, _cpc2)((_cpc1)>=(_cpc2)? NULL :(_cpc2)-1)
$define _strinc(_pc)	((_pc)+1)
$define _strnextc(_cpc)((UINT)*(_cpc))
$define _strninc(_pc, _sz)(((_pc)+(_sz)))
$define _strncnt(_cpc, _sz)((strlen(_cpc)>_sz)? _sz : strlen(_cpc))
$define _strspnp(_cpc1, _cpc2)((*((_cpc1)+strspn(_cpc1,_cpc2)))?((_cpc1)+strspn(_cpc1,_cpc2)): NULL)
# else
__inline pointer	cdecl _strdec(pointer _cpc1,pointer _cpc2){ return(pointer p)((_cpc1)>=(_cpc2)? NULL :(_cpc2-1)); }
__inline pointer	cdecl _strinc(pointer _pc){ return(pointer p)(_pc+1); }
__inline UINT cdecl _strnextc(pointer _cpc){ return(UINT)*_cpc; }
__inline pointer	cdecl _strninc(pointer _pc, size_t _sz){ return(pointer p)(_pc+_sz); }
__inline size_t cdecl _strncnt(pointer _cpc, size_t _sz){ size_t len; len = strlen(_cpc); return(len>_sz)? _sz : len; }
__inline pointer	cdecl _strspnp(pointer _cpc1,pointer _cpc2){ return(*(_cpc1 += strspn(_cpc1,_cpc2))!='\0')?(pointerp)_cpc1 : NULL; }
# endif
*/

$endif
/* _MBCS */

$endif
/* UNICODE */

/* Generic text macros to be used with string literals and character constants.
	Will also allow symbolic constants that resolve to same. */

'$define _T(x)	__T(x)
'$define _TEXT(x)	__T(x)

$endif
/* _INC_TCHAR */
