/***
*wchar.h - declarations for wide character functions
*
*	Copyright(c)1992-1997, Microsoft Corporation. All rights reserved.
*
*Purpose:
*	This file contains the types, macros and function declarations for
*	all wide character-related functions.	They may also be declared in
*	individual header files on a functional basis.
*	[ISO]
*
*	Note: keep in sync with ctype.h, stdio.h, stdlib.h, string.h, time.h.
*
*	[Public]
*
****/

$ifndef _MAC

$ifndef __wchar_inc__
$define __wchar_inc__
$use "_crtdll.lib"

typedef short sword
'typedef byte schar
'$ifdef __CASESENSITIVE__
'typedef BYTE char
'$endif

$ifndef _SIZE_T_DEFINED
typedef size_t UINT
$define _SIZE_T_DEFINED
$endif

$ifndef _TIME_T_DEFINED
typedef time_t int
$define _TIME_T_DEFINED
$endif

$ifndef _WCHAR_T_DEFINED
typedef wchar_t word
$define _WCHAR_T_DEFINED
$endif

$define WCHAR_MIN	0
$define WCHAR_MAX	-1

$ifndef _WCTYPE_T_DEFINED
typedef wint_t wchar_t
typedef wctype_t wchar_t
$define _WCTYPE_T_DEFINED
$endif

$ifndef _VA_LIST_DEFINED
typedef va_list pointer
$define _VA_LIST_DEFINED
$endif

$ifndef WEOF
$define WEOF(0xFFFF)
$endif

$ifndef _FILE_DEFINED
type _iobuf
	pointer _ptr
	int	_cnt
	pointer _base
	int	_flag
	int	_file
	int	_charbuf
	int	_bufsiz
	pointer _tmpfname
endtype
type _FILE
	pointer _ptr
	int	_cnt
	pointer _base
	int	_flag
	int	_file
	int	_charbuf
	int	_bufsiz
	pointer _tmpfname
endtype
$define _FILE_DEFINED
$endif

/* Declare _iob[] array */

$ifndef _STDIO_DEFINED
'_CRTIMP extern _FILE _iob[]
$endif
/* _STDIO_DEFINED */

$ifndef _FSIZE_T_DEFINED
typedef _fsize_t UINT /* Could be 64 bits for Win32 */
$define _FSIZE_T_DEFINED
$endif

$ifndef _WFINDDATA_T_DEFINED

type _wfinddata_t
	UINT attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	_fsize_t size
	iwstring	name[260]
endtype

$ifndef _MAC
type _wfinddatai64_t
	UINT attrib
	time_t	time_create	/* -1 for FAT file systems */
	time_t	time_access	/* -1 for FAT file systems */
	time_t	time_write
	int64	size
	iwstring	name[260]
endtype
$endif

$define _WFINDDATA_T_DEFINED
$endif

$ifndef _CTYPE_DISABLE_MACROS
'_CRTIMP extern USHORT _ctype[]
'_CRTIMP extern pointer _pctype
$ifndef _MAC
'_CRTIMP extern wctype_t* _pwctype
$endif
/* ndef _MAC */
$endif
/* _CTYPE_DISABLE_MACROS */

/* set bit masks for the possible character types */

$define _UPPER	0x1	/* upper case letter */
$define _LOWER	0x2	/* lower case letter */
$define _DIGIT	0x4	/* digit[0-9] */
$define _SPACE	0x8	/* tab, carriage return, newline, */
		/* vertical tab or form feed */
$define _PUNCT	0x10	/* punctuation character */
$define _CONTROL	0x20	/* control character */
$define _BLANK	0x40	/* space char */
$define _HEX	0x80	/* hexadecimal digit */

$define _LEADBYTE	0x8000	/* multibyte leadbyte */
$define _ALPHA	(0x0100|_UPPER|_LOWER)	/* alphabetic character */

/* Function prototypes */

$ifndef _WCTYPE_DEFINED

/* Character classification function prototypes */
/* also declared in ctype.h */

declare cdecl import, iswalpha(wint_t w),int
declare cdecl import, iswupper(wint_t w),int
declare cdecl import, iswlower(wint_t w),int
declare cdecl import, iswdigit(wint_t w),int
declare cdecl import, iswxdigit(wint_t w),int
declare cdecl import, iswspace(wint_t w),int
declare cdecl import, iswpunct(wint_t w),int
declare cdecl import, iswalnum(wint_t w),int
declare cdecl import, iswprint(wint_t w),int
declare cdecl import, iswgraph(wint_t w),int
declare cdecl import, iswcntrl(wint_t w),int
declare cdecl import, iswascii(wint_t w),int
declare cdecl import, isleadbyte(int i),int

declare cdecl import, towupper(wchar_t w),wchar_t
declare cdecl import, towlower(wchar_t w),wchar_t

declare cdecl import, iswctype(wint_t w, wctype_t t),int

/* --------- The following functions are OBSOLETE --------- */
declare cdecl import, is_wctype(wint_t w, wctype_t t),int
/*	--------- The preceding functions are OBSOLETE --------- */

$define _WCTYPE_DEFINED
$endif

$ifndef _WDIRECT_DEFINED

/* also declared in direct.h */

declare cdecl import, _wchdir(pointer p),int
declare cdecl import, _wgetcwd(pointer p, int i),pointer
declare cdecl import, _wgetdcwd(int i, pointer p, int i),pointer
declare cdecl import, _wmkdir(pointer p),int
declare cdecl import, _wrmdir(pointer p),int

$define _WDIRECT_DEFINED
$endif

$ifndef _WIO_DEFINED

/* also declared in io.h */

declare cdecl import, _waccess(pointer p, int i),int
declare cdecl import, _wchmod(pointer p, int i),int
declare cdecl import, _wcreat(pointer p, int i),int
declare cdecl import, _wfindfirst(pointer p, pointer p),int
declare cdecl import, _wfindnext(long l, pointer p),int
declare cdecl import, _wunlink(pointer p),int
declare cdecl import, _wrename(pointer p, pointer p),int
declare cdecl import, _wopen(pointer p, int i, ...),int
declare cdecl import, _wsopen(pointer p, int i, int i, ...),int
declare cdecl import, _wmktemp(pointer p),pointer

declare cdecl import, _wfindfirsti64(pointer p, pointer p),int
declare cdecl import, _wfindnexti64(long l, pointer p),int

$define _WIO_DEFINED
$endif

$ifndef _WLOCALE_DEFINED

/* wide function prototypes, also declared in wchar.h	*/

declare cdecl import, _wsetlocale(int i, pointer p),pointer

$define _WLOCALE_DEFINED
$endif

$ifndef _WPROCESS_DEFINED

/* also declared in process.inc */

declare cdecl import, _wexecl(pointer p, pointer p, ...),int
declare cdecl import, _wexecle(pointer p, pointer p, ...),int
declare cdecl import, _wexeclp(pointer p, pointer p, ...),int
declare cdecl import, _wexeclpe(pointer p, pointer p, ...),int
declare cdecl import, _wexecv(pointer p, pointer p),int
declare cdecl import, _wexecve(pointer p, pointer p, pointer p),int
declare cdecl import, _wexecvp(pointer p, pointer p),int
declare cdecl import, _wexecvpe(pointer p, pointer p, pointer p),int
declare cdecl import, _wspawnl(int i, pointer p, pointer p, ...),int
declare cdecl import, _wspawnle(int i, pointer p, pointer p, ...),int
declare cdecl import, _wspawnlp(int i, pointer p, pointer p, ...),int
declare cdecl import, _wspawnlpe(int i, pointer p, pointer p, ...),int
declare cdecl import, _wspawnv(int i, pointer p, pointer p),int
declare cdecl import, _wspawnve(int i, pointer p, pointer p, pointer p),int
declare cdecl import, _wspawnvp(int i, pointer p, pointer p),int
declare cdecl import, _wspawnvpe(int i, pointer p, pointer p, pointer p),int
$ifndef _WSTDLIB_DEFINED
declare cdecl import, _wsystem(pointer p),int
$endif

$define _WPROCESS_DEFINED
$endif

$ifndef _WCTYPE_INLINE_DEFINED
'# ifndef __cplusplus
/*
$define iswalpha(_c)	(iswctype(_c,_ALPHA))
$define iswupper(_c)	(iswctype(_c,_UPPER))
$define iswlower(_c)	(iswctype(_c,_LOWER))
$define iswdigit(_c)	(iswctype(_c,_DIGIT))
$define iswxdigit(_c)	(iswctype(_c,_HEX))
$define iswspace(_c)	(iswctype(_c,_SPACE))
$define iswpunct(_c)	(iswctype(_c,_PUNCT))
$define iswalnum(_c)	(iswctype(_c,_ALPHA|_DIGIT))
$define iswprint(_c)	(iswctype(_c,_BLANK|_PUNCT|_ALPHA|_DIGIT))
$define iswgraph(_c)	(iswctype(_c,_PUNCT|_ALPHA|_DIGIT))
$define iswcntrl(_c)	(iswctype(_c,_CONTROL))
$define iswascii(_c)	((unsigned)(_c)< 0x80)

$ifndef _CTYPE_DISABLE_MACROS
$define isleadbyte(_c)	(_pctype[(UCHAR)(_c)] & _LEADBYTE)
$endif
*/
/* _CTYPE_DISABLE_MACROS */

'$else
	/* __cplusplus */
/*
inline int cdecl iswalpha(wint_t _C){return(iswctype(_C,_ALPHA)); }
inline int cdecl iswupper(wint_t _C){return(iswctype(_C,_UPPER)); }
inline int cdecl iswlower(wint_t _C){return(iswctype(_C,_LOWER)); }
inline int cdecl iswdigit(wint_t _C){return(iswctype(_C,_DIGIT)); }
inline int cdecl iswxdigit(wint_t _C){return(iswctype(_C,_HEX)); }
inline int cdecl iswspace(wint_t _C){return(iswctype(_C,_SPACE)); }
inline int cdecl iswpunct(wint_t _C){return(iswctype(_C,_PUNCT)); }
inline int cdecl iswalnum(wint_t _C){return(iswctype(_C,_ALPHA|_DIGIT)); }
inline int cdecl iswprint(wint_t _C)
		{return(iswctype(_C,_BLANK|_PUNCT|_ALPHA|_DIGIT)); }
inline int cdecl iswgraph(wint_t _C)
		{return(iswctype(_C,_PUNCT|_ALPHA|_DIGIT)); }
inline int cdecl iswcntrl(wint_t _C){return(iswctype(_C,_CONTROL)); }
inline int cdecl iswascii(wint_t _C){return((unsigned)(_C)< 0x80); }

$ifndef _CTYPE_DISABLE_MACROS
inline int cdecl isleadbyte(int _C)
		{return(_pctype[(UCHAR)(_C)] & _LEADBYTE); }
$endif
*/
/* _CTYPE_DISABLE_MACROS */
'# endif
/* __cplusplus */
$define _WCTYPE_INLINE_DEFINED
$endif
/* _WCTYPE_INLINE_DEFINED */

$ifndef _POSIX_

/* define structure for returning status information */

$ifndef _INO_T_DEFINED
typedef _ino_t word	/* i-node number(not used on DOS)*/
'# if	!__STDC__
/* Non-ANSI name for compatibility */
typedef ino_t word
'# endif
$define _INO_T_DEFINED
$endif

$ifndef _DEV_T_DEFINED
typedef _dev_t UINT	/* device code */
'# if	!__STDC__
/* Non-ANSI name for compatibility */
typedef dev_t UINT
'# endif
$define _DEV_T_DEFINED
$endif

$ifndef _OFF_T_DEFINED
typedef _off_t int	/* file offset value */
'# if	!__STDC__
/* Non-ANSI name for compatibility */
typedef off_t int
'# endif
$define _OFF_T_DEFINED
$endif

$ifndef _STAT_DEFINED

type _stat
	_dev_t st_dev
	_ino_t st_ino
	word st_mode
	short st_nlink
	short st_uid
	short st_gid
	_dev_t st_rdev
	_off_t st_size
	time_t st_atime
	time_t st_mtime
	time_t st_ctime
endtype

'# if	!__STDC__
/* Non-ANSI names for compatibility */
type stat
	_dev_t st_dev
	_ino_t st_ino
	word st_mode
	short st_nlink
	short st_uid
	short st_gid
	_dev_t st_rdev
	_off_t st_size
	time_t st_atime
	time_t st_mtime
	time_t st_ctime
endtype
'# endif
/* __STDC__ */

type _stati64
	_dev_t st_dev
	_ino_t st_ino
	word st_mode
	short st_nlink
	short st_uid
	short st_gid
	_dev_t st_rdev
	int64 st_size
	time_t st_atime
	time_t st_mtime
	time_t st_ctime
endtype

$define _STAT_DEFINED
$endif

$ifndef _WSTAT_DEFINED

/* also declared in stat.h */

declare cdecl import, _wstat(pointer p, pointer p),int
declare cdecl import, _wstati64(pointer p, pointer p),int

$define _WSTAT_DEFINED
$endif

$endif
/* !_POSIX_ */

$ifndef _WSTDIO_DEFINED

/* also declared in stdio.h */

$ifdef	_POSIX_
declare cdecl import, _wfsopen(pointer p, pointer p),pointer
$else
declare cdecl import, _wfsopen(pointer p, pointer p, int i),pointer
$endif

declare cdecl import, fgetwc(pointer p),wint_t
declare cdecl import, _fgetwchar(),wint_t
declare cdecl import, fputwc(wint_t w,pointer p),wint_t
declare cdecl import, _fputwchar(wint_t w),wint_t
declare cdecl import, getwc(pointer p),wint_t
declare cdecl import, getwchar(),wint_t
declare cdecl import, putwc(wint_t w,pointer p),wint_t
declare cdecl import, putwchar(wint_t w),wint_t
declare cdecl import, ungetwc(wint_t w,pointer p),wint_t
declare cdecl import, fgetws(pointer p, int i,pointer p),pointer
declare cdecl import, fputws(pointer p,pointer p),int
declare cdecl import, _getws(pointer p),pointer
declare cdecl import, _putws(pointer p),int
declare cdecl import, fwprintf(pointer p, pointer p, ...),int
declare cdecl import, wprintf(/*pointer p,*/ ...),int
declare cdecl import, _snwprintf(pointer p, size_t i, pointer p, ...),int
declare cdecl import, swprintf(pointer p, pointer p, ...),int
declare cdecl import, vfwprintf(pointer p, pointer p, va_list p),int
declare cdecl import, vwprintf(pointer p, va_list p),int
declare cdecl import, _vsnwprintf(pointer p, size_t i, pointer p, va_list p),int
declare cdecl import, vswprintf(pointer p, pointer p, va_list p),int
declare cdecl import, fwscanf(pointer p, pointer p, ...),int
declare cdecl import, swscanf(pointer p, pointer p, ...),int
declare cdecl import, wscanf(pointer p, ...),int
declare cdecl import, _wtof(pointer p),double

$ifndef __cplusplus
'$define getwchar()	fgetwc(stdin)
'$define putwchar(_c)	fputwc((_c),stdout)
$else	/* __cplusplus */
'inline wint_t cdecl getwchar()	{return(fgetwc(&_iob[0])); }	' stdin
'inline wint_t cdecl putwchar(wchar_t _C)	{return(fputwc(_C, &_iob[1])); }	' stdout
$endif
/* __cplusplus */

'$define getwc(_stm)	fgetwc(_stm)
'$define putwc(_c,_stm)	fputwc(_c,_stm)

declare cdecl import, _wfdopen(int i, pointer p),pointer
declare cdecl import, _wfopen(pointer p, pointer p),pointer
declare cdecl import, _wfreopen(pointer p, pointer p,pointer p),pointer
$ifndef _WSTDLIBP_DEFINED
declare cdecl import, _wperror(pointer p)
$endif
declare cdecl import, _wpopen(pointer p, pointer p),pointer
declare cdecl import, _wremove(pointer p),int
declare cdecl import, _wtempnam(pointer p, pointer p),pointer
declare cdecl import, _wtmpnam(pointer p),pointer

$define _WSTDIO_DEFINED
$endif

$ifndef _WSTDLIB_DEFINED

/* also declared in stdlib.h */

declare cdecl import, _itow(int i, pointer p, int i),pointer
declare cdecl import, _ltow(int l, pointer p, int i),pointer
declare cdecl import, _ultow(UINT i, pointer p, int i),pointer
declare cdecl import, wcstod(pointer p, pointer p),double
declare cdecl import, wcstol(pointer p, pointer p, int i),int
declare cdecl import, wcstoul(pointer p, pointer p, int i),UINT
declare cdecl import, _wgetenv(pointer p),pointer
'clare cdecl import, _wsystem(pointer p),int
declare cdecl import, _wtoi(pointer p),int
declare cdecl import, _wtol(pointer p),int

declare cdecl import, _i64tow(int64 i, pointer p, int i),pointer
declare cdecl import, _ui64tow(uint64 i, pointer p, int i),pointer
declare cdecl import, _wtoi64(pointer p),int64

$define _WSTDLIB_DEFINED
$endif

$ifndef _POSIX_

$ifndef _WSTDLIBP_DEFINED

/* also declared in stdlib.h	*/

declare cdecl import, _wfullpath(pointer p, pointer p, size_t i),pointer
declare cdecl import, _wmakepath(pointer p, pointer p, pointer p, pointer p, pointer p)
'clare cdecl import, _wperror(pointer p)
declare cdecl import, _wputenv(pointer p),int
declare cdecl import, _wsearchenv(pointer p, pointer p, pointer p)
declare cdecl import, _wsplitpath(pointer p, pointer p, pointer p, pointer p, pointer p)

$define _WSTDLIBP_DEFINED
$endif

$endif
/* _POSIX_ */

$ifndef _WSTRING_DEFINED

/* also declared in string.h */

$ifdef	__cplusplus
		'$define _WConst_return	const
$else
		'$define _WConst_return
$endif

$ifndef _WSTDLIBP_DEFINED
declare cdecl import, wcscat(pointer p, pointer p),pointer
declare cdecl import, wcschr(pointer p, wchar_t w),pointer
declare cdecl import, wcscmp(pointer p, pointer p),int
declare cdecl import, wcscpy(pointer p, pointer p),pointer
declare cdecl import, wcscspn(pointer p, pointer p),size_t
declare cdecl import, wcslen(pointer p),size_t
declare cdecl import, wcsncat(pointer p, pointer p, size_t i),pointer
declare cdecl import, wcsncmp(pointer p, pointer p, size_t i),int
declare cdecl import, wcsncpy(pointer p, pointer p, size_t i),pointer
declare cdecl import, wcspbrk(pointer p, pointer p),pointer
declare cdecl import, wcsrchr(pointer p, wchar_t w),pointer
declare cdecl import, wcsspn(pointer p, pointer p),size_t
declare cdecl import, wcsstr(pointer p, pointer p),pointer
declare cdecl import, wcstok(pointer p, pointer p),pointer
declare cdecl import, _wcsdup(pointer p),pointer
declare cdecl import, _wcsicmp(pointer p, pointer p),int
declare cdecl import, _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, _wcsrev(pointer p),pointer
declare cdecl import, _wcsset(pointer p, wchar_t w),pointer
declare cdecl import, _wcslwr(pointer p),pointer
declare cdecl import, _wcsupr(pointer p),pointer
declare cdecl import, wcsxfrm(pointer p, pointer p, size_t i),size_t
declare cdecl import, wcscoll(pointer p, pointer p),int
declare cdecl import, _wcsicoll(pointer p, pointer p),int
declare cdecl import, _wcsncoll(pointer p, pointer p, size_t i),int
declare cdecl import, _wcsnicoll(pointer p, pointer p, size_t i),int
$endif

/* Old names */
'$define wcswcs wcsstr

$ifndef __STDC__

/* prototypes for oldnames.lib functions */
$ifndef _WSTDLIBP_DEFINEDv
declare cdecl import, wcsdup alias _wcsdup(pointer p),pointer
declare cdecl import, wcsicmp alias _wcsicmp(pointer p, pointer p),int
declare cdecl import, wcsnicmp alias _wcsnicmp(pointer p, pointer p, size_t i),int
declare cdecl import, wcsnset alias _wcsnset(pointer p, wchar_t w, size_t i),pointer
declare cdecl import, wcsrev alias _wcsrev(pointer p),pointer
declare cdecl import, wcsset alias _wcsset(pointer p, wchar_t w),pointer
declare cdecl import, wcslwr alias _wcslwr(pointer p),pointer
declare cdecl import, wcsupr alias _wcsupr(pointer p),pointer
declare cdecl import, wcsicoll alias _wcsicoll(pointer p, pointer p),int
$endif
$endif
/* !__STDC__ */

$define _WSTRING_DEFINED
$endif

$ifndef _TM_DEFINED
type tm
	int tm_sec	/* seconds after the minute - [0,59] */
	int tm_min	/* minutes after the hour - [0,59] */
	int tm_hour	/* hours since midnight - [0,23] */
	int tm_mday	/* day of the month - [1,31] */
	int tm_mon	/* months since January - [0,11] */
	int tm_year	/* years since 1900 */
	int tm_wday	/* days since Sunday - [0,6] */
	int tm_yday	/* days since January 1 - [0,365] */
	int tm_isdst	/* daylight savings time flag */
endtype
$define _TM_DEFINED
$endif

$ifndef _WTIME_DEFINED

/* also declared in time.h */

declare cdecl import, _wasctime(pointer p),pointer
declare cdecl import, _wctime(pointer p),pointer
declare cdecl import, wcsftime(pointer p, size_t i, pointer p,pointer p),size_t
declare cdecl import, _wstrdate(pointer p),pointer
declare cdecl import, _wstrtime(pointer p),pointer

$define _WTIME_DEFINED
$endif

typedef mbstate_t int
typedef _Wint_t wchar_t

declare cdecl import, btowc(int i),wint_t
declare cdecl import, mbrlen(pointer p, size_t i, pointer p),size_t
declare cdecl import, mbrtowc(pointer p,pointer p, size_t i, pointer p),size_t
declare cdecl import, mbsrtowcs(pointer p,pointer p, size_t i, pointer p),size_t

declare cdecl import, wcrtomb(pointer p, wchar_t w, pointer p),size_t
declare cdecl import, wcsrtombs(pointer p, pointer p, size_t i, pointer p),size_t
declare cdecl import, wctob(wint_t w),int

declare extern wmemset(pointer dest,int c,size_t count)

$endif
/* _INC_WCHAR */

$else
	/* ndef _MAC */

/*
*	These definitions are needed on the _MAC as well as _WIN32
 */

typedef mbstate_t int
typedef _Wint_t wchar_t

$endif
/* _MAC */
