/************************************************************************
*	*
*	winbase.h -- This module defines the 32-Bit Windows Base APIs	*
*	*
*	Copyright(c)Microsoft Corp. All rights reserved.	*
*	*
************************************************************************/
$ifndef __winbase_inc__
$define __winbase_inc__
$define _WINBASE_

' to fix: struct COMSTAT,DCB

$ifdef _MAC
$include "macwin32.inc"
$endif

/*
* Compatibility macros
 */

'$define DefineHandleTable(w)	((w),TRUE)
'$define LimitEmsPages(dw)
'$define SetSwapAreaSize(w)	(w)
'$define LockSegment(w)	GlobalFix((HANDLE)(w))
'$define UnlockSegment(w)	GlobalUnfix((HANDLE)(w))
declare import,GetCurrentTime alias GetTickCount(),int
'$define Yield()

$define INVALID_HANDLE_VALUE(-1)
$define INVALID_FILE_SIZE(0xFFFFFFFF)
$define INVALID_SET_FILE_POINTER(-1)
$define INVALID_FILE_ATTRIBUTES(-1)

$define FILE_BEGIN	0
$define FILE_CURRENT	1
$define FILE_END	2

$define TIME_ZONE_ID_INVALID(0xFFFFFFFF)

$define WAIT_FAILED(0xFFFFFFFF)
$define WAIT_OBJECT_0	((0)+ 0)

$define WAIT_ABANDONED	((0x80)+ 0)
$define WAIT_ABANDONED_0	((0x80)+ 0)

$define WAIT_IO_COMPLETION	0xC0
$define STILL_ACTIVE	0x103
$define EXCEPTION_ACCESS_VIOLATION	0xC0000005
$define EXCEPTION_DATATYPE_MISALIGNMENT	0x80000002
$define EXCEPTION_BREAKPOINT	0x80000003
$define EXCEPTION_SINGLE_STEP	0x80000004
$define EXCEPTION_ARRAY_BOUNDS_EXCEEDED	0xC000008C
$define EXCEPTION_FLT_DENORMAL_OPERAND	0xC000008D
$define EXCEPTION_FLT_DIVIDE_BY_ZERO	0xC000008E
$define EXCEPTION_FLT_INEXACT_RESULT	0xC000008F
$define EXCEPTION_FLT_INVALID_OPERATION	0xC0000090
$define EXCEPTION_FLT_OVERFLOW	0xC0000091
$define EXCEPTION_FLT_STACK_CHECK	0xC0000092
$define EXCEPTION_FLT_UNDERFLOW	0xC0000093
$define EXCEPTION_INT_DIVIDE_BY_ZERO	0xC0000094
$define EXCEPTION_INT_OVERFLOW	0xC0000095
$define EXCEPTION_PRIV_INSTRUCTION	0xC0000096
$define EXCEPTION_IN_PAGE_ERROR	0xC0000006
$define EXCEPTION_ILLEGAL_INSTRUCTION	0xC000001D
$define EXCEPTION_NONCONTINUABLE_EXCEPTION	0xC0000025
$define EXCEPTION_STACK_OVERFLOW	0xC00000FD
$define EXCEPTION_INVALID_DISPOSITION	0xC0000026
$define EXCEPTION_GUARD_PAGE	0x80000001
$define EXCEPTION_INVALID_HANDLE	0xC0000008
$define EXCEPTION_POSSIBLE_DEADLOCK	0xC0000194
$define CONTROL_C_EXIT	0xC000013A
declare import,RtlMoveMemory(PVOID Destination,pointer Source,SIZE_T Length)
declare import,MoveMemory alias RtlMoveMemory(PVOID Destination,pointer Source,SIZE_T Length)
declare import,CopyMemory alias RtlMoveMemory(PVOID Destination,pointer Source,SIZE_T Length)
'$define FillMemory RtlFillMemory
declare import,RtlZeroMemory(PVOID Destination,SIZE_T Length)
declare import,ZeroMemory alias RtlZeroMemory(PVOID Destination,SIZE_T Length)
'$define SecureZeroMemory RtlSecureZeroMemory
declare extern RtlFillMemory(PVOID Destination, SIZE_T Length, BYTE Fill)
declare extern FillMemory alias RtlFillMemory(PVOID Destination, SIZE_T Length, BYTE Fill)
' File creation flags must start at the high end since they
' are combined with the attributes

$define FILE_FLAG_WRITE_THROUGH	0x80000000
$define FILE_FLAG_OVERLAPPED	0x40000000
$define FILE_FLAG_NO_BUFFERING	0x20000000
$define FILE_FLAG_RANDOM_ACCESS	0x10000000
$define FILE_FLAG_SEQUENTIAL_SCAN	0x08000000
$define FILE_FLAG_DELETE_ON_CLOSE	0x04000000
$define FILE_FLAG_BACKUP_SEMANTICS	0x02000000
$define FILE_FLAG_POSIX_SEMANTICS	0x01000000
$define FILE_FLAG_OPEN_REPARSE_POINT	0x00200000
$define FILE_FLAG_OPEN_NO_RECALL	0x00100000
$define FILE_FLAG_FIRST_PIPE_INSTANCE	0x00080000

$define CREATE_NEW	1
$define CREATE_ALWAYS	2
$define OPEN_EXISTING	3
$define OPEN_ALWAYS	4
$define TRUNCATE_EXISTING	5

' Define possible return codes from the CopyFileEx callback routine

$define PROGRESS_CONTINUE	0
$define PROGRESS_CANCEL	1
$define PROGRESS_STOP	2
$define PROGRESS_QUIET	3

' Define CopyFileEx callback routine state change values

$define CALLBACK_CHUNK_FINISHED	0x00000000
$define CALLBACK_STREAM_SWITCH	0x00000001

' Define CopyFileEx option flags

$define COPY_FILE_FAIL_IF_EXISTS	0x00000001
$define COPY_FILE_RESTARTABLE	0x00000002
$define COPY_FILE_OPEN_SOURCE_FOR_WRITE	0x00000004
$define COPY_FILE_ALLOW_DECRYPTED_DESTINATION 0x00000008

' Define ReplaceFile option flags

$define REPLACEFILE_WRITE_THROUGH	0x00000001
$define REPLACEFILE_IGNORE_MERGE_ERRORS 0x00000002

' Define the NamedPipe definitions

' Define the dwOpenMode values for CreateNamedPipe

$define PIPE_ACCESS_INBOUND	0x00000001
$define PIPE_ACCESS_OUTBOUND	0x00000002
$define PIPE_ACCESS_DUPLEX	0x00000003

' Define the Named Pipe End flags for GetNamedPipeInfo

$define PIPE_CLIENT_END	0x00000000
$define PIPE_SERVER_END	0x00000001

' Define the dwPipeMode values for CreateNamedPipe

$define PIPE_WAIT	0x00000000
$define PIPE_NOWAIT	0x00000001
$define PIPE_READMODE_BYTE	0x00000000
$define PIPE_READMODE_MESSAGE	0x00000002
$define PIPE_TYPE_BYTE	0x00000000
$define PIPE_TYPE_MESSAGE	0x00000004

' Define the well known values for CreateNamedPipe nMaxInstances

$define PIPE_UNLIMITED_INSTANCES	255

' Define the Security Quality of Service bits to be passed
' into CreateFile

$define SECURITY_ANONYMOUS	(0	<< 16)
$define SECURITY_IDENTIFICATION	(1 << 16)
$define SECURITY_IMPERSONATION	(2	<< 16)
$define SECURITY_DELEGATION	(3	<< 16)

$define SECURITY_CONTEXT_TRACKING	0x00040000
$define SECURITY_EFFECTIVE_ONLY	0x00080000

$define SECURITY_SQOS_PRESENT	0x00100000
$define SECURITY_VALID_SQOS_FLAGS	0x001F0000

'	File structures

type OVERLAPPED
	ULONG_PTR Internal
	ULONG_PTR InternalHigh
'	union
		PVOID _Pointer[0]
'	struct
		DWORD Offset
		DWORD OffsetHigh
'	}

'	}

	HANDLE	hEvent
endtype

type SECURITY_ATTRIBUTES
	DWORD nLength
	LPVOID lpSecurityDescriptor
	BOOL bInheritHandle
endtype

type PROCESS_INFORMATION
	HANDLE hProcess
	HANDLE hThread
	DWORD dwProcessId
	DWORD dwThreadId
endtype

'	File System time stamps are represented with the following structure:

$ifndef _FILETIME_
$define _FILETIME_
type FILETIME
	DWORD dwLowDateTime
	DWORD dwHighDateTime
endtype
$endif

' System time is represented with the following structure:

type SYSTEMTIME
	USHORT wYear
	USHORT wMonth
	USHORT wDayOfWeek
	USHORT wDay
	USHORT wHour
	USHORT wMinute
	USHORT wSecond
	USHORT wMilliseconds
endtype

typedef PTHREAD_START_ROUTINE int
typedef LPTHREAD_START_ROUTINE int
/*typedef(*PTHREAD_START_ROUTINE)(LPVOID lpThreadParameter),DWORD;*/
'typedef PTHREAD_START_ROUTINE LPTHREAD_START_ROUTINE
typedef PFIBER_START_ROUTINE int
typedef LPFIBER_START_ROUTINE int
/*typedef VOID(*PFIBER_START_ROUTINE)(LPVOID lpFiberParameter),*/

type RTL_CRITICAL_SECTION ' hacked!
	byte x[24]
endtype

type CRITICAL_SECTION_DEBUG
	USHORT	_Type
	USHORT	CreatorBackTraceIndex
	pointer CriticalSection
	LIST_ENTRY ProcessLocksList
	DWORD EntryCount
	DWORD ContentionCount
	DWORD Spare[ 2 ]
endtype
declare import,EncodePointer(PVOID Ptr),PVOID
declare import,DecodePointer(PVOID Ptr),PVOID
declare import,EncodeSystemPointer(PVOID Ptr),PVOID
declare import,DecodeSystemPointer(PVOID Ptr),PVOID

type CRITICAL_SECTION
	byte x[24]
endtype

$define MUTEX_MODIFY_STATE 1
$define MUTEX_ALL_ACCESS 0x1F0001

' Serial provider type.

$define SP_SERIALCOMM	(0x00000001)

' Provider SubTypes

$define PST_UNSPECIFIED	(0x00000000)
$define PST_RS232	(0x00000001)
$define PST_PARALLELPORT	(0x00000002)
$define PST_RS422	(0x00000003)
$define PST_RS423	(0x00000004)
$define PST_RS449	(0x00000005)
$define PST_MODEM	(0x00000006)
$define PST_FAX	(0x00000021)
$define PST_SCANNER	(0x00000022)
$define PST_NETWORK_BRIDGE	(0x00000100)
$define PST_LAT	(0x00000101)
$define PST_TCPIP_TELNET	(0x00000102)
$define PST_X25	(0x00000103)

' Provider capabilities flags.

$define PCF_DTRDSR	(0x0001)
$define PCF_RTSCTS	(0x0002)
$define PCF_RLSD	(0x0004)
$define PCF_PARITY_CHECK(0x0008)
$define PCF_XONXOFF	(0x0010)
$define PCF_SETXCHAR	(0x0020)
$define PCF_TOTALTIMEOUTS(0x0040)
$define PCF_INTTIMEOUTS	(0x0080)
$define PCF_SPECIALCHARS(0x0100)
$define PCF_16BITMODE	(0x0200)

' Comm provider settable parameters.

$define SP_PARITY	(0x0001)
$define SP_BAUD	(0x0002)
$define SP_DATABITS	(0x0004)
$define SP_STOPBITS	(0x0008)
$define SP_HANDSHAKING	(0x0010)
$define SP_PARITY_CHECK	(0x0020)
$define SP_RLSD	(0x0040)

' Settable baud rates in the provider.

$define BAUD_075	(0x00000001)
$define BAUD_110	(0x00000002)
$define BAUD_134_5	(0x00000004)
$define BAUD_150	(0x00000008)
$define BAUD_300	(0x00000010)
$define BAUD_600	(0x00000020)
$define BAUD_1200	(0x00000040)
$define BAUD_1800	(0x00000080)
$define BAUD_2400	(0x00000100)
$define BAUD_4800	(0x00000200)
$define BAUD_7200	(0x00000400)
$define BAUD_9600	(0x00000800)
$define BAUD_14400	(0x00001000)
$define BAUD_19200	(0x00002000)
$define BAUD_38400	(0x00004000)
$define BAUD_56K	(0x00008000)
$define BAUD_128K	(0x00010000)
$define BAUD_115200	(0x00020000)
$define BAUD_57600	(0x00040000)
$define BAUD_USER	(0x10000000)

' Settable Data Bits

$define DATABITS_5	(0x0001)
$define DATABITS_6	(0x0002)
$define DATABITS_7	(0x0004)
$define DATABITS_8	(0x0008)
$define DATABITS_16	(0x0010)
$define DATABITS_16X	(0x0020)

' Settable Stop and Parity bits.

$define STOPBITS_10	(0x0001)
$define STOPBITS_15	(0x0002)
$define STOPBITS_20	(0x0004)
$define PARITY_NONE	(0x0100)
$define PARITY_ODD	(0x0200)
$define PARITY_EVEN	(0x0400)
$define PARITY_MARK	(0x0800)
$define PARITY_SPACE	(0x1000)

type COMMPROP
	USHORT wPacketLength
	USHORT wPacketVersion
	DWORD dwServiceMask
	DWORD dwReserved1
	DWORD dwMaxTxQueue
	DWORD dwMaxRxQueue
	DWORD dwMaxBaud
	DWORD dwProvSubType
	DWORD dwProvCapabilities
	DWORD dwSettableParams
	DWORD dwSettableBaud
	USHORT wSettableData
	USHORT wSettableStopParity
	DWORD dwCurrentTxQueue
	DWORD dwCurrentRxQueue
	DWORD dwProvSpec1
	DWORD dwProvSpec2
	iwstring wcProvChar[1]
endtype

' Set dwProvSpec1 to COMMPROP_INITIALIZED to indicate that wPacketLength
' is valid before a call to GetCommProperties().
$define COMMPROP_INITIALIZED(0xE73CF52E)

type COMSTAT
	DWORD fCtsHold[0]' : 1
	DWORD fDsrHold[0]' : 1
	DWORD fRlsdHold[0]' : 1
	DWORD fXoffHold[0]' : 1
	DWORD fXoffSent[0]' : 1
	DWORD fEof[0]' : 1
	DWORD fTxim[0]' : 1
	DWORD fReserved[0]' : 25
	DWORD cbInQue
	DWORD cbOutQue
endtype

' DTR Control Flow Values.
$define DTR_CONTROL_DISABLE	0x00
$define DTR_CONTROL_ENABLE	0x01
$define DTR_CONTROL_HANDSHAKE	0x02

' RTS Control Flow Values
$define RTS_CONTROL_DISABLE	0x00
$define RTS_CONTROL_ENABLE	0x01
$define RTS_CONTROL_HANDSHAKE	0x02
$define RTS_CONTROL_TOGGLE	0x03

type DCB,1
	DWORD DCBlength	/* sizeof(DCB)	*/
	DWORD BaudRate	/* Baudrate at which running	*/
	DWORD fBinary[0]': 1	/* Binary Mode(skip EOF check)	*/
	DWORD fParity[0]': 1	/* Enable parity checking	*/
	DWORD fOutxCtsFlow[0]':1; /* CTS handshaking on output	*/
	DWORD fOutxDsrFlow[0]':1; /* DSR handshaking on output	*/
	DWORD fDtrControl[0]':2;	/* DTR Flow control	*/
	DWORD fDsrSensitivity[0]':1; /* DSR Sensitivity	*/
	DWORD fTXContinueOnXoff[0]': 1; /* Continue TX when Xoff sent */
	DWORD fOutX[0]': 1	/* Enable output X-ON/X-OFF	*/
	DWORD fInX[0]': 1	/* Enable input X-ON/X-OFF	*/
	DWORD fErrorChar[0]': 1;	/* Enable Err Replacement	*/
	DWORD fNull[0]': 1	/* Enable Null stripping	*/
	DWORD fRtsControl[0]':2;	/* Rts Flow control	*/
	DWORD fAbortOnError[0]':1; /* Abort all reads and writes on Error */
	DWORD fDummy2[1]':17	/* Reserved	*/
	USHORT wReserved	/* Not currently used	*/
	USHORT XonLim	/* Transmit X-ON threshold	*/
	USHORT XoffLim	/* Transmit X-OFF threshold	*/
	UCHAR ByteSize	/* Number of bits/byte,4-8	*/
	UCHAR Parity	/* 0-4=None,Odd,Even,Mark */
	UCHAR StopBits	/* 0,1,2 = 1,1.5,2	*/
	char XonChar	/* Tx and Rx X-ON character	*/
	char XoffChar	/* Tx and Rx X-OFF character	*/
	char ErrorChar	/* Error replacement char	*/
	char EofChar	/* End of Input character	*/
	char EvtChar	/* Received Event character	*/
	USHORT wReserved1	/* Fill for now.	*/
endtype

type COMMTIMEOUTS
	DWORD ReadIntervalTimeout	/* Maximum time between read chars. */
	DWORD ReadTotalTimeoutMultiplier	/* Multiplier of characters.	*/
	DWORD ReadTotalTimeoutConstant	/* Constant in milliseconds.	*/
	DWORD WriteTotalTimeoutMultiplier	/* Multiplier of characters.	*/
	DWORD WriteTotalTimeoutConstant	/* Constant in milliseconds.	*/
endtype

type COMMCONFIG
	DWORD dwSize	/* Size of the entire struct */
	USHORT wVersion	/* version of the structure */
	USHORT wReserved	/* alignment */
	DCB dcb	/* device control block */
	DWORD dwProviderSubType	/* ordinal value for identifying
		provider-defined data structure format*/
	DWORD dwProviderOffset	/* Specifies the offset of provider specific
		data field in bytes from the start */
	DWORD dwProviderSize	/* size of the provider-specific data field */
	iwstring wcProviderData[1]	/* provider-specific data */
endtype

type SYSTEM_INFO
'	union
		DWORD dwOemId[0]	' Obsolete field...do not use
'	struct
		USHORT wProcessorArchitecture
		USHORT wReserved
'	}
'	}
	DWORD dwPageSize
	LPVOID lpMinimumApplicationAddress
	LPVOID lpMaximumApplicationAddress
	DWORD_PTR dwActiveProcessorMask
	DWORD dwNumberOfProcessors
	DWORD dwProcessorType
	DWORD dwAllocationGranularity
	USHORT wProcessorLevel
	USHORT wProcessorRevision
endtype

declare import, FreeModule alias FreeLibrary(HMODULE hLibModule),BOOL
'$define MakeProcInstance(lpProc,hInstance)(lpProc)
'$define FreeProcInstance(lpProc)(lpProc)

/* Global Memory Flags */
$define GMEM_FIXED	0x0000
$define GMEM_MOVEABLE	0x0002
$define GMEM_NOCOMPACT	0x0010
$define GMEM_NODISCARD	0x0020
$define GMEM_ZEROINIT	0x0040
$define GMEM_MODIFY	0x0080
$define GMEM_DISCARDABLE	0x0100
$define GMEM_NOT_BANKED	0x1000
$define GMEM_SHARE	0x2000
$define GMEM_DDESHARE	0x2000
$define GMEM_NOTIFY	0x4000
$define GMEM_LOWER	GMEM_NOT_BANKED
$define GMEM_VALID_FLAGS	0x7F72
$define GMEM_INVALID_HANDLE 0x8000

$define GHND	(GMEM_MOVEABLE | GMEM_ZEROINIT)
$define GPTR	(GMEM_FIXED | GMEM_ZEROINIT)

'$define GlobalLRUNewest(h)	((HANDLE)(h))
'$define GlobalLRUOldest(h)	((HANDLE)(h))
'$define GlobalDiscard(h)	GlobalReAlloc((h),0,GMEM_MOVEABLE)

/* Flags returned by GlobalFlags(in addition to GMEM_DISCARDABLE)*/
$define GMEM_DISCARDED	0x4000
$define GMEM_LOCKCOUNT	0x00FF

type MEMORYSTATUS
	DWORD dwLength
	DWORD dwMemoryLoad
	SIZE_T dwTotalPhys
	SIZE_T dwAvailPhys
	SIZE_T dwTotalPageFile
	SIZE_T dwAvailPageFile
	SIZE_T dwTotalVirtual
	SIZE_T dwAvailVirtual
endtype

/* Local Memory Flags */
$define LMEM_FIXED	0x0000
$define LMEM_MOVEABLE	0x0002
$define LMEM_NOCOMPACT	0x0010
$define LMEM_NODISCARD	0x0020
$define LMEM_ZEROINIT	0x0040
$define LMEM_MODIFY	0x0080
$define LMEM_DISCARDABLE	0x0F00
$define LMEM_VALID_FLAGS	0x0F72
$define LMEM_INVALID_HANDLE 0x8000

$define LHND	(LMEM_MOVEABLE | LMEM_ZEROINIT)
$define LPTR	(LMEM_FIXED | LMEM_ZEROINIT)

$define NONZEROLHND	(LMEM_MOVEABLE)
$define NONZEROLPTR	(LMEM_FIXED)

'$define LocalDiscard(h)	LocalReAlloc((h),0,LMEM_MOVEABLE)

/* Flags returned by LocalFlags(in addition to LMEM_DISCARDABLE)*/
$define LMEM_DISCARDED	0x4000
$define LMEM_LOCKCOUNT	0x00FF

' dwCreationFlag values

$define DEBUG_PROCESS	0x00000001
$define DEBUG_ONLY_THIS_PROCESS	0x00000002
$define CREATE_SUSPENDED	0x00000004
$define DETACHED_PROCESS	0x00000008
$define CREATE_NEW_CONSOLE	0x00000010
$define NORMAL_PRIORITY_CLASS	0x00000020
$define IDLE_PRIORITY_CLASS	0x00000040
$define HIGH_PRIORITY_CLASS	0x00000080
$define REALTIME_PRIORITY_CLASS	0x00000100
$define CREATE_NEW_PROCESS_GROUP	0x00000200
$define CREATE_UNICODE_ENVIRONMENT	0x00000400
$define CREATE_SEPARATE_WOW_VDM	0x00000800
$define CREATE_SHARED_WOW_VDM	0x00001000
$define CREATE_FORCEDOS	0x00002000
$define BELOW_NORMAL_PRIORITY_CLASS	0x00004000
$define ABOVE_NORMAL_PRIORITY_CLASS	0x00008000
$define STACK_SIZE_PARAM_IS_A_RESERVATION 0x00010000
$define CREATE_BREAKAWAY_FROM_JOB	0x01000000
$define CREATE_PRESERVE_CODE_AUTHZ_LEVEL	0x02000000
$define CREATE_DEFAULT_ERROR_MODE	0x04000000
$define CREATE_NO_WINDOW	0x08000000
$define PROFILE_USER	0x10000000
$define PROFILE_KERNEL	0x20000000
$define PROFILE_SERVER	0x40000000
$define CREATE_IGNORE_SYSTEM_DEFAULT	0x80000000
$define THREAD_PRIORITY_LOWEST	0xFFFFFFFE
$define THREAD_PRIORITY_BELOW_NORMAL	(0xFFFFFFFE+1)
$define THREAD_PRIORITY_NORMAL	0
$define THREAD_PRIORITY_HIGHEST	2
$define THREAD_PRIORITY_ABOVE_NORMAL	(THREAD_PRIORITY_HIGHEST-1)
$define THREAD_PRIORITY_ERROR_RETURN	(0x7FFFFFFF)
$define THREAD_PRIORITY_TIME_CRITICAL	0xF
$define THREAD_PRIORITY_IDLE	0xFFFFFFF1

' Debug APIs
$define EXCEPTION_DEBUG_EVENT	1
$define CREATE_THREAD_DEBUG_EVENT	2
$define CREATE_PROCESS_DEBUG_EVENT	3
$define EXIT_THREAD_DEBUG_EVENT	4
$define EXIT_PROCESS_DEBUG_EVENT	5
$define LOAD_DLL_DEBUG_EVENT	6
$define UNLOAD_DLL_DEBUG_EVENT	7
$define OUTPUT_DEBUG_STRING_EVENT	8
$define RIP_EVENT	9

type EXCEPTION_DEBUG_INFO
	EXCEPTION_RECORD ExceptionRecord
	DWORD dwFirstChance
endtype
type CREATE_THREAD_DEBUG_INFO
	HANDLE hThread
	LPVOID lpThreadLocalBase
	LPTHREAD_START_ROUTINE lpStartAddress
endtype
type CREATE_PROCESS_DEBUG_INFO
	HANDLE hFile
	HANDLE hProcess
	HANDLE hThread
	LPVOID lpBaseOfImage
	DWORD dwDebugInfoFileOffset
	DWORD nDebugInfoSize
	LPVOID lpThreadLocalBase
	LPTHREAD_START_ROUTINE lpStartAddress
	LPVOID lpImageName
	USHORT fUnicode
endtype
type EXIT_THREAD_DEBUG_INFO
	DWORD dwExitCode
endtype
type EXIT_PROCESS_DEBUG_INFO
	DWORD dwExitCode
endtype
type LOAD_DLL_DEBUG_INFO
	HANDLE hFile
	LPVOID lpBaseOfDll
	DWORD dwDebugInfoFileOffset
	DWORD nDebugInfoSize
	LPVOID lpImageName
	USHORT fUnicode
endtype
type UNLOAD_DLL_DEBUG_INFO
	LPVOID lpBaseOfDll
endtype
type OUTPUT_DEBUG_STRING_INFO
	LPSTR lpDebugStringData
	USHORT fUnicode
	USHORT nDebugStringLength
endtype
type RIP_INFO
	DWORD dwError
	DWORD dwType
endtype
union DEBUG_EVENT_u
	EXCEPTION_DEBUG_INFO Exception
	CREATE_THREAD_DEBUG_INFO CreateThread
	CREATE_PROCESS_DEBUG_INFO CreateProcessInfo
	EXIT_THREAD_DEBUG_INFO ExitThread
	EXIT_PROCESS_DEBUG_INFO ExitProcess
	LOAD_DLL_DEBUG_INFO LoadDll
	UNLOAD_DLL_DEBUG_INFO UnloadDll
	OUTPUT_DEBUG_STRING_INFO DebugString
	RIP_INFO RipInfo
endunion
type DEBUG_EVENT,4
	DWORD dwDebugEventCode
	DWORD dwProcessId
	DWORD dwThreadId
	DEBUG_EVENT_u u
endtype

$define DRIVE_UNKNOWN	0
$define DRIVE_NO_ROOT_DIR 1
$define DRIVE_REMOVABLE	2
$define DRIVE_FIXED	3
$define DRIVE_REMOTE	4
$define DRIVE_CDROM	5
$define DRIVE_RAMDISK	6

$ifndef _MAC
'$define GetFreeSpace(w)	(0x100000)
$else
declare import, GetFreeSpace(UINT u),DWORD
$endif

$define FILE_TYPE_UNKNOWN	0x0000
$define FILE_TYPE_DISK	0x0001
$define FILE_TYPE_CHAR	0x0002
$define FILE_TYPE_PIPE	0x0003
$define FILE_TYPE_REMOTE	0x8000

$define STD_INPUT_HANDLE	(-10)
$define STD_OUTPUT_HANDLE	(-11)
$define STD_ERROR_HANDLE	(-12)

$define NOPARITY	0
$define ODDPARITY	1
$define EVENPARITY	2
$define MARKPARITY	3
$define SPACEPARITY	4
$define ONESTOPBIT	0
$define ONE5STOPBITS	1
$define TWOSTOPBITS	2
$define IGNORE	0	' Ignore signal
$define INFINITE	0xFFFFFFFF	' Infinite timeout

' Baud rates at which the communication device operates
$define CBR_110	110
$define CBR_300	300
$define CBR_600	600
$define CBR_1200	1200
$define CBR_2400	2400
$define CBR_4800	4800
$define CBR_9600	9600
$define CBR_14400	14400
$define CBR_19200	19200
$define CBR_38400	38400
$define CBR_56000	56000
$define CBR_57600	57600
$define CBR_115200	115200
$define CBR_128000	128000
$define CBR_256000	256000

' Error Flags
$define CE_RXOVER	0x0001	' Receive Queue overflow
$define CE_OVERRUN	0x0002	' Receive Overrun Error
$define CE_RXPARITY	0x0004	' Receive Parity Error
$define CE_FRAME	0x0008	' Receive Framing error
$define CE_BREAK	0x0010	' Break Detected
$define CE_TXFULL	0x0100	' TX Queue is full
$define CE_PTO	0x0200	' LPTx Timeout
$define CE_IOE	0x0400	' LPTx I/O Error
$define CE_DNS	0x0800	' LPTx Device not selected
$define CE_OOP	0x1000	' LPTx Out-Of-Paper
$define CE_MODE	0x8000	' Requested mode unsupported

$define IE_BADID	(-1)	' Invalid or unsupported id
$define IE_OPEN	(-2)	' Device Already Open
$define IE_NOPEN	(-3)	' Device Not Open
$define IE_MEMORY	(-4)	' Unable to allocate queues
$define IE_DEFAULT	(-5)	' Error in default parameters
$define IE_HARDWARE	(-10)	' Hardware Not Present
$define IE_BYTESIZE	(-11)	' Illegal Byte Size
$define IE_BAUDRATE	(-12)	' Unsupported BaudRate

' Events
$define EV_RXCHAR	0x0001	' Any Character received
$define EV_RXFLAG	0x0002	' Received certain character
$define EV_TXEMPTY	0x0004	' Transmitt Queue Empty
$define EV_CTS	0x0008	' CTS changed state
$define EV_DSR	0x0010	' DSR changed state
$define EV_RLSD	0x0020	' RLSD changed state
$define EV_BREAK	0x0040	' BREAK received
$define EV_ERR	0x0080	' Line status error occurred
$define EV_RING	0x0100	' Ring signal detected
$define EV_PERR	0x0200	' Printer error occured
$define EV_RX80FULL	0x0400	' Receive buffer is 80 percent full
$define EV_EVENT1	0x0800	' Provider specific event 1
$define EV_EVENT2	0x1000	' Provider specific event 2

' Escape Functions
$define SETXOFF	1	' Simulate XOFF received
$define SETXON	2	' Simulate XON received
$define SETRTS	3	' Set RTS high
$define CLRRTS	4	' Set RTS low
$define SETDTR	5	' Set DTR high
$define CLRDTR	6	' Set DTR low
$define RESETDEV	7	' Reset device if possible
$define SETBREAK	8	' Set the device break line.
$define CLRBREAK	9	' Clear the device break line.

' PURGE function flags.
$define PURGE_TXABORT	0x0001	' Kill the pending/current writes to the comm port.
$define PURGE_RXABORT	0x0002	' Kill the pending/current reads to the comm port.
$define PURGE_TXCLEAR	0x0004	' Kill the transmit queue if there.
$define PURGE_RXCLEAR	0x0008	' Kill the typeahead buffer if there.

$define LPTx	0x80	' Set if ID is for LPT device

' Modem Status Flags
$define MS_CTS_ON	(0x0010)
$define MS_DSR_ON	(0x0020)
$define MS_RING_ON	(0x0040)
$define MS_RLSD_ON	(0x0080)

' WaitSoundState()Constants
$define S_QUEUEEMPTY	0
$define S_THRESHOLD	1
$define S_ALLTHRESHOLD	2

' Accent Modes
$define S_NORMAL	0
$define S_LEGATO	1
$define S_STACCATO	2

' SetSoundNoise()Sources
$define S_PERIOD512	0	' Freq = N/512 high pitch,less coarse hiss
$define S_PERIOD1024	1	' Freq = N/1024
$define S_PERIOD2048	2	' Freq = N/2048 low pitch,more coarse hiss
$define S_PERIODVOICE 3	' Source is frequency from voice channel(3)
$define S_WHITE512	4	' Freq = N/512 high pitch,less coarse hiss
$define S_WHITE1024	5	' Freq = N/1024
$define S_WHITE2048	6	' Freq = N/2048 low pitch,more coarse hiss
$define S_WHITEVOICE	7	' Source is frequency from voice channel(3)
$define S_SERDVNA	(-1)	' Device not available
$define S_SEROFM	(-2)	' Out of memory
$define S_SERMACT	(-3)	' Music active
$define S_SERQFUL	(-4)	' Queue full
$define S_SERBDNT	(-5)	' Invalid note
$define S_SERDLN	(-6)	' Invalid note length
$define S_SERDCC	(-7)	' Invalid note count
$define S_SERDTP	(-8)	' Invalid tempo
$define S_SERDVL	(-9)	' Invalid volume
$define S_SERDMD	(-10)' Invalid mode
$define S_SERDSH	(-11)' Invalid shape
$define S_SERDPT	(-12)' Invalid pitch
$define S_SERDFQ	(-13)' Invalid frequency
$define S_SERDDR	(-14)' Invalid duration
$define S_SERDSR	(-15)' Invalid source
$define S_SERDST	(-16)' Invalid state
$define NMPWAIT_WAIT_FOREVER	0xffffffff
$define NMPWAIT_NOWAIT	0x00000001
$define NMPWAIT_USE_DEFAULT_WAIT	0x00000000
$define FS_CASE_IS_PRESERVED	2
$define FS_CASE_SENSITIVE	1
$define FS_UNICODE_STORED_ON_DISK	4
$define FS_PERSISTENT_ACLS	8
$define FS_VOL_IS_COMPRESSED	0x8000
$define FS_FILE_COMPRESSION	0x10
$define FS_FILE_ENCRYPTION	0x20000
$define FILE_MAP_COPY	1
$define FILE_MAP_WRITE	2
$define FILE_MAP_READ	4
$define FILE_MAP_ALL_ACCESS 0xF001F
$define FILE_MAP_EXECUTE	0x0020	' not included in FILE_MAP_ALL_ACCESS
$define OF_READ	0x00000000
$define OF_WRITE	0x00000001
$define OF_READWRITE	0x00000002
$define OF_SHARE_COMPAT	0x00000000
$define OF_SHARE_EXCLUSIVE	0x00000010
$define OF_SHARE_DENY_WRITE 0x00000020
$define OF_SHARE_DENY_READ	0x00000030
$define OF_SHARE_DENY_NONE	0x00000040
$define OF_PARSE	0x00000100
$define OF_DELETE	0x00000200
$define OF_VERIFY	0x00000400
$define OF_CANCEL	0x00000800
$define OF_CREATE	0x00001000
$define OF_PROMPT	0x00002000
$define OF_EXIST	0x00004000
$define OF_REOPEN	0x00008000
$define OFS_MAXPATHNAME 128
type OFSTRUCT
	BYTE cBytes
	BYTE fFixedDisk
	USHORT nErrCode
	USHORT Reserved1
	USHORT Reserved2
	istring szPathName[OFS_MAXPATHNAME]
endtype
$ifndef NOWINBASEINTERLOCK
$ifndef _NTOS_
declare cdecl import,InterlockedIncrement64(pointer Addend),LONGLONG
declare cdecl import,InterlockedDecrement64(pointer Addend),LONGLONG
declare cdecl import,InterlockedIncrementAcquire(pointer Addend),LONG
declare cdecl import,InterlockedDecrementAcquire(pointer Addend),LONG
declare cdecl import,InterlockedIncrementRelease(pointer Addend),LONG
declare cdecl import,InterlockedDecrementRelease(pointer Addend),LONG
declare cdecl import,InterlockedExchange64(pointer Target,LONGLONG Value),LONGLONG
declare cdecl import,InterlockedExchangeAcquire64(pointer Target,LONGLONG Value),LONGLONG
declare cdecl import,InterlockedExchangeAdd64(pointer Addend,LONGLONG Value),LONGLONG
declare cdecl import,InterlockedCompareExchangeAcquire64(pointer Destination,LONGLONG ExChange,LONGLONG Comperand),LONGLONG
declare cdecl import,InterlockedCompareExchangeRelease64(pointer Destination,LONGLONG ExChange,LONGLONG Comperand),LONGLONG
declare cdecl import,InterlockedCompareExchangeRelease(pointer Destination,LONG ExChange,LONG Comperand),LONG
declare cdecl import,InterlockedCompareExchangeAcquire(pointer Destination,LONG ExChange,LONG Comperand),LONG
$ifndef InterlockedExchangePointer_defined
$define InterlockedExchangePointer_defined
declare cdecl import,InterlockedExchangePointer(pointer Target, PVOID Value),PVOID
$endif
declare cdecl import,InterlockedCompareExchangePointer(pointer Destination, PVOID ExChange, PVOID Comperand),PVOID
declare cdecl import,InterlockedCompareExchangePointerAcquire(pointer Destination, PVOID Exchange, PVOID Comperand),PVOID
declare cdecl import,InterlockedCompareExchangePointerRelease(pointer Destination, PVOID Exchange, PVOID Comperand),PVOID
declare import,InterlockedIncrement(pointer lpAddend),LONG
declare import,InterlockedDecrement(pointer lpAddend),LONG
declare import,InterlockedExchange(pointer Target,LONG Value),LONG
'$define InterlockedExchangePointer(Target,Value)\	(PVOID)InterlockedExchange((PLONG)(Target),(LONG)(Value))
'declare import,InterlockedExchangePointer alias InterlockedExchange(pointer Target,LONG Value),LONG
declare import,InterlockedExchangeAdd(pointer Addend,LONG Value),LONG
declare import,InterlockedCompareExchange(pointer Destination,LONG Exchange,LONG Comperand),LONG
declare import,InterlockedCompareExchange64(pointer Destination,LONGLONG Exchange,LONGLONG Comperand),LONGLONG
' Use a function for C++ so X86 will generate the same errors as RISC.
'$define InterlockedCompareExchangePointer(Destination,ExChange,Comperand)\
'	(PVOID)(LONG_PTR)InterlockedCompareExchange((pointer)(Destination),(LONG)(LONG_PTR)(ExChange),(LONG)(LONG_PTR)(Comperand))
'declare import,InterlockedCompareExchangePointer alias InterlockedCompareExchange(pointer Destination,LONG Exchange,LONG Comperand),LONG
declare import,InitializeSListHead(pointer ListHead)
declare import,InterlockedPopEntrySList(pointer ListHead),pointer
declare import,InterlockedPushEntrySList(pointer ListHead,pointer ListEntry),pointer
declare import,InterlockedFlushSList(pointer ListHead),pointer
declare import,QueryDepthSList(pointer ListHead),USHORT
$endif
 /* _NTOS_ */
$endif
 /* NOWINBASEINTERLOCK */
declare import,FreeResource(HGLOBAL hResData),BOOL
declare import,LockResource(HGLOBAL hResData),LPVOID
'$define UnlockResource(hResData)((hResData),0)
$define MAXINTATOM 0xC000
'$define MAKEINTATOM(i)(LPTSTR)((ULONG_PTR)((USHORT)(i)))
declare extern MAKEINTATOM alias LOWORD(word w),pointer
$define INVALID_ATOM(0)
declare import,FreeLibrary(HMODULE hLibModule),BOOL
declare import,FreeLibraryAndExitThread(HMODULE hLibModule,DWORD dwExitCode)
declare import,DisableThreadLibraryCalls(HMODULE hLibModule),BOOL
declare import,GetProcAddress(HMODULE hModule,LPCSTR lpProcName),FARPROC
declare import,GetVersion(),DWORD
declare import,GlobalAlloc(UINT uFlags,SIZE_T dwBytes),HGLOBAL
declare import,GlobalReAlloc(HGLOBAL hMem,SIZE_T dwBytes,UINT uFlags),HGLOBAL
declare import,GlobalSize(HGLOBAL hMem),SIZE_T
declare import,GlobalFlags(HGLOBAL hMem),UINT
declare import,GlobalLock(HGLOBAL hMem),LPVOID
declare import,GlobalHandle(LPCVOID pMem),HGLOBAL
declare import,GlobalUnlock(HGLOBAL hMem),BOOL
declare import,GlobalFree(HGLOBAL hMem),HGLOBAL
declare import,GlobalCompact(DWORD dwMinFree),SIZE_T
declare import,GlobalFix(HGLOBAL hMem)
declare import,GlobalUnfix(HGLOBAL hMem)
declare import,GlobalWire(HGLOBAL hMem),LPVOID
declare import,GlobalUnWire(HGLOBAL hMem),BOOL
declare import,GlobalMemoryStatus(pointer lpBuffer)
type MEMORYSTATUSEX
	DWORD dwLength
	DWORD dwMemoryLoad
	DWORDLONG ullTotalPhys
	DWORDLONG ullAvailPhys
	DWORDLONG ullTotalPageFile
	DWORDLONG ullAvailPageFile
	DWORDLONG ullTotalVirtual
	DWORDLONG ullAvailVirtual
	DWORDLONG ullAvailExtendedVirtual
endtype
declare import,GlobalMemoryStatusEx(pointer lpBuffer),BOOL
declare import,LocalAlloc(UINT uFlags,SIZE_T uBytes),HLOCAL
declare import,LocalReAlloc(HLOCAL hMem,SIZE_T uBytes,UINT uFlags),HLOCAL
declare import,LocalLock(HLOCAL hMem),LPVOID
declare import,LocalHandle(LPCVOID pMem),HLOCAL
declare import,LocalUnlock(HLOCAL hMem),BOOL
declare import,LocalSize(HLOCAL hMem),SIZE_T
declare import,LocalFlags(HLOCAL hMem),UINT
declare import,LocalFree(HLOCAL hMem),HLOCAL
declare import,LocalShrink(HLOCAL hMem,UINT cbNewSize),SIZE_T
declare import,LocalCompact(UINT uMinFree),SIZE_T
declare import,FlushInstructionCache(HANDLE hProcess,LPCVOID lpBaseAddress,SIZE_T dwSize),BOOL
declare import,VirtualAlloc(LPVOID lpAddress,SIZE_T dwSize,DWORD flAllocationType,DWORD flProtect),LPVOID
declare import,VirtualFree(LPVOID lpAddress,SIZE_T dwSize,DWORD dwFreeType),BOOL
declare import,VirtualProtect(LPVOID lpAddress,SIZE_T dwSize,DWORD flNewProtect,pointer lpflOldProtect),BOOL
declare import,VirtualQuery(LPCVOID lpAddress,pointer lpBuffer,SIZE_T dwLength),SIZE_T
declare import,VirtualAllocEx(HANDLE hProcess, LPVOID lpAddress,SIZE_T dwSize,DWORD flAllocationType,DWORD flProtect),LPVOID
declare import,GetWriteWatch(DWORD dwFlags,PVOID lpBaseAddress,SIZE_T dwRegionSize,pointer lpAddresses,pointer lpdwCount,pointer lpdwGranularity),UINT
declare import,ResetWriteWatch(LPVOID lpBaseAddress,SIZE_T dwRegionSize),UINT
declare import,GetLargePageMinimum(),SIZE_T
declare import,EnumSystemFirmwareTables(DWORD FirmwareTableProviderSignature,PVOID pFirmwareTableEnumBuffer,DWORD BufferSize),UINT
declare import,GetSystemFirmwareTable(DWORD FirmwareTableProviderSignature,DWORD FirmwareTableID,PVOID pFirmwareTableBuffer,DWORD BufferSize),UINT
declare import,VirtualFreeEx(HANDLE hProcess,LPVOID lpAddress,SIZE_T dwSize,DWORD	dwFreeType),BOOL
declare import,VirtualProtectEx(HANDLE hProcess,LPVOID lpAddress,SIZE_T dwSize,DWORD flNewProtect,pointer lpflOldProtect),BOOL
declare import,VirtualQueryEx(HANDLE hProcess, LPCVOID lpAddress,pointer lpBuffer,SIZE_T dwLength),SIZE_T
declare import,HeapCreate(DWORD flOptions,SIZE_T dwInitialSize,SIZE_T dwMaximumSize),HANDLE
declare import,HeapDestroy(HANDLE hHeap),BOOL
declare import,HeapAlloc(HANDLE hHeap,DWORD dwFlags,SIZE_T dwBytes),LPVOID
declare import,HeapReAlloc(HANDLE hHeap,DWORD dwFlags,LPVOID lpMem,SIZE_T dwBytes),LPVOID
declare import,HeapFree(HANDLE hHeap,DWORD dwFlags,LPVOID lpMem),BOOL
declare import,HeapSize(HANDLE hHeap,DWORD dwFlags,LPCVOID lpMem),SIZE_T
declare import,HeapValidate(HANDLE hHeap,DWORD dwFlags, LPCVOID lpMem),BOOL
declare import,HeapCompact(HANDLE hHeap,DWORD dwFlags),SIZE_T
declare import,GetProcessHeap(),HANDLE
declare import,GetProcessHeaps(DWORD NumberOfHeaps,pointer ProcessHeaps),DWORD
type PROCESS_HEAP_ENTRY_Block
	HANDLE hMem
	DWORD dwReserved[ 3 ]
endtype
type PROCESS_HEAP_ENTRY_Region
	DWORD dwCommittedSize
	DWORD dwUnCommittedSize
	LPVOID lpFirstBlock
	LPVOID lpLastBlock
endtype
type PROCESS_HEAP_ENTRY
	PVOID lpData
	DWORD cbData
	BYTE cbOverhead
	BYTE iRegionIndex
	USHORT wFlags
	union
		PROCESS_HEAP_ENTRY_Block Block
		PROCESS_HEAP_ENTRY_Region Region
	endunion
endtype
$define PROCESS_HEAP_REGION	0x0001
$define PROCESS_HEAP_UNCOMMITTED_RANGE	0x0002
$define PROCESS_HEAP_ENTRY_BUSY	0x0004
$define PROCESS_HEAP_ENTRY_MOVEABLE	0x0010
$define PROCESS_HEAP_ENTRY_DDESHARE	0x0020
declare import,HeapLock(HANDLE hHeap),BOOL
declare import,HeapUnlock(HANDLE hHeap),BOOL
declare import,HeapWalk(HANDLE hHeap,pointer lpEntry),BOOL
declare import,HeapSetInformation(HANDLE HeapHandle,HEAP_INFORMATION_CLASS HeapInformationClass,PVOID HeapInformation,SIZE_T HeapInformationLength),BOOL
declare import,HeapQueryInformation(HANDLE HeapHandle,HEAP_INFORMATION_CLASS HeapInformationClass,PVOID HeapInformation,SIZE_T HeapInformationLength,pointer ReturnLength),BOOL

' GetBinaryType return values.

$define SCS_32BIT_BINARY	0
$define SCS_DOS_BINARY	1
$define SCS_WOW_BINARY	2
$define SCS_PIF_BINARY	3
$define SCS_POSIX_BINARY	4
$define SCS_OS216_BINARY	5
$define SCS_64BIT_BINARY	6

$define SCS_THIS_PLATFORM_BINARY SCS_32BIT_BINARY
declare import,GetBinaryTypeA(LPCSTR lpApplicationName,pointer lpBinaryType),BOOL
declare import,GetBinaryTypeW(LPCWSTR lpApplicationName,pointer lpBinaryType),BOOL
declare import,GetShortPathNameA(LPCSTR lpszLongPath,LPSTR	lpszShortPath,DWORD cchBuffer),DWORD
declare import,GetShortPathNameW(LPCWSTR lpszLongPath,LPWSTR	lpszShortPath,DWORD cchBuffer),DWORD
declare import,GetLongPathNameA(LPCSTR lpszShortPath,LPSTR	lpszLongPath,DWORD cchBuffer),DWORD
declare import,GetLongPathNameW(LPCWSTR lpszShortPath,LPWSTR	lpszLongPath,DWORD cchBuffer),DWORD
$ifdef UNICODE
declare import,GetBinaryType alias GetBinaryTypeW(LPCWSTR lpApplicationName,pointer lpBinaryType),BOOL
declare import,GetShortPathName alias GetShortPathNameW(LPCWSTR lpszLongPath,LPWSTR	lpszShortPath,DWORD cchBuffer),DWORD
declare import,GetLongPathName alias GetLongPathNameW(LPCWSTR lpszShortPath,LPWSTR	lpszLongPath,DWORD cchBuffer),DWORD
$else
declare import,GetBinaryType alias GetBinaryTypeA(LPCSTR lpApplicationName,pointer lpBinaryType),BOOL
declare import,GetShortPathName alias GetShortPathNameA(LPCSTR lpszLongPath,LPSTR	lpszShortPath,DWORD cchBuffer),DWORD
declare import,GetLongPathName alias GetLongPathNameA(LPCSTR lpszShortPath,LPSTR	lpszLongPath,DWORD cchBuffer),DWORD
$endif
declare import,GetProcessAffinityMask(HANDLE hProcess,pointer lpProcessAffinityMask,pointer lpSystemAffinityMask),BOOL
declare import,SetProcessAffinityMask(HANDLE hProcess,DWORD_PTR dwProcessAffinityMask),BOOL
declare import,GetProcessHandleCount(HANDLE hProcess,pointer pdwHandleCount),BOOL
declare import,GetProcessTimes(HANDLE hProcess,pointer lpCreationTime,pointer lpExitTime,pointer lpKernelTime,pointer lpUserTime),BOOL
declare import,GetProcessIoCounters(HANDLE hProcess,pointer lpIoCounters),BOOL
declare import,GetProcessWorkingSetSize(HANDLE hProcess,pointer lpMinimumWorkingSetSize,pointer lpMaximumWorkingSetSize),BOOL
declare import,GetProcessWorkingSetSizeEx(HANDLE hProcess,pointer lpMinimumWorkingSetSize,pointer lpMaximumWorkingSetSize,pointer Flags),BOOL
declare import,SetProcessWorkingSetSize(HANDLE hProcess,SIZE_T dwMinimumWorkingSetSize,SIZE_T dwMaximumWorkingSetSize),BOOL
declare import,SetProcessWorkingSetSizeEx(HANDLE hProcess,SIZE_T dwMinimumWorkingSetSize,SIZE_T dwMaximumWorkingSetSize,DWORD Flags),BOOL
declare import,OpenProcess(DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwProcessId),HANDLE
declare import,GetCurrentProcess(),HANDLE
declare import,GetCurrentProcessId(),DWORD
declare import,ExitProcess(UINT uExitCode)
declare import,TerminateProcess(HANDLE hProcess,UINT uExitCode),BOOL
declare import,GetExitCodeProcess(HANDLE hProcess,pointer lpExitCode),BOOL
declare import,FatalExit(int ExitCode)
declare import,GetEnvironmentStrings(),LPCH
declare import,GetEnvironmentStringsW(),LPWCH
declare import,SetEnvironmentStringsA(LPCH NewEnvironment),BOOL
declare import,SetEnvironmentStringsW(LPWCH NewEnvironment),BOOL
declare import,FreeEnvironmentStringsA(LPCH __nullnullterminated),BOOL
declare import,FreeEnvironmentStringsW(LPWCH __nullnullterminated),BOOL
$ifdef UNICODE
declare import,SetEnvironmentStrings alias SetEnvironmentStringsW(LPWCH NewEnvironment),BOOL
declare import,FreeEnvironmentStrings alias FreeEnvironmentStringsW(LPWCH __nullnullterminated),BOOL
$else
declare import,SetEnvironmentStrings alias SetEnvironmentStringsA(LPCH NewEnvironment),BOOL
declare import,FreeEnvironmentStrings alias FreeEnvironmentStringsA(LPCH __nullnullterminated),BOOL
$endif
declare import,RaiseException(DWORD dwExceptionCode,DWORD dwExceptionFlags,DWORD nNumberOfArguments,pointer lpArguments)

/*__callback
declare import,UnhandledExceptionFilter(EXCEPTION_POINTERS* ExceptionInfo),LONG

typedef(*PTOP_LEVEL_EXCEPTION_FILTER)(struct _EXCEPTION_POINTERS* ExceptionInfo),LONG;*/
typedef PTOP_LEVEL_EXCEPTION_FILTER	int
typedef LPTOP_LEVEL_EXCEPTION_FILTER int
'typedef PTOP_LEVEL_EXCEPTION_FILTER LPTOP_LEVEL_EXCEPTION_FILTER
declare import,SetUnhandledExceptionFilter(LPTOP_LEVEL_EXCEPTION_FILTER lpTopLevelExceptionFilter),LPTOP_LEVEL_EXCEPTION_FILTER

' Fiber creation flags

$define FIBER_FLAG_FLOAT_SWITCH 0x1	' context switch floating point
declare import,CreateFiber(SIZE_T dwStackSize,LPFIBER_START_ROUTINE lpStartAddress, LPVOID lpParameter),LPVOID
declare import,CreateFiberEx(SIZE_T dwStackCommitSize,SIZE_T dwStackReserveSize,DWORD dwFlags,LPFIBER_START_ROUTINE lpStartAddress, LPVOID lpParameter),LPVOID
declare import,DeleteFiber(LPVOID lpFiber)
declare import,ConvertThreadToFiber(LPVOID lpParameter),LPVOID
declare import,ConvertThreadToFiberEx(LPVOID lpParameter,DWORD dwFlags),LPVOID
declare import,ConvertFiberToThread(),BOOL
declare import,SwitchToFiber(LPVOID lpFiber)
declare import,SwitchToThread(),BOOL
declare import,CreateThread(pointer lpThreadAttributes,SIZE_T dwStackSize,LPTHREAD_START_ROUTINE lpStartAddress, LPVOID lpParameter,DWORD dwCreationFlags,pointer lpThreadId),HANDLE
declare import,CreateRemoteThread(HANDLE hProcess,pointer lpThreadAttributes,SIZE_T dwStackSize,LPTHREAD_START_ROUTINE lpStartAddress, LPVOID lpParameter,DWORD dwCreationFlags,pointer lpThreadId),HANDLE
declare import,GetCurrentThread(),HANDLE
declare import,GetCurrentThreadId(),DWORD
declare import,SetThreadStackGuarantee(pointer StackSizeInBytes),BOOL
declare import,GetProcessIdOfThread(HANDLE Thread),DWORD
declare import,GetThreadId(HANDLE Thread),DWORD
declare import,GetProcessId(HANDLE Process),DWORD
declare import,GetCurrentProcessorNumber(),DWORD
declare import,SetThreadAffinityMask(HANDLE hThread,DWORD_PTR dwThreadAffinityMask),DWORD_PTR
declare import,SetThreadIdealProcessor(HANDLE hThread,DWORD dwIdealProcessor),DWORD
declare import,SetProcessPriorityBoost(HANDLE hProcess,BOOL bDisablePriorityBoost),BOOL
declare import,GetProcessPriorityBoost(HANDLE hProcess,pointer pDisablePriorityBoost),BOOL
declare import,RequestWakeupLatency(LATENCY_TIME latency),BOOL
declare import,IsSystemResumeAutomatic(),BOOL
declare import,OpenThread(DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwThreadId),HANDLE
declare import,SetThreadPriority(HANDLE hThread,int nPriority),BOOL
declare import,SetThreadPriorityBoost(HANDLE hThread,BOOL bDisablePriorityBoost),BOOL
declare import,GetThreadPriorityBoost(HANDLE hThread,pointer pDisablePriorityBoost),BOOL
declare import,GetThreadPriority(HANDLE hThread),int
declare import,GetThreadTimes(HANDLE hThread,pointer lpCreationTime,pointer lpExitTime,pointer lpKernelTime,pointer lpUserTime),BOOL
declare import,GetThreadIOPendingFlag(HANDLE hThread,pointer lpIOIsPending),BOOL
declare import,ExitThread(DWORD dwExitCode)
declare import,TerminateThread(HANDLE hThread,DWORD dwExitCode),BOOL
declare import,GetExitCodeThread(HANDLE hThread,pointer lpExitCode),BOOL
declare import,GetThreadSelectorEntry(HANDLE hThread,DWORD dwSelector,pointer lpSelectorEntry),BOOL
declare import,SetThreadExecutionState(EXECUTION_STATE esFlags),EXECUTION_STATE
declare import,GetLastError(),DWORD
declare import,SetLastError(DWORD dwErrCode)
declare import,RestoreLastError(DWORD dwErrCode)

typedef PRESTORE_LAST_ERROR int
'typedef VOID(* PRESTORE_LAST_ERROR)(DWORD)
$define RESTORE_LAST_ERROR_NAME_A	"RestoreLastError"
$define RESTORE_LAST_ERROR_NAME_W	L"RestoreLastError"
$ifdef UNICODE
$define RESTORE_LAST_ERROR_NAME	L"RestoreLastError"
$else
$define RESTORE_LAST_ERROR_NAME	"RestoreLastError"
$endif

'$define HasOverlappedIoCompleted(lpOverlapped)(((DWORD)(lpOverlapped)->Internal)!= STATUS_PENDING)
declare import,GetOverlappedResult(HANDLE hFile,pointer lpOverlapped,pointer lpNumberOfBytesTransferred,BOOL bWait),BOOL
declare import,CreateIoCompletionPort(HANDLE FileHandle, HANDLE ExistingCompletionPort,ULONG_PTR CompletionKey,DWORD NumberOfConcurrentThreads),HANDLE
declare import,GetQueuedCompletionStatus(HANDLE CompletionPort,pointer lpNumberOfBytesTransferred,pointer lpCompletionKey,pointer lpOverlapped,DWORD dwMilliseconds),BOOL
declare import,PostQueuedCompletionStatus(HANDLE CompletionPort,DWORD dwNumberOfBytesTransferred,ULONG_PTR dwCompletionKey,pointer lpOverlapped),BOOL

$define SEM_FAILCRITICALERRORS	0x0001
$define SEM_NOGPFAULTERRORBOX	0x0002
$define SEM_NOALIGNMENTFAULTEXCEPT	0x0004
$define SEM_NOOPENFILEERRORBOX	0x8000
declare import,SetErrorMode(UINT uMode),UINT
declare import,ReadProcessMemory(HANDLE hProcess,LPCVOID lpBaseAddress,LPVOID lpBuffer,SIZE_T nSize,pointer lpNumberOfBytesRead),BOOL
declare import,WriteProcessMemory(HANDLE hProcess,LPVOID lpBaseAddress,LPCVOID lpBuffer,SIZE_T nSize,pointer lpNumberOfBytesWritten),BOOL
declare import,GetThreadContext(HANDLE hThread,pointer lpContext),BOOL
declare import,SetThreadContext(HANDLE hThread,pointer lpContext),BOOL
declare import,SuspendThread(HANDLE hThread),DWORD
declare import,ResumeThread(HANDLE hThread),DWORD

typedef APCFUNC int
/*VOID(pointer APCFUNC*)(ULONG_PTR dwParam);*/
declare import,QueueUserAPC(APCFUNC pfnAPC,HANDLE hThread,ULONG_PTR dwData),DWORD
declare import,IsDebuggerPresent(),BOOL
declare import,CheckRemoteDebuggerPresent(HANDLE hProcess,pointer pbDebuggerPresent),BOOL
declare import,DebugBreak()
declare import,WaitForDebugEvent(pointer lpDebugEvent,DWORD dwMilliseconds),BOOL
declare import,ContinueDebugEvent(DWORD dwProcessId,DWORD dwThreadId,DWORD dwContinueStatus),BOOL
declare import,DebugActiveProcess(DWORD dwProcessId),BOOL
declare import,DebugActiveProcessStop(DWORD dwProcessId),BOOL
declare import,DebugSetProcessKillOnExit(BOOL KillOnExit),BOOL
declare import,DebugBreakProcess(HANDLE Process),BOOL
declare import,InitializeCriticalSection(pointer lpCriticalSection)
declare import,EnterCriticalSection(pointer lpCriticalSection)
declare import,LeaveCriticalSection(pointer lpCriticalSection)
declare import,InitializeCriticalSectionAndSpinCount(pointer lpCriticalSection,DWORD dwSpinCount),BOOL
declare import,SetCriticalSectionSpinCount(pointer lpCriticalSection,DWORD dwSpinCount),DWORD
declare import,TryEnterCriticalSection(pointer lpCriticalSection),BOOL
declare import,DeleteCriticalSection(pointer lpCriticalSection)
declare import,SetEvent(HANDLE hEvent),BOOL
declare import,ResetEvent(HANDLE hEvent),BOOL
declare import,PulseEvent(HANDLE hEvent),BOOL
declare import,ReleaseSemaphore(HANDLE hSemaphore,LONG lReleaseCount,pointer lpPreviousCount),BOOL
declare import,ReleaseMutex(HANDLE hMutex),BOOL
declare import,WaitForSingleObject(HANDLE hHandle,DWORD dwMilliseconds),DWORD
declare import,WaitForMultipleObjects(DWORD nCount,pointer lpHandles,BOOL bWaitAll,DWORD dwMilliseconds),DWORD
declare import,Sleep(DWORD dwMilliseconds)
declare import,_LoadResource alias LoadResource(HMODULE hModule,HRSRC hResInfo),HGLOBAL
declare import,SizeofResource(HMODULE hModule,HRSRC hResInfo),DWORD
declare import,GlobalDeleteAtom(ATOM nAtom),ATOM
declare import,InitAtomTable(DWORD nSize),BOOL
declare import,DeleteAtom(ATOM nAtom),ATOM
declare import,SetHandleCount(UINT uNumber),UINT
declare import,GetLogicalDrives(),DWORD
declare import,LockFile(HANDLE hFile,DWORD dwFileOffsetLow,DWORD dwFileOffsetHigh,DWORD nNumberOfBytesToLockLow,DWORD nNumberOfBytesToLockHigh),BOOL
declare import,UnlockFile(HANDLE hFile,DWORD dwFileOffsetLow,DWORD dwFileOffsetHigh,DWORD nNumberOfBytesToUnlockLow,DWORD nNumberOfBytesToUnlockHigh),BOOL
declare import,LockFileEx(HANDLE hFile,DWORD dwFlags,DWORD dwReserved,DWORD nNumberOfBytesToLockLow,DWORD nNumberOfBytesToLockHigh,pointer lpOverlapped),BOOL

$define LOCKFILE_FAIL_IMMEDIATELY	0x00000001
$define LOCKFILE_EXCLUSIVE_LOCK	0x00000002
declare import,UnlockFileEx(HANDLE hFile,DWORD dwReserved,DWORD nNumberOfBytesToUnlockLow,DWORD nNumberOfBytesToUnlockHigh,pointer lpOverlapped),BOOL

type BY_HANDLE_FILE_INFORMATION
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD dwVolumeSerialNumber
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
	DWORD nNumberOfLinks
	DWORD nFileIndexHigh
	DWORD nFileIndexLow
endtype
declare import,GetFileInformationByHandle(HANDLE hFile,pointer lpFileInformation),BOOL
declare import,GetFileType(HANDLE hFile),DWORD
declare import,GetFileSize(HANDLE hFile,pointer lpFileSizeHigh),DWORD
declare import,GetFileSizeEx(HANDLE hFile,pointer lpFileSize),BOOL
declare import,GetStdHandle(DWORD nStdHandle),HANDLE
declare import,SetStdHandle(DWORD nStdHandle,HANDLE hHandle),BOOL
declare import,WriteFile(HANDLE hFile,LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite,pointer lpNumberOfBytesWritten,pointer lpOverlapped),BOOL
declare import,ReadFile(HANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer lpNumberOfBytesRead,pointer lpOverlapped),BOOL
declare import,FlushFileBuffers(HANDLE hFile),BOOL
declare import,DeviceIoControl(HANDLE hDevice,DWORD dwIoControlCode,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesReturned,pointer lpOverlapped),BOOL
declare import,RequestDeviceWakeup(HANDLE hDevice),BOOL
declare import,CancelDeviceWakeupRequest(HANDLE hDevice),BOOL
declare import,GetDevicePowerState(HANDLE hDevice,pointer pfOn),BOOL
declare import,SetMessageWaitingIndicator(HANDLE hMsgIndicator,ULONG ulMsgCount),BOOL
declare import,SetEndOfFile(HANDLE hFile),BOOL
declare import,SetFilePointer(HANDLE hFile,LONG lDistanceToMove, PLONG lpDistanceToMoveHigh,DWORD dwMoveMethod),DWORD
declare import,SetFilePointerEx(HANDLE hFile,LARGE_INTEGER liDistanceToMove byval,pointer lpNewFilePointer,DWORD dwMoveMethod),BOOL
declare import,_FindClose alias FindClose(HANDLE hFindFile),BOOL
declare import,GetFileTime(HANDLE hFile,pointer lpCreationTime,pointer lpLastAccessTime,pointer lpLastWriteTime),BOOL
declare import,SetFileTime(HANDLE hFile,pointer lpCreationTime,pointer lpLastAccessTime,pointer lpLastWriteTime),BOOL
declare import,SetFileValidData(HANDLE hFile,LONGLONG ValidDataLength),BOOL
declare import,SetFileShortNameA(HANDLE hFile,LPCSTR lpShortName),BOOL
declare import,SetFileShortNameW(HANDLE hFile,LPCWSTR lpShortName),BOOL
$ifdef UNICODE
declare import,SetFileShortName alias SetFileShortNameW(HANDLE hFile,LPCWSTR lpShortName),BOOL
$else
declare import,SetFileShortName alias SetFileShortNameA(HANDLE hFile,LPCSTR lpShortName),BOOL
$endif
declare import,CloseHandle(HANDLE hObject),BOOL
declare import,DuplicateHandle(HANDLE hSourceProcessHandle,HANDLE hSourceHandle,HANDLE hTargetProcessHandle,pointer lpTargetHandle,DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwOptions),BOOL
declare import,GetHandleInformation(HANDLE hObject,pointer lpdwFlags),BOOL
declare import,SetHandleInformation(HANDLE hObject,DWORD dwMask,DWORD dwFlags),BOOL

$define HANDLE_FLAG_INHERIT	0x00000001
$define HANDLE_FLAG_PROTECT_FROM_CLOSE	0x00000002

$define HINSTANCE_ERROR 32
declare import,LoadModule(LPCSTR lpModuleName,LPVOID lpParameterBlock),DWORD
declare import,WinExec(LPCSTR lpCmdLine,UINT uCmdShow),UINT
declare import,ClearCommBreak(HANDLE hFile),BOOL
declare import,ClearCommError(HANDLE hFile,pointer lpErrors,pointer lpStat),BOOL
declare import,SetupComm(HANDLE hFile,DWORD dwInQueue,DWORD dwOutQueue),BOOL
declare import,EscapeCommFunction(HANDLE hFile,DWORD dwFunc),BOOL
declare import,GetCommConfig(HANDLE hCommDev,pointer lpCC,pointer lpdwSize),BOOL
declare import,GetCommMask(HANDLE hFile,pointer lpEvtMask),BOOL
declare import,GetCommProperties(HANDLE hFile,pointer lpCommProp),BOOL
declare import,GetCommModemStatus(HANDLE hFile,pointer lpModemStat),BOOL
declare import,GetCommState(HANDLE hFile,pointer lpDCB),BOOL
declare import,GetCommTimeouts(HANDLE hFile,pointer lpCommTimeouts),BOOL
declare import,PurgeComm(HANDLE hFile,DWORD dwFlags),BOOL
declare import,SetCommBreak(HANDLE hFile),BOOL
declare import,SetCommConfig(HANDLE hCommDev,pointer lpCC,DWORD dwSize),BOOL
declare import,SetCommMask(HANDLE hFile,DWORD dwEvtMask),BOOL
declare import,SetCommState(HANDLE hFile,pointer lpDCB),BOOL
declare import,SetCommTimeouts(HANDLE hFile,pointer lpCommTimeouts),BOOL
declare import,TransmitCommChar(HANDLE hFile,char cChar),BOOL
declare import,WaitCommEvent(HANDLE hFile,pointer lpEvtMask,pointer lpOverlapped),BOOL
declare import,SetTapePosition(HANDLE hDevice,DWORD dwPositionMethod,DWORD dwPartition,DWORD dwOffsetLow,DWORD dwOffsetHigh,BOOL bImmediate),DWORD
declare import,GetTapePosition(HANDLE hDevice,DWORD dwPositionType,pointer lpdwPartition,pointer lpdwOffsetLow,pointer lpdwOffsetHigh),DWORD
declare import,PrepareTape(HANDLE hDevice,DWORD dwOperation,BOOL bImmediate),DWORD
declare import,EraseTape(HANDLE hDevice,DWORD dwEraseType,BOOL bImmediate),DWORD
declare import,CreateTapePartition(HANDLE hDevice,DWORD dwPartitionMethod,DWORD dwCount,DWORD dwSize),DWORD
declare import,WriteTapemark(HANDLE hDevice,DWORD dwTapemarkType,DWORD dwTapemarkCount,BOOL bImmediate),DWORD
declare import,GetTapeStatus(HANDLE hDevice),DWORD
declare import,GetTapeParameters(HANDLE hDevice,DWORD dwOperation,pointer lpdwSize,LPVOID lpTapeInformation),DWORD

$define GET_TAPE_MEDIA_INFORMATION 0
$define GET_TAPE_DRIVE_INFORMATION 1
declare import,SetTapeParameters(HANDLE hDevice,DWORD dwOperation,LPVOID lpTapeInformation),DWORD

$define SET_TAPE_MEDIA_INFORMATION 0
$define SET_TAPE_DRIVE_INFORMATION 1
declare import,Beep(DWORD dwFreq,DWORD dwDuration),BOOL
declare import,MulDiv(int nNumber,int nNumerator,int nDenominator),int
declare import,GetSystemTime(pointer lpSystemTime)
declare import,GetSystemTimeAsFileTime(pointer lpSystemTimeAsFileTime)
declare import,SetSystemTime(pointer lpSystemTime),BOOL
declare import,GetLocalTime(pointer lpSystemTime)
declare import,SetLocalTime(pointer lpSystemTime),BOOL
declare import,GetSystemInfo(pointer lpSystemInfo)
declare import,SetSystemFileCacheSize(SIZE_T MinimumFileCacheSize,SIZE_T MaximumFileCacheSize,DWORD Flags),BOOL
declare import,GetSystemFileCacheSize(pointer lpMinimumFileCacheSize,pointer lpMaximumFileCacheSize,pointer lpFlags),BOOL
declare import,GetSystemRegistryQuota(pointer pdwQuotaAllowed,pointer pdwQuotaUsed),BOOL
declare import,GetSystemTimes(pointer lpIdleTime,pointer lpKernelTime,pointer lpUserTime),BOOL
declare import,GetNativeSystemInfo(pointer lpSystemInfo)
declare import,IsProcessorFeaturePresent(DWORD ProcessorFeature),BOOL

type TIME_ZONE_INFORMATION
	LONG Bias
	iwstring StandardName[ 32 ]
	SYSTEMTIME StandardDate
	LONG StandardBias
	iwstring DaylightName[ 32 ]
	SYSTEMTIME DaylightDate
	LONG DaylightBias
endtype
declare import,SystemTimeToTzSpecificLocalTime(pointer lpTimeZoneInformation,pointer lpUniversalTime,pointer lpLocalTime),BOOL
declare import,TzSpecificLocalTimeToSystemTime(pointer lpTimeZoneInformation,pointer lpLocalTime,pointer lpUniversalTime),BOOL
declare import,GetTimeZoneInformation(pointer lpTimeZoneInformation),DWORD
declare import,SetTimeZoneInformation(pointer lpTimeZoneInformation),BOOL

' Routines to convert back and forth between system time and file time
declare import,SystemTimeToFileTime(pointer lpSystemTime,pointer lpFileTime),BOOL
declare import,FileTimeToLocalFileTime(pointer lpFileTime,pointer lpLocalFileTime),BOOL
declare import,LocalFileTimeToFileTime(pointer lpLocalFileTime,pointer lpFileTime),BOOL
declare import,FileTimeToSystemTime(pointer lpFileTime,pointer lpSystemTime),BOOL
declare import,CompareFileTime(pointer lpFileTime1,pointer lpFileTime2),LONG
declare import,FileTimeToDosDateTime(pointer lpFileTime,pointer lpFatDate,pointer lpFatTime),BOOL
declare import,DosDateTimeToFileTime(USHORT wFatDate,USHORT wFatTime,pointer lpFileTime),BOOL
declare import,GetTickCount(),DWORD
declare import,SetSystemTimeAdjustment(DWORD dwTimeAdjustment,BOOL	bTimeAdjustmentDisabled),BOOL
declare import,GetSystemTimeAdjustment(pointer lpTimeAdjustment,pointer lpTimeIncrement,pointer lpTimeAdjustmentDisabled),BOOL
declare import,FormatMessageA(DWORD dwFlags,LPCVOID lpSource,DWORD dwMessageId,DWORD dwLanguageId,LPSTR lpBuffer,DWORD nSize,pointer Arguments),DWORD
declare import,FormatMessageW(DWORD dwFlags,LPCVOID lpSource,DWORD dwMessageId,DWORD dwLanguageId,LPWSTR lpBuffer,DWORD nSize,pointer Arguments),DWORD
$ifdef UNICODE
declare import,FormatMessage alias FormatMessageW(DWORD dwFlags,LPCVOID lpSource,DWORD dwMessageId,DWORD dwLanguageId,LPWSTR lpBuffer,DWORD nSize,pointer Arguments),DWORD
$else
declare import,FormatMessage alias FormatMessageA(DWORD dwFlags,LPCVOID lpSource,DWORD dwMessageId,DWORD dwLanguageId,LPSTR lpBuffer,DWORD nSize,pointer Arguments),DWORD
$endif


$define FORMAT_MESSAGE_ALLOCATE_BUFFER 0x00000100
$define FORMAT_MESSAGE_IGNORE_INSERTS	0x00000200
$define FORMAT_MESSAGE_FROM_STRING	0x00000400
$define FORMAT_MESSAGE_FROM_HMODULE	0x00000800
$define FORMAT_MESSAGE_FROM_SYSTEM	0x00001000
$define FORMAT_MESSAGE_ARGUMENT_ARRAY	0x00002000
$define FORMAT_MESSAGE_MAX_WIDTH_MASK	0x000000FF
declare import,CreatePipe(pointer hReadPipe,pointer hWritePipe,pointer lpPipeAttributes,DWORD nSize),BOOL
declare import,ConnectNamedPipe(HANDLE hNamedPipe,pointer lpOverlapped),BOOL
declare import,DisconnectNamedPipe(HANDLE hNamedPipe),BOOL
declare import,SetNamedPipeHandleState(HANDLE hNamedPipe,pointer lpMode,pointer lpMaxCollectionCount,pointer lpCollectDataTimeout),BOOL
declare import,GetNamedPipeInfo(HANDLE hNamedPipe,pointer lpFlags,pointer lpOutBufferSize,pointer lpInBufferSize,pointer lpMaxInstances),BOOL
declare import,PeekNamedPipe(HANDLE hNamedPipe,LPVOID lpBuffer,DWORD nBufferSize,pointer lpBytesRead,pointer lpTotalBytesAvail,pointer lpBytesLeftThisMessage),BOOL
declare import,TransactNamedPipe(HANDLE hNamedPipe,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesRead,pointer lpOverlapped),BOOL
declare import,CreateMailslotA(LPCSTR lpName,DWORD nMaxMessageSize,DWORD lReadTimeout,pointer lpSecurityAttributes),HANDLE
declare import,CreateMailslotW(LPCWSTR lpName,DWORD nMaxMessageSize,DWORD lReadTimeout,pointer lpSecurityAttributes),HANDLE
$ifdef UNICODE
declare import,CreateMailslot alias CreateMailslotW(LPCWSTR lpName,DWORD nMaxMessageSize,DWORD lReadTimeout,pointer lpSecurityAttributes),HANDLE
$else
declare import,CreateMailslot alias CreateMailslotA(LPCSTR lpName,DWORD nMaxMessageSize,DWORD lReadTimeout,pointer lpSecurityAttributes),HANDLE
$endif
declare import,GetMailslotInfo(HANDLE hMailslot,pointer lpMaxMessageSize,pointer lpNextSize,pointer lpMessageCount,pointer lpReadTimeout),BOOL
declare import,SetMailslotInfo(HANDLE hMailslot,DWORD lReadTimeout),BOOL
declare import,MapViewOfFile(HANDLE hFileMappingObject,DWORD dwDesiredAccess,DWORD dwFileOffsetHigh,DWORD dwFileOffsetLow,SIZE_T dwNumberOfBytesToMap),LPVOID
declare import,FlushViewOfFile(LPCVOID lpBaseAddress,SIZE_T dwNumberOfBytesToFlush),BOOL
declare import,UnmapViewOfFile(LPCVOID lpBaseAddress),BOOL

' File Encryption API
declare import,EncryptFileA(LPCSTR lpFileName),BOOL
declare import,EncryptFileW(LPCWSTR lpFileName),BOOL
declare import,DecryptFileA(LPCSTR lpFileName,DWORD dwReserved),BOOL
declare import,DecryptFileW(LPCWSTR lpFileName,DWORD dwReserved),BOOL
$ifdef UNICODE
declare import,EncryptFile alias EncryptFileW(LPCWSTR lpFileName),BOOL
declare import,DecryptFile alias DecryptFileW(LPCWSTR lpFileName,DWORD dwReserved),BOOL
$else
declare import,EncryptFile alias EncryptFileA(LPCSTR lpFileName),BOOL
declare import,DecryptFile alias DecryptFileA(LPCSTR lpFileName,DWORD dwReserved),BOOL
$endif

'	Encryption Status Value

$define FILE_ENCRYPTABLE	0
$define FILE_IS_ENCRYPTED	1
$define FILE_SYSTEM_ATTR	2
$define FILE_ROOT_DIR	3
$define FILE_SYSTEM_DIR	4
$define FILE_UNKNOWN	5
$define FILE_SYSTEM_NOT_SUPPORT	6
$define FILE_USER_DISALLOWED	7
$define FILE_READ_ONLY	8
$define FILE_DIR_DISALLOWED	9
declare import,FileEncryptionStatusA(LPCSTR lpFileName,pointer lpStatus),BOOL
declare import,FileEncryptionStatusW(LPCWSTR lpFileName,pointer lpStatus),BOOL
$ifdef UNICODE
declare import,FileEncryptionStatus alias FileEncryptionStatusW(LPCWSTR lpFileName,pointer lpStatus),BOOL
$else
declare import,FileEncryptionStatus alias FileEncryptionStatusA(LPCSTR lpFileName,pointer lpStatus),BOOL
$endif

' Currently defined recovery flags

$define EFS_USE_RECOVERY_KEYS(0x1)

typedef PFE_IMPORT_FUNC int
typedef PFE_EXPORT_FUNC int

/*(*PFE_EXPORT_FUNC)(__in_bcount(ulLength)PBYTE pbData, PVOID pvCallbackContext,ULONG ulLength),DWORD
(*PFE_IMPORT_FUNC)((*ulLength,*ulLength)PBYTE pbData, PVOID pvCallbackContext, pointer ulLength),DWORD;*/

'	OpenRaw flag values

$define CREATE_FOR_IMPORT(1)
$define CREATE_FOR_DIR	(2)
$define OVERWRITE_HIDDEN	(4)
declare import,ReadEncryptedFileRaw(PFE_EXPORT_FUNC pfExportCallback, PVOID pvCallbackContext,PVOID pvContext),DWORD
declare import,WriteEncryptedFileRaw(PFE_IMPORT_FUNC pfImportCallback, PVOID pvCallbackContext,PVOID pvContext),DWORD
declare import,CloseEncryptedFileRaw(PVOID pvContext)
declare import,OpenEncryptedFileRawA(LPCSTR lpFileName,ULONG ulFlags,pointer pvContext),DWORD
declare import,OpenEncryptedFileRawW(LPCWSTR lpFileName,ULONG ulFlags,pointer pvContext),DWORD
$ifdef UNICODE
declare import,OpenEncryptedFileRaw alias OpenEncryptedFileRawW(LPCWSTR lpFileName,ULONG ulFlags,pointer pvContext),DWORD
$else
declare import,OpenEncryptedFileRaw alias OpenEncryptedFileRawA(LPCSTR lpFileName,ULONG ulFlags,pointer pvContext),DWORD
$endif

' _l Compat Functions
declare import,lstrcmpA(LPCSTR lpString1,LPCSTR lpString2),int
declare import,lstrcmpW(LPCWSTR lpString1,LPCWSTR lpString2),int
declare import,lstrcmpiA(LPCSTR lpString1,LPCSTR lpString2),int
declare import,lstrcmpiW(LPCWSTR lpString1,LPCWSTR lpString2),int
declare import,lstrcpynA(LPSTR lpString1,LPCSTR lpString2,int iMaxLength),LPSTR
declare import,lstrcpynW(LPWSTR lpString1,LPCWSTR lpString2,int iMaxLength),LPWSTR
declare import,lstrcpyA(LPSTR lpString1,LPCSTR lpString2),LPSTR
declare import,lstrcpyW(LPWSTR lpString1,LPCWSTR lpString2),LPWSTR
declare import,lstrcatA(LPSTR lpString1,LPCSTR lpString2),LPSTR
declare import,lstrcatW(LPWSTR lpString1,LPCWSTR lpString2),LPWSTR
declare import,lstrlenA(LPCSTR lpString),int
declare import,lstrlenW(LPCWSTR lpString),int
$ifdef UNICODE
declare import,lstrcmp alias lstrcmpW(LPCWSTR lpString1,LPCWSTR lpString2),int
declare import,lstrcmpi alias lstrcmpiW(LPCWSTR lpString1,LPCWSTR lpString2),int
declare import,lstrcpyn alias lstrcpynW(LPWSTR lpString1,LPCWSTR lpString2,int iMaxLength),LPWSTR
declare import,lstrcpy alias lstrcpyW(LPWSTR lpString1,LPCWSTR lpString2),LPWSTR
declare import,lstrcat alias lstrcatW(LPWSTR lpString1,LPCWSTR lpString2),LPWSTR
declare import,lstrlen alias lstrlenW(LPCWSTR lpString),int
$else
declare import,lstrcmp alias lstrcmpA(LPCSTR lpString1,LPCSTR lpString2),int
declare import,lstrcmpi alias lstrcmpiA(LPCSTR lpString1,LPCSTR lpString2),int
declare import,lstrcpyn alias lstrcpynA(LPSTR lpString1,LPCSTR lpString2,int iMaxLength),LPSTR
declare import,lstrcpy alias lstrcpyA(LPSTR lpString1,LPCSTR lpString2),LPSTR
declare import,lstrcat alias lstrcatA(LPSTR lpString1,LPCSTR lpString2),LPSTR
declare import,lstrlen alias lstrlenA(LPCSTR lpString),int
$endif
declare import,_OpenFile alias OpenFile(LPCSTR lpFileName,pointer lpReOpenBuff,UINT uStyle),HFILE
declare import,_lopen(LPCSTR lpPathName,int iReadWrite),HFILE
declare import,_lcreate(LPCSTR lpPathName,int	iAttribute),HFILE
declare import,_lread(HFILE hFile,LPVOID lpBuffer,UINT uBytes),UINT
declare import,_lwrite(HFILE hFile,LPCCH lpBuffer,UINT uBytes),UINT
declare import,_hread(HFILE hFile,LPVOID lpBuffer,long lBytes),long
declare import,_hwrite(HFILE hFile,LPCCH lpBuffer,long lBytes),long
declare import,_lclose(HFILE hFile),HFILE
declare import,_llseek(HFILE hFile,LONG lOffset,int iOrigin),LONG
declare import,IsTextUnicode(pointer lpv,int iSize,opt LPINT lpiResult),BOOL

$define FLS_OUT_OF_INDEXES(0xFFFFFFFF)
declare import,FlsAlloc(PFLS_CALLBACK_FUNCTION lpCallback),DWORD
declare import,FlsGetValue(DWORD dwFlsIndex),PVOID
declare import,FlsSetValue(DWORD dwFlsIndex, PVOID lpFlsData),BOOL
declare import,FlsFree(DWORD dwFlsIndex),BOOL

$define TLS_OUT_OF_INDEXES(0xFFFFFFFF)
declare import,TlsAlloc(),DWORD
declare import,TlsGetValue(DWORD dwTlsIndex),LPVOID
declare import,TlsSetValue(DWORD dwTlsIndex, LPVOID lpTlsValue),BOOL
declare import,TlsFree(DWORD dwTlsIndex),BOOL

typedef LPOVERLAPPED_COMPLETION_ROUTINE int
/*VOID(*LPOVERLAPPED_COMPLETION_ROUTINE)(DWORD dwErrorCode,DWORD dwNumberOfBytesTransfered,pointer lpOverlapped);*/
declare import,SleepEx(DWORD dwMilliseconds,BOOL bAlertable),DWORD
declare import,WaitForSingleObjectEx(HANDLE hHandle,DWORD dwMilliseconds,BOOL bAlertable),DWORD
declare import,WaitForMultipleObjectsEx(DWORD nCount,pointer lpHandles,BOOL bWaitAll,DWORD dwMilliseconds,BOOL bAlertable),DWORD
declare import,SignalObjectAndWait(HANDLE hObjectToSignal,HANDLE hObjectToWaitOn,DWORD dwMilliseconds,BOOL bAlertable),DWORD
declare import,ReadFileEx(HANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer lpOverlapped, LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine),BOOL
declare import,WriteFileEx(HANDLE hFile,LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite,pointer lpOverlapped, LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine),BOOL
declare import,BackupRead(HANDLE hFile,pointer lpBuffer,DWORD nNumberOfBytesToRead,pointer lpNumberOfBytesRead,BOOL bAbort,BOOL bProcessSecurity,pointer lpContext),BOOL
declare import,BackupSeek(HANDLE hFile,DWORD dwLowBytesToSeek,DWORD dwHighBytesToSeek,pointer lpdwLowByteSeeked,pointer lpdwHighByteSeeked,pointer lpContext),BOOL
declare import,BackupWrite(HANDLE hFile,pointer lpBuffer,DWORD nNumberOfBytesToWrite,pointer lpNumberOfBytesWritten,BOOL bAbort,BOOL bProcessSecurity,pointer lpContext),BOOL

'	Stream id structure
type WIN32_STREAM_ID
	DWORD	dwStreamId
	DWORD	dwStreamAttributes
	LARGE_INTEGER	Size
	DWORD	dwStreamNameSize
	iwstring	cStreamName[ ANYSIZE_ARRAY ]
endtype

'	Stream Ids

$define BACKUP_INVALID	0x00000000
$define BACKUP_DATA	0x00000001
$define BACKUP_EA_DATA	0x00000002
$define BACKUP_SECURITY_DATA	0x00000003
$define BACKUP_ALTERNATE_DATA	0x00000004
$define BACKUP_LINK	0x00000005
$define BACKUP_PROPERTY_DATA	0x00000006
$define BACKUP_OBJECT_ID	0x00000007
$define BACKUP_REPARSE_DATA	0x00000008
$define BACKUP_SPARSE_BLOCK	0x00000009

'	Stream Attributes

$define STREAM_NORMAL_ATTRIBUTE	0x00000000
$define STREAM_MODIFIED_WHEN_READ	0x00000001
$define STREAM_CONTAINS_SECURITY	0x00000002
$define STREAM_CONTAINS_PROPERTIES	0x00000004
$define STREAM_SPARSE_ATTRIBUTE	0x00000008
declare import,ReadFileScatter(HANDLE hFile,FILE_SEGMENT_ELEMENT aSegmentArray[],DWORD nNumberOfBytesToRead,pointer lpReserved,pointer lpOverlapped),BOOL
declare import,WriteFileGather(HANDLE hFile,FILE_SEGMENT_ELEMENT aSegmentArray[],DWORD nNumberOfBytesToWrite,pointer lpReserved,pointer lpOverlapped),BOOL

' Dual Mode API below this line. Dual Mode Structures also included.

$define STARTF_USESHOWWINDOW	0x00000001
$define STARTF_USESIZE	0x00000002
$define STARTF_USEPOSITION	0x00000004
$define STARTF_USECOUNTCHARS	0x00000008
$define STARTF_USEFILLATTRIBUTE 0x00000010
$define STARTF_RUNFULLSCREEN	0x00000020	' ignored for non-x86 platforms
$define STARTF_FORCEONFEEDBACK	0x00000040
$define STARTF_FORCEOFFFEEDBACK 0x00000080
$define STARTF_USESTDHANDLES	0x00000100

$define STARTF_USEHOTKEY	0x00000200

type STARTUPINFOA
	DWORD	cb
	pointer lpReserved
	pointer lpDesktop
	pointer lpTitle
	DWORD	dwX
	DWORD	dwY
	DWORD	dwXSize
	DWORD	dwYSize
	DWORD	dwXCountChars
	DWORD	dwYCountChars
	DWORD	dwFillAttribute
	DWORD	dwFlags
	USHORT wShowWindow
	USHORT cbReserved2
	pointer lpReserved2
	HANDLE	hStdInput
	HANDLE	hStdOutput
	HANDLE	hStdError
endtype
type STARTUPINFOW
	DWORD	cb
	pointer lpReserved
	pointer lpDesktop
	pointer lpTitle
	DWORD	dwX
	DWORD	dwY
	DWORD	dwXSize
	DWORD	dwYSize
	DWORD	dwXCountChars
	DWORD	dwYCountChars
	DWORD	dwFillAttribute
	DWORD	dwFlags
	USHORT	wShowWindow
	USHORT	cbReserved2
	pointer lpReserved2
	HANDLE	hStdInput
	HANDLE	hStdOutput
	HANDLE	hStdError
endtype
type STARTUPINFO
	DWORD	cb
	pointer lpReserved
	pointer lpDesktop
	pointer lpTitle
	DWORD	dwX
	DWORD	dwY
	DWORD	dwXSize
	DWORD	dwYSize
	DWORD	dwXCountChars
	DWORD	dwYCountChars
	DWORD	dwFillAttribute
	DWORD	dwFlags
	USHORT	wShowWindow
	USHORT	cbReserved2
	pointer lpReserved2
	HANDLE	hStdInput
	HANDLE	hStdOutput
	HANDLE	hStdError
endtype

$define SHUTDOWN_NORETRY	0x00000001

type WIN32_FIND_DATAA
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
	DWORD dwReserved0
	DWORD dwReserved1
	istring cFileName[ MAX_PATH ]
	istring cAlternateFileName[ 14 ]
endtype
type WIN32_FIND_DATAW
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
	DWORD dwReserved0
	DWORD dwReserved1
	iwstring cFileName[ MAX_PATH ]
	iwstring cAlternateFileName[ 14 ]
endtype
$ifdef UNICODE
type WIN32_FIND_DATA
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
	DWORD dwReserved0
	DWORD dwReserved1
	iwstring cFileName[ MAX_PATH ]
	iwstring cAlternateFileName[ 14 ]
endtype
$else
type WIN32_FIND_DATA
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
	DWORD dwReserved0
	DWORD dwReserved1
	istring cFileName[ MAX_PATH ]
	istring cAlternateFileName[ 14 ]
endtype
$endif

type WIN32_FILE_ATTRIBUTE_DATA
	DWORD dwFileAttributes
	FILETIME ftCreationTime
	FILETIME ftLastAccessTime
	FILETIME ftLastWriteTime
	DWORD nFileSizeHigh
	DWORD nFileSizeLow
endtype
declare import,CreateMutexA(pointer lpMutexAttributes,BOOL bInitialOwner, LPCSTR lpName),HANDLE
declare import,CreateMutexW(pointer lpMutexAttributes,BOOL bInitialOwner, LPCWSTR lpName),HANDLE
declare import,OpenMutexA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,OpenMutexW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,CreateEventA(pointer lpEventAttributes,BOOL bManualReset,BOOL bInitialState, LPCSTR lpName),HANDLE
declare import,CreateEventW(pointer lpEventAttributes,BOOL bManualReset,BOOL bInitialState, LPCWSTR lpName),HANDLE
declare import,OpenEventA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,OpenEventW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,CreateSemaphoreA(pointer lpSemaphoreAttributes,LONG lInitialCount,LONG lMaximumCount, LPCSTR lpName),HANDLE
declare import,CreateSemaphoreW(pointer lpSemaphoreAttributes,LONG lInitialCount,LONG lMaximumCount, LPCWSTR lpName),HANDLE
declare import,OpenSemaphoreA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,OpenSemaphoreW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
$ifdef UNICODE
declare import,CreateMutex alias CreateMutexW(pointer lpMutexAttributes,BOOL bInitialOwner, LPCWSTR lpName),HANDLE
declare import,OpenMutex alias OpenMutexW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,CreateEvent alias CreateEventW(pointer lpEventAttributes,BOOL bManualReset,BOOL bInitialState, LPCWSTR lpName),HANDLE
declare import,OpenEvent alias OpenEventW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,CreateSemaphore alias CreateSemaphoreW(pointer lpSemaphoreAttributes,LONG lInitialCount,LONG lMaximumCount, LPCWSTR lpName),HANDLE
declare import,OpenSemaphore alias OpenSemaphoreW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
$else
declare import,CreateMutex alias CreateMutexA(pointer lpMutexAttributes,BOOL bInitialOwner, LPCSTR lpName),HANDLE
declare import,OpenMutex alias OpenMutexA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,CreateEvent alias CreateEventA(pointer lpEventAttributes,BOOL bManualReset,BOOL bInitialState, LPCSTR lpName),HANDLE
declare import,OpenEvent alias OpenEventA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,CreateSemaphore alias CreateSemaphoreA(pointer lpSemaphoreAttributes,LONG lInitialCount,LONG lMaximumCount, LPCSTR lpName),HANDLE
declare import,OpenSemaphore alias OpenSemaphoreA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
$endif
typedef PTIMERAPCROUTINE int
/*VOID
(pointer PTIMERAPCROUTINE)(LPVOID lpArgToCompletionRoutine,DWORD dwTimerLowValue,DWORD dwTimerHighValue);*/
declare import,CreateWaitableTimerA(pointer lpTimerAttributes,BOOL bManualReset, LPCSTR lpTimerName),HANDLE
declare import,CreateWaitableTimerW(pointer lpTimerAttributes,BOOL bManualReset, LPCWSTR lpTimerName),HANDLE
declare import,OpenWaitableTimerA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpTimerName),HANDLE
declare import,OpenWaitableTimerW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpTimerName),HANDLE
$ifdef UNICODE
declare import,CreateWaitableTimer alias CreateWaitableTimerW(pointer lpTimerAttributes,BOOL bManualReset, LPCWSTR lpTimerName),HANDLE
declare import,OpenWaitableTimer alias OpenWaitableTimerW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpTimerName),HANDLE
$else
declare import,CreateWaitableTimer alias CreateWaitableTimerA(pointer lpTimerAttributes,BOOL bManualReset, LPCSTR lpTimerName),HANDLE
declare import,OpenWaitableTimer alias OpenWaitableTimerA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpTimerName),HANDLE
$endif
declare import,SetWaitableTimer(HANDLE hTimer,pointer lpDueTime,LONG lPeriod, PTIMERAPCROUTINE pfnCompletionRoutine, LPVOID lpArgToCompletionRoutine,BOOL fResume),BOOL
declare import,CancelWaitableTimer(HANDLE hTimer),BOOL
declare import,CreateFileMappingA(HANDLE hFile,pointer lpFileMappingAttributes,DWORD flProtect,DWORD dwMaximumSizeHigh,DWORD dwMaximumSizeLow, LPCSTR lpName),HANDLE
declare import,CreateFileMappingW(HANDLE hFile,pointer lpFileMappingAttributes,DWORD flProtect,DWORD dwMaximumSizeHigh,DWORD dwMaximumSizeLow, LPCWSTR lpName),HANDLE
declare import,OpenFileMappingA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,OpenFileMappingW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,GetLogicalDriveStringsA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,GetLogicalDriveStringsW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
$ifdef UNICODE
declare import,CreateFileMapping alias CreateFileMappingW(HANDLE hFile,pointer lpFileMappingAttributes,DWORD flProtect,DWORD dwMaximumSizeHigh,DWORD dwMaximumSizeLow, LPCWSTR lpName),HANDLE
declare import,OpenFileMapping alias OpenFileMappingW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
declare import,GetLogicalDriveStrings alias GetLogicalDriveStringsW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
$else
declare import,CreateFileMapping alias CreateFileMappingA(HANDLE hFile,pointer lpFileMappingAttributes,DWORD flProtect,DWORD dwMaximumSizeHigh,DWORD dwMaximumSizeLow, LPCSTR lpName),HANDLE
declare import,OpenFileMapping alias OpenFileMappingA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,GetLogicalDriveStrings alias GetLogicalDriveStringsA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
$endif

typedef MEMORY_RESOURCE_NOTIFICATION_TYPE int
$define LowMemoryResourceNotification 0
$define HighMemoryResourceNotification 1
declare import,CreateMemoryResourceNotification(MEMORY_RESOURCE_NOTIFICATION_TYPE NotificationType),HANDLE
declare import,QueryMemoryResourceNotification(HANDLE ResourceNotificationHandle,pointer ResourceState),BOOL
declare import,LoadLibraryA(LPCSTR lpLibFileName),HMODULE
declare import,LoadLibraryW(LPCWSTR lpLibFileName),HMODULE
declare import,LoadLibraryExA(LPCSTR lpLibFileName,HANDLE hFile,DWORD dwFlags),HMODULE
declare import,LoadLibraryExW(LPCWSTR lpLibFileName,HANDLE hFile,DWORD dwFlags),HMODULE
$ifdef UNICODE
declare import,LoadLibrary alias LoadLibraryW(LPCWSTR lpLibFileName),HMODULE
declare import,LoadLibraryEx alias LoadLibraryExW(LPCWSTR lpLibFileName,HANDLE hFile,DWORD dwFlags),HMODULE
$else
declare import,LoadLibrary alias LoadLibraryA(LPCSTR lpLibFileName),HMODULE
declare import,LoadLibraryEx alias LoadLibraryExA(LPCSTR lpLibFileName,HANDLE hFile,DWORD dwFlags),HMODULE
$endif

$define DONT_RESOLVE_DLL_REFERENCES	0x00000001
$define LOAD_LIBRARY_AS_DATAFILE	0x00000002
$define LOAD_WITH_ALTERED_SEARCH_PATH 0x00000008
$define LOAD_IGNORE_CODE_AUTHZ_LEVEL	0x00000010
declare import,GetModuleFileNameA(HMODULE hModule,LPCH lpFilename,DWORD nSize),DWORD
declare import,GetModuleFileNameW(HMODULE hModule,LPWCH lpFilename,DWORD nSize),DWORD
declare import,GetModuleHandleA(LPCSTR lpModuleName),HMODULE
declare import,GetModuleHandleW(LPCWSTR lpModuleName),HMODULE
$ifdef UNICODE
declare import,GetModuleFileName alias GetModuleFileNameW(HMODULE hModule,LPWCH lpFilename,DWORD nSize),DWORD
declare import,GetModuleHandle alias GetModuleHandleW(LPCWSTR lpModuleName),HMODULE
$else
declare import,GetModuleFileName alias GetModuleFileNameA(HMODULE hModule,LPCH lpFilename,DWORD nSize),DWORD
declare import,GetModuleHandle alias GetModuleHandleA(LPCSTR lpModuleName),HMODULE
$endif

$ifndef RC_INVOKED

$define GET_MODULE_HANDLE_EX_FLAG_PIN	(0x00000001)
$define GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT(0x00000002)
$define GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS	(0x00000004)

typedef GET_MODULE_HANDLE_EX int
typedef GET_MODULE_HANDLE_EXA int
typedef GET_MODULE_HANDLE_EXW int
/*(*GET_MODULE_HANDLE_EX*)(DWORD	dwFlags, LPCSTR	lpModuleName,HMODULE*	phModule),BOOL
typedef(*GET_MODULE_HANDLE_EXW*)(DWORD	dwFlags, LPCWSTR	lpModuleName,HMODULE*	phModule),BOOL;*/
declare import,GetModuleHandleExA(DWORD	dwFlags, LPCSTR lpModuleName,pointer phModule),BOOL
declare import,GetModuleHandleExW(DWORD	dwFlags, LPCWSTR lpModuleName,pointer phModule),BOOL
$ifdef UNICODE
declare import,GetModuleHandleEx alias GetModuleHandleExW(DWORD	dwFlags, LPCWSTR lpModuleName,pointer phModule),BOOL
$else
declare import,GetModuleHandleEx alias GetModuleHandleExA(DWORD	dwFlags, LPCSTR lpModuleName,pointer phModule),BOOL
$endif

$endif
declare import,NeedCurrentDirectoryForExePathA(LPCSTR ExeName),BOOL
declare import,NeedCurrentDirectoryForExePathW(LPCWSTR ExeName),BOOL
declare import,CreateProcessA(LPCSTR lpApplicationName,opt LPSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
declare import,CreateProcessW(LPCWSTR lpApplicationName,opt LPWSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$ifdef UNICODE
declare import,NeedCurrentDirectoryForExePath alias NeedCurrentDirectoryForExePathW(LPCWSTR ExeName),BOOL
declare import,CreateProcess alias CreateProcessW(LPCWSTR lpApplicationName,opt LPWSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$else
declare import,NeedCurrentDirectoryForExePath alias NeedCurrentDirectoryForExePathA(LPCSTR ExeName),BOOL
declare import,CreateProcess alias CreateProcessA(LPCSTR lpApplicationName,opt LPSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$endif
declare import,SetProcessShutdownParameters(DWORD dwLevel,DWORD dwFlags),BOOL
declare import,GetProcessShutdownParameters(pointer lpdwLevel,pointer lpdwFlags),BOOL
declare import,GetProcessVersion(DWORD ProcessId),DWORD
declare import,FatalAppExitA(UINT uAction,LPCSTR lpMessageText)
declare import,FatalAppExitW(UINT uAction,LPCWSTR lpMessageText)
declare import,GetStartupInfoA(pointer lpStartupInfo)
declare import,GetStartupInfoW(pointer lpStartupInfo)
declare import,GetCommandLineA(),pointer
declare import,GetCommandLineW(),pointer
declare import,GetEnvironmentVariableA(LPCSTR lpName,LPSTR lpBuffer,DWORD nSize),DWORD
declare import,GetEnvironmentVariableW(LPCWSTR lpName,LPWSTR lpBuffer,DWORD nSize),DWORD
declare import,SetEnvironmentVariableA(LPCSTR lpName, LPCSTR lpValue),BOOL
declare import,SetEnvironmentVariableW(LPCWSTR lpName, LPCWSTR lpValue),BOOL
declare import,ExpandEnvironmentStringsA(LPCSTR lpSrc,LPSTR lpDst,DWORD nSize),DWORD
declare import,ExpandEnvironmentStringsW(LPCWSTR lpSrc,LPWSTR lpDst,DWORD nSize),DWORD
declare import,GetFirmwareEnvironmentVariableA(LPCSTR lpName,LPCSTR lpGuid,PVOID pBuffer,DWORD nSize),DWORD
declare import,GetFirmwareEnvironmentVariableW(LPCWSTR lpName,LPCWSTR lpGuid,PVOID pBuffer,DWORD nSize),DWORD
declare import,SetFirmwareEnvironmentVariableA(LPCSTR lpName,LPCSTR lpGuid,PVOID pValue,DWORD nSize),BOOL
declare import,SetFirmwareEnvironmentVariableW(LPCWSTR lpName,LPCWSTR lpGuid,PVOID pValue,DWORD	nSize),BOOL
declare import,OutputDebugStringA(LPCSTR lpOutputString)
declare import,OutputDebugStringW(LPCWSTR lpOutputString)
declare import,FindResourceA(HMODULE hModule,LPCSTR lpName,LPCSTR lpType),HRSRC
declare import,FindResourceW(HMODULE hModule,LPCWSTR lpName,LPCWSTR lpType),HRSRC
declare import,FindResourceExA(HMODULE hModule,LPCSTR lpType,LPCSTR lpName,USHORT	wLanguage),HRSRC
declare import,FindResourceExW(HMODULE hModule,LPCWSTR lpType,LPCWSTR lpName,USHORT	wLanguage),HRSRC
$ifdef UNICODE
declare import,FatalAppExit alias FatalAppExitW(UINT uAction,LPCWSTR lpMessageText)
declare import,GetStartupInfo alias GetStartupInfoW(pointer lpStartupInfo)
declare import,GetCommandLine alias GetCommandLineW(),pointer
declare import,GetEnvironmentVariable alias GetEnvironmentVariableW(LPCWSTR lpName,LPWSTR lpBuffer,DWORD nSize),DWORD
declare import,SetEnvironmentVariable alias SetEnvironmentVariableW(LPCWSTR lpName, LPCWSTR lpValue),BOOL
declare import,ExpandEnvironmentStrings alias ExpandEnvironmentStringsW(LPCWSTR lpSrc,LPWSTR lpDst,DWORD nSize),DWORD
declare import,GetFirmwareEnvironmentVariable alias GetFirmwareEnvironmentVariableW(LPCWSTR lpName,LPCWSTR lpGuid,PVOID pBuffer,DWORD nSize),DWORD
declare import,SetFirmwareEnvironmentVariable alias SetFirmwareEnvironmentVariableW(LPCWSTR lpName,LPCWSTR lpGuid,PVOID pValue,DWORD	nSize),BOOL
declare import,OutputDebugString alias OutputDebugStringW(LPCWSTR lpOutputString)
declare import,FindResource alias FindResourceW(HMODULE hModule,LPCWSTR lpName,LPCWSTR lpType),HRSRC
declare import,FindResourceEx alias FindResourceExW(HMODULE hModule,LPCWSTR lpType,LPCWSTR lpName,USHORT	wLanguage),HRSRC
$else
declare import,FatalAppExit alias FatalAppExitA(UINT uAction,LPCSTR lpMessageText)
declare import,GetStartupInfo alias GetStartupInfoA(pointer lpStartupInfo)
declare import,GetCommandLine alias GetCommandLineA(),pointer
declare import,GetEnvironmentVariable alias GetEnvironmentVariableA(LPCSTR lpName,LPSTR lpBuffer,DWORD nSize),DWORD
declare import,SetEnvironmentVariable alias SetEnvironmentVariableA(LPCSTR lpName, LPCSTR lpValue),BOOL
declare import,ExpandEnvironmentStrings alias ExpandEnvironmentStringsA(LPCSTR lpSrc,LPSTR lpDst,DWORD nSize),DWORD
declare import,GetFirmwareEnvironmentVariable alias GetFirmwareEnvironmentVariableA(LPCSTR lpName,LPCSTR lpGuid,PVOID pBuffer,DWORD nSize),DWORD
declare import,SetFirmwareEnvironmentVariable alias SetFirmwareEnvironmentVariableA(LPCSTR lpName,LPCSTR lpGuid,PVOID pValue,DWORD nSize),BOOL
declare import,OutputDebugString alias OutputDebugStringA(LPCSTR lpOutputString)
declare import,FindResource alias FindResourceA(HMODULE hModule,LPCSTR lpName,LPCSTR lpType),HRSRC
declare import,FindResourceEx alias FindResourceExA(HMODULE hModule,LPCSTR lpType,LPCSTR lpName,USHORT	wLanguage),HRSRC
$endif

$ifdef STRICT
typedef ENUMRESTYPEPROC int
typedef ENUMRESTYPEPROCW int
'typedef(CALLBACK* ENUMRESTYPEPROC)(__in_opt HMODULE hModule,LPSTR lpType,LONG_PTR lParam),BOOL
'typedef(CALLBACK* ENUMRESTYPEPROCW)(__in_opt HMODULE hModule,LPWSTR lpType,LONG_PTR lParam),BOOL

typedef ENUMRESNAMEPROC int
typedef ENUMRESNAMEPROCW int
'typedef(CALLBACK* ENUMRESNAMEPROC)(__in_opt HMODULE hModule,LPCSTR lpType,LPSTR lpName,LONG_PTR lParam),BOOL
'typedef(CALLBACK* ENUMRESNAMEPROCW)(__in_opt HMODULE hModule,LPCWSTR lpType,LPWSTR lpName,LONG_PTR lParam),BOOL

typedef ENUMRESLANGPROC int
typedef ENUMRESLANGPROCW int
'typedef(CALLBACK* ENUMRESLANGPROC)(__in_opt HMODULE hModule,LPCSTR lpType,LPCSTR lpName,USHORT	wLanguage,LONG_PTR lParam),BOOL
'typedef(CALLBACK* ENUMRESLANGPROCW)(__in_opt HMODULE hModule,LPCWSTR lpType,LPCWSTR lpName,USHORT	wLanguage,LONG_PTR lParam),BOOL

$else
typedef ENUMRESTYPEPROC FARPROC
typedef ENUMRESTYPEPROCA FARPROC
typedef ENUMRESTYPEPROCW FARPROC

typedef ENUMRESNAMEPROC FARPROC
typedef ENUMRESNAMEPROCA FARPROC
typedef ENUMRESNAMEPROCW FARPROC

typedef ENUMRESLANGPROC FARPROC
typedef ENUMRESLANGPROCA FARPROC
typedef ENUMRESLANGPROCW FARPROC

$endif
declare import,EnumResourceTypesA(HMODULE hModule,ENUMRESTYPEPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceTypesW(HMODULE hModule,ENUMRESTYPEPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceNamesA(HMODULE hModule,LPCSTR lpType,ENUMRESNAMEPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceNamesW(HMODULE hModule,LPCWSTR lpType,ENUMRESNAMEPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceLanguagesA(HMODULE hModule,LPCSTR lpType,LPCSTR lpName,ENUMRESLANGPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceLanguagesW(HMODULE hModule,LPCWSTR lpType,LPCWSTR lpName,ENUMRESLANGPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,BeginUpdateResourceA(LPCSTR pFileName,BOOL bDeleteExistingResources),HANDLE
declare import,BeginUpdateResourceW(LPCWSTR pFileName,BOOL bDeleteExistingResources),HANDLE
declare import,UpdateResourceA(HANDLE hUpdate,LPCSTR lpType,LPCSTR lpName,USHORT wLanguage,LPVOID lpData,DWORD cb),BOOL
declare import,UpdateResourceW(HANDLE hUpdate,LPCWSTR lpType,LPCWSTR lpName,USHORT wLanguage,LPVOID lpData,DWORD cb),BOOL
declare import,EndUpdateResourceA(HANDLE hUpdate,BOOL fDiscard),BOOL
declare import,EndUpdateResourceW(HANDLE hUpdate,BOOL fDiscard),BOOL
$ifdef UNICODE
declare import,EnumResourceTypes alias EnumResourceTypesW(HMODULE hModule,ENUMRESTYPEPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceNames alias EnumResourceNamesW(HMODULE hModule,LPCWSTR lpType,ENUMRESNAMEPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceLanguages alias EnumResourceLanguagesW(HMODULE hModule,LPCWSTR lpType,LPCWSTR lpName,ENUMRESLANGPROCW lpEnumFunc,LONG_PTR lParam),BOOL
declare import,BeginUpdateResource alias BeginUpdateResourceW(LPCWSTR pFileName,BOOL bDeleteExistingResources),HANDLE
declare import,UpdateResource alias UpdateResourceW(HANDLE hUpdate,LPCWSTR lpType,LPCWSTR lpName,USHORT wLanguage,LPVOID lpData,DWORD cb),BOOL
declare import,EndUpdateResource alias EndUpdateResourceW(HANDLE hUpdate,BOOL fDiscard),BOOL
$else
declare import,EnumResourceTypes alias EnumResourceTypesA(HMODULE hModule,ENUMRESTYPEPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceNames alias EnumResourceNamesA(HMODULE hModule,LPCSTR lpType,ENUMRESNAMEPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,EnumResourceLanguages alias EnumResourceLanguagesA(HMODULE hModule,LPCSTR lpType,LPCSTR lpName,ENUMRESLANGPROC lpEnumFunc,LONG_PTR lParam),BOOL
declare import,BeginUpdateResource alias BeginUpdateResourceA(LPCSTR pFileName,BOOL bDeleteExistingResources),HANDLE
declare import,UpdateResource alias UpdateResourceA(HANDLE hUpdate,LPCSTR lpType,LPCSTR lpName,USHORT wLanguage,LPVOID lpData,DWORD cb),BOOL
declare import,EndUpdateResource alias EndUpdateResourceA(HANDLE hUpdate,BOOL fDiscard),BOOL
$endif
declare import,GlobalAddAtomA(LPCSTR lpString),ATOM
declare import,GlobalAddAtomW(LPCWSTR lpString),ATOM
declare import,GlobalFindAtomA(LPCSTR lpString),ATOM
declare import,GlobalFindAtomW(LPCWSTR lpString),ATOM
declare import,GlobalGetAtomNameA(ATOM nAtom,LPSTR lpBuffer,int nSize),UINT
declare import,GlobalGetAtomNameW(ATOM nAtom,LPWSTR lpBuffer,int nSize),UINT
declare import,AddAtomA(LPCSTR lpString),ATOM
declare import,AddAtomW(LPCWSTR lpString),ATOM
declare import,FindAtomA(LPCSTR lpString),ATOM
declare import,FindAtomW(LPCWSTR lpString),ATOM
declare import,GetAtomNameA(ATOM nAtom,LPSTR lpBuffer,int nSize),UINT
declare import,GetAtomNameW(ATOM nAtom,LPWSTR lpBuffer,int nSize),UINT
$ifdef UNICODE
declare import,GlobalAddAtom alias GlobalAddAtomW(LPCWSTR lpString),ATOM
declare import,GlobalFindAtom alias GlobalFindAtomW(LPCWSTR lpString),ATOM
declare import,GlobalGetAtomName alias GlobalGetAtomNameW(ATOM nAtom,LPWSTR lpBuffer,int nSize),UINT
declare import,AddAtom alias AddAtomW(LPCWSTR lpString),ATOM
declare import,FindAtom alias FindAtomW(LPCWSTR lpString),ATOM
declare import,GetAtomName alias GetAtomNameW(ATOM nAtom,LPWSTR lpBuffer,int nSize),UINT
$else
declare import,GlobalAddAtom alias GlobalAddAtomA(LPCSTR lpString),ATOM
declare import,GlobalFindAtom alias GlobalFindAtomA(LPCSTR lpString),ATOM
declare import,GlobalGetAtomName alias GlobalGetAtomNameA(ATOM nAtom,LPSTR lpBuffer,int nSize),UINT
declare import,AddAtom alias AddAtomA(LPCSTR lpString),ATOM
declare import,FindAtom alias FindAtomA(LPCSTR lpString),ATOM
declare import,GetAtomName alias GetAtomNameA(ATOM nAtom,LPSTR lpBuffer,int nSize),UINT
$endif
declare import,GetProfileIntA(LPCSTR lpAppName,LPCSTR lpKeyName,INT nDefault),UINT
declare import,GetProfileIntW(LPCWSTR lpAppName,LPCWSTR lpKeyName,INT nDefault),UINT
declare import,GetProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpDefault,LPSTR lpReturnedString,DWORD nSize),DWORD
declare import,GetProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpDefault,LPWSTR lpReturnedString,DWORD nSize),DWORD
declare import,GetProfileSectionA(LPCSTR lpAppName,LPSTR lpReturnedString,DWORD nSize),DWORD
declare import,GetProfileSectionW(LPCWSTR lpAppName,LPWSTR lpReturnedString,DWORD nSize),DWORD
declare import,WriteProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpString),BOOL
declare import,WriteProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpString),BOOL
declare import,WriteProfileSectionA(LPCSTR lpAppName,LPCSTR lpString),BOOL
declare import,WriteProfileSectionW(LPCWSTR lpAppName,LPCWSTR lpString),BOOL
declare import,GetPrivateProfileIntA(LPCSTR lpAppName,LPCSTR lpKeyName,INT nDefault, LPCSTR lpFileName),UINT
declare import,GetPrivateProfileIntW(LPCWSTR lpAppName,LPCWSTR lpKeyName,INT nDefault, LPCWSTR lpFileName),UINT
declare import,GetPrivateProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpDefault,LPSTR lpReturnedString,DWORD nSize, LPCSTR lpFileName),DWORD
declare import,GetPrivateProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpDefault,LPWSTR lpReturnedString,DWORD nSize, LPCWSTR lpFileName),DWORD
declare import,WritePrivateProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpString, LPCSTR lpFileName),BOOL
declare import,WritePrivateProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpString, LPCWSTR lpFileName),BOOL
declare import,GetPrivateProfileSectionA(LPCSTR lpAppName,LPSTR lpReturnedString,DWORD nSize, LPCSTR lpFileName),DWORD
declare import,GetPrivateProfileSectionW(LPCWSTR lpAppName,LPWSTR lpReturnedString,DWORD nSize, LPCWSTR lpFileName),DWORD
declare import,WritePrivateProfileSectionA(LPCSTR lpAppName,LPCSTR lpString, LPCSTR lpFileName),BOOL
declare import,WritePrivateProfileSectionW(LPCWSTR lpAppName,LPCWSTR lpString, LPCWSTR lpFileName),BOOL
declare import,GetPrivateProfileSectionNamesA(LPSTR lpszReturnBuffer,DWORD nSize, LPCSTR lpFileName),DWORD
declare import,GetPrivateProfileSectionNamesW(LPWSTR lpszReturnBuffer,DWORD nSize, LPCWSTR lpFileName),DWORD
declare import,GetPrivateProfileStructA(LPCSTR lpszSection,LPCSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCSTR szFile),BOOL
declare import,GetPrivateProfileStructW(LPCWSTR lpszSection,LPCWSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCWSTR szFile),BOOL
declare import,WritePrivateProfileStructA(LPCSTR lpszSection,LPCSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCSTR szFile),BOOL
declare import,WritePrivateProfileStructW(LPCWSTR lpszSection,LPCWSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCWSTR szFile),BOOL
$ifdef UNICODE
declare import,GetProfileInt alias GetProfileIntW(LPCWSTR lpAppName,LPCWSTR lpKeyName,INT nDefault),UINT
declare import,GetProfileString alias GetProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpDefault,LPWSTR lpReturnedString,DWORD nSize),DWORD
declare import,GetProfileSection alias GetProfileSectionW(LPCWSTR lpAppName,LPWSTR lpReturnedString,DWORD nSize),DWORD
declare import,WriteProfileString alias WriteProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpString),BOOL
declare import,WriteProfileSection alias WriteProfileSectionW(LPCWSTR lpAppName,LPCWSTR lpString),BOOL
declare import,GetPrivateProfileInt alias GetPrivateProfileIntW(LPCWSTR lpAppName,LPCWSTR lpKeyName,INT nDefault, LPCWSTR lpFileName),UINT
declare import,GetPrivateProfileString alias GetPrivateProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpDefault,LPWSTR lpReturnedString,DWORD nSize, LPCWSTR lpFileName),DWORD
declare import,GetPrivateProfileStruct alias GetPrivateProfileStructW(LPCWSTR lpszSection,LPCWSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCWSTR szFile),BOOL
declare import,GetPrivateProfileSection alias GetPrivateProfileSectionW(LPCWSTR lpAppName,LPWSTR lpReturnedString,DWORD nSize, LPCWSTR lpFileName),DWORD
declare import,WritePrivateProfileString alias WritePrivateProfileStringW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPCWSTR lpString, LPCWSTR lpFileName),BOOL
declare import,WritePrivateProfileStruct alias WritePrivateProfileStructW(LPCWSTR lpszSection,LPCWSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCWSTR szFile),BOOL
declare import,WritePrivateProfileSection alias WritePrivateProfileSectionW(LPCWSTR lpAppName,LPCWSTR lpString, LPCWSTR lpFileName),BOOL
declare import,GetPrivateProfileSectionNames alias GetPrivateProfileSectionNamesW(LPWSTR lpszReturnBuffer,DWORD nSize, LPCWSTR lpFileName),DWORD
$else
declare import,GetProfileInt alias GetProfileIntA(LPCSTR lpAppName,LPCSTR lpKeyName,INT nDefault),UINT
declare import,GetProfileString alias GetProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpDefault,LPSTR lpReturnedString,DWORD nSize),DWORD
declare import,GetProfileSection alias GetProfileSectionA(LPCSTR lpAppName,LPSTR lpReturnedString,DWORD nSize),DWORD
declare import,WriteProfileString alias WriteProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpString),BOOL
declare import,WriteProfileSection alias WriteProfileSectionA(LPCSTR lpAppName,LPCSTR lpString),BOOL
declare import,GetPrivateProfileInt alias GetPrivateProfileIntA(LPCSTR lpAppName,LPCSTR lpKeyName,INT nDefault, LPCSTR lpFileName),UINT
declare import,GetPrivateProfileString alias GetPrivateProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpDefault,LPSTR lpReturnedString,DWORD nSize, LPCSTR lpFileName),DWORD
declare import,GetPrivateProfileStruct alias GetPrivateProfileStructA(LPCSTR lpszSection,LPCSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCSTR szFile),BOOL
declare import,GetPrivateProfileSection alias GetPrivateProfileSectionA(LPCSTR lpAppName,LPSTR lpReturnedString,DWORD nSize, LPCSTR lpFileName),DWORD
declare import,WritePrivateProfileString alias WritePrivateProfileStringA(LPCSTR lpAppName, LPCSTR lpKeyName, LPCSTR lpString, LPCSTR lpFileName),BOOL
declare import,WritePrivateProfileStruct alias WritePrivateProfileStructA(LPCSTR lpszSection,LPCSTR lpszKey,LPVOID lpStruct,UINT uSizeStruct, LPCSTR szFile),BOOL
declare import,WritePrivateProfileSection alias WritePrivateProfileSectionA(LPCSTR lpAppName,LPCSTR lpString, LPCSTR lpFileName),BOOL
declare import,GetPrivateProfileSectionNames alias GetPrivateProfileSectionNamesA(LPSTR lpszReturnBuffer,DWORD nSize, LPCSTR lpFileName),DWORD
$endif
declare import,GetDriveTypeA(LPCSTR lpRootPathName),UINT
declare import,GetDriveTypeW(LPCWSTR lpRootPathName),UINT
declare import,GetSystemDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
declare import,GetTempPathA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,GetTempPathW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
declare import,GetTempFileNameA(LPCSTR lpPathName,LPCSTR lpPrefixString,UINT uUnique,LPSTR lpTempFileName),UINT
declare import,GetTempFileNameW(LPCWSTR lpPathName,LPCWSTR lpPrefixString,UINT uUnique,LPWSTR lpTempFileName),UINT
declare import,GetWindowsDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetWindowsDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemWindowsDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemWindowsDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
$ifdef UNICODE
declare import,GetDriveType alias GetDriveTypeW(LPCWSTR lpRootPathName),UINT
declare import,GetSystemDirectory alias GetSystemDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
declare import,GetTempPath alias GetTempPathW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
declare import,GetTempFileName alias GetTempFileNameW(LPCWSTR lpPathName,LPCWSTR lpPrefixString,UINT uUnique,LPWSTR lpTempFileName),UINT
declare import,GetWindowsDirectory alias GetWindowsDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemWindowsDirectory alias GetSystemWindowsDirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
$else
declare import,GetDriveType alias GetDriveTypeA(LPCSTR lpRootPathName),UINT
declare import,GetSystemDirectory alias GetSystemDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetTempPath alias GetTempPathA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,GetTempFileName alias GetTempFileNameA(LPCSTR lpPathName,LPCSTR lpPrefixString,UINT uUnique,LPSTR lpTempFileName),UINT
declare import,GetWindowsDirectory alias GetWindowsDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemWindowsDirectory alias GetSystemWindowsDirectoryA(LPSTR lpBuffer,UINT uSize),UINT
$endif

$ifndef RC_INVOKED ' RC warns because "WINBASE_DECLARE_GET_SYSTEM_WOW64_DIRECTORY" is a bit long.
declare import,GetSystemWow64DirectoryA(LPSTR lpBuffer,UINT uSize),UINT
declare import,GetSystemWow64DirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
$ifdef UNICODE
declare import,GetSystemWow64Directory alias GetSystemWow64DirectoryW(LPWSTR lpBuffer,UINT uSize),UINT
$else
declare import,GetSystemWow64Directory alias GetSystemWow64DirectoryA(LPSTR lpBuffer,UINT uSize),UINT
$endif
declare import,Wow64EnableWow64FsRedirection(BOOLEAN Wow64FsEnableRedirection),BOOL
declare import,Wow64DisableWow64FsRedirection(pointer OldValue),BOOL
declare import,Wow64RevertWow64FsRedirection(PVOID OlValue),BOOL


' for GetProcAddress
typedef PGET_SYSTEM_WOW64_DIRECTORY int
typedef PGET_SYSTEM_WOW64_DIRECTORY_A int
typedef PGET_SYSTEM_WOW64_DIRECTORY_W int
'typedef(* PGET_SYSTEM_WOW64_DIRECTORY_A)(LPSTR lpBuffer,UINT uSize),UINT
'typedef(* PGET_SYSTEM_WOW64_DIRECTORY_W)(LPWSTR lpBuffer,UINT uSize),UINT

' GetProcAddress only accepts GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A,// GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A,GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A.
' The others are if you want to use the strings in some other way.

$define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A	"GetSystemWow64DirectoryA"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_W	L"GetSystemWow64DirectoryA"
'$define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_T TEXT("GetSystemWow64DirectoryA")
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A	"GetSystemWow64DirectoryW"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_W	L"GetSystemWow64DirectoryW"
'$define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_T TEXT("GetSystemWow64DirectoryW")
$ifdef UNICODE
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A	"GetSystemWow64DirectoryW"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_W L"GetSystemWow64DirectoryW"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_T L"GetSystemWow64DirectoryW"
$else
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A	"GetSystemWow64DirectoryA"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_W L"GetSystemWow64DirectoryA"
$define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_T L"GetSystemWow64DirectoryA"
$endif

$endif
declare import,SetCurrentDirectoryA(LPCSTR lpPathName),BOOL
declare import,SetCurrentDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetCurrentDirectoryA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,GetCurrentDirectoryW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
declare import,SetDllDirectoryA(LPCSTR lpPathName),BOOL
declare import,SetDllDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetDllDirectoryA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,GetDllDirectoryW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
$ifdef UNICODE
declare import,SetCurrentDirectory alias SetCurrentDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetCurrentDirectory alias GetCurrentDirectoryW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
declare import,SetDllDirectory alias SetDllDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetDllDirectory alias GetDllDirectoryW(DWORD nBufferLength,LPWSTR lpBuffer),DWORD
$else
declare import,SetCurrentDirectory alias SetCurrentDirectoryA(LPCSTR lpPathName),BOOL
declare import,GetCurrentDirectory alias GetCurrentDirectoryA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
declare import,SetDllDirectory alias SetDllDirectoryA(LPCSTR lpPathName),BOOL
declare import,GetDllDirectory alias GetDllDirectoryA(DWORD nBufferLength,LPSTR lpBuffer),DWORD
$endif
declare import,GetDiskFreeSpaceA(LPCSTR lpRootPathName,pointer lpSectorsPerCluster,pointer lpBytesPerSector,pointer lpNumberOfFreeClusters,pointer lpTotalNumberOfClusters),BOOL
declare import,GetDiskFreeSpaceW(LPCWSTR lpRootPathName,pointer lpSectorsPerCluster,pointer lpBytesPerSector,pointer lpNumberOfFreeClusters,pointer lpTotalNumberOfClusters),BOOL
declare import,GetDiskFreeSpaceExA(LPCSTR lpDirectoryName,pointer lpFreeBytesAvailableToCaller,pointer lpTotalNumberOfBytes,pointer lpTotalNumberOfFreeBytes),BOOL
declare import,GetDiskFreeSpaceExW(LPCWSTR lpDirectoryName,pointer lpFreeBytesAvailableToCaller,pointer lpTotalNumberOfBytes,pointer lpTotalNumberOfFreeBytes),BOOL
declare import,CreateDirectoryA(LPCSTR lpPathName,pointer lpSecurityAttributes),BOOL
declare import,CreateDirectoryW(LPCWSTR lpPathName,pointer lpSecurityAttributes),BOOL
declare import,CreateDirectoryExA(LPCSTR lpTemplateDirectory,LPCSTR lpNewDirectory,pointer lpSecurityAttributes),BOOL
declare import,CreateDirectoryExW(LPCWSTR lpTemplateDirectory,LPCWSTR lpNewDirectory,pointer lpSecurityAttributes),BOOL
declare import,RemoveDirectoryA(LPCSTR lpPathName),BOOL
declare import,RemoveDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetFullPathNameA(LPCSTR lpFileName,DWORD nBufferLength,LPSTR lpBuffer,pointer lpFilePart),DWORD
declare import,GetFullPathNameW(LPCWSTR lpFileName,DWORD nBufferLength,LPWSTR lpBuffer,pointer lpFilePart),DWORD
$ifdef UNICODE
declare import,GetDiskFreeSpace alias GetDiskFreeSpaceW(LPCWSTR lpRootPathName,pointer lpSectorsPerCluster,pointer lpBytesPerSector,pointer lpNumberOfFreeClusters,pointer lpTotalNumberOfClusters),BOOL
declare import,GetDiskFreeSpaceEx alias GetDiskFreeSpaceExW(LPCWSTR lpDirectoryName,pointer lpFreeBytesAvailableToCaller,pointer lpTotalNumberOfBytes,pointer lpTotalNumberOfFreeBytes),BOOL
declare import,CreateDirectory alias CreateDirectoryW(LPCWSTR lpPathName,pointer lpSecurityAttributes),BOOL
declare import,CreateDirectoryEx alias CreateDirectoryExW(LPCWSTR lpTemplateDirectory,LPCWSTR lpNewDirectory,pointer lpSecurityAttributes),BOOL
declare import,RemoveDirectory alias RemoveDirectoryW(LPCWSTR lpPathName),BOOL
declare import,GetFullPathName alias GetFullPathNameW(LPCWSTR lpFileName,DWORD nBufferLength,LPWSTR lpBuffer,pointer lpFilePart),DWORD
$else
declare import,GetDiskFreeSpace alias GetDiskFreeSpaceA(LPCSTR lpRootPathName,pointer lpSectorsPerCluster,pointer lpBytesPerSector,pointer lpNumberOfFreeClusters,pointer lpTotalNumberOfClusters),BOOL
declare import,GetDiskFreeSpaceEx alias GetDiskFreeSpaceExA(LPCSTR lpDirectoryName,pointer lpFreeBytesAvailableToCaller,pointer lpTotalNumberOfBytes,pointer lpTotalNumberOfFreeBytes),BOOL
declare import,CreateDirectory alias CreateDirectoryA(LPCSTR lpPathName,pointer lpSecurityAttributes),BOOL
declare import,CreateDirectoryEx alias CreateDirectoryExA(LPCSTR lpTemplateDirectory,LPCSTR lpNewDirectory,pointer lpSecurityAttributes),BOOL
declare import,RemoveDirectory alias RemoveDirectoryA(LPCSTR lpPathName),BOOL
declare import,GetFullPathName alias GetFullPathNameA(LPCSTR lpFileName,DWORD nBufferLength,LPSTR lpBuffer,pointer lpFilePart),DWORD
$endif

$define DDD_RAW_TARGET_PATH	0x00000001
$define DDD_REMOVE_DEFINITION	0x00000002
$define DDD_EXACT_MATCH_ON_REMOVE	0x00000004
$define DDD_NO_BROADCAST_SYSTEM	0x00000008
$define DDD_LUID_BROADCAST_DRIVE	0x00000010
declare import,DefineDosDeviceA(DWORD dwFlags,LPCSTR lpDeviceName, LPCSTR lpTargetPath),BOOL
declare import,DefineDosDeviceW(DWORD dwFlags,LPCWSTR lpDeviceName, LPCWSTR lpTargetPath),BOOL
declare import,QueryDosDeviceA(LPCSTR lpDeviceName,LPSTR lpTargetPath,DWORD ucchMax),DWORD
declare import,QueryDosDeviceW(LPCWSTR lpDeviceName,LPWSTR lpTargetPath,DWORD ucchMax),DWORD
$ifdef UNICODE
declare import,DefineDosDevice alias DefineDosDeviceW(DWORD dwFlags,LPCWSTR lpDeviceName, LPCWSTR lpTargetPath),BOOL
declare import,QueryDosDevice alias QueryDosDeviceW(LPCWSTR lpDeviceName,LPWSTR lpTargetPath,DWORD ucchMax),DWORD
$else
declare import,DefineDosDevice alias DefineDosDeviceA(DWORD dwFlags,LPCSTR lpDeviceName, LPCSTR lpTargetPath),BOOL
declare import,QueryDosDevice alias QueryDosDeviceA(LPCSTR lpDeviceName,LPSTR lpTargetPath,DWORD ucchMax),DWORD
$endif

$define EXPAND_LOCAL_DRIVES
declare import,CreateFileA(LPCSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,pointer lpSecurityAttributes,DWORD dwCreationDisposition,DWORD dwFlagsAndAttributes, HANDLE hTemplateFile),HANDLE
declare import,CreateFileW(LPCWSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,pointer lpSecurityAttributes,DWORD dwCreationDisposition,DWORD dwFlagsAndAttributes, HANDLE hTemplateFile),HANDLE
declare import,SetFileAttributesA(LPCSTR lpFileName,DWORD dwFileAttributes),BOOL
declare import,SetFileAttributesW(LPCWSTR lpFileName,DWORD dwFileAttributes),BOOL
declare import,GetFileAttributesA(pointer lpFileName),DWORD
declare import,GetFileAttributesW(LPCWSTR lpFileName),DWORD
$ifdef UNICODE
declare import,CreateFile alias CreateFileW(LPCWSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,pointer lpSecurityAttributes,DWORD dwCreationDisposition,DWORD dwFlagsAndAttributes, HANDLE hTemplateFile),HANDLE
declare import,SetFileAttributes alias SetFileAttributesW(LPCWSTR lpFileName,DWORD dwFileAttributes),BOOL
declare import,GetFileAttributes alias GetFileAttributesW(LPCWSTR lpFileName),DWORD
$else
declare import,CreateFile alias CreateFileA(LPCSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,pointer lpSecurityAttributes,DWORD dwCreationDisposition,DWORD dwFlagsAndAttributes, HANDLE hTemplateFile),HANDLE
declare import,SetFileAttributes alias SetFileAttributesA(LPCSTR lpFileName,DWORD dwFileAttributes),BOOL
declare import,GetFileAttributes alias GetFileAttributesA(pointer lpFileName),DWORD
$endif
declare import,ReOpenFile(HANDLE hOriginalFile,DWORD dwDesiredAccess,DWORD dwShareMode,DWORD dwFlagsAndAttributes),HANDLE

typedef GET_FILEEX_INFO_LEVELS int
$define GetFileExInfoStandard 0
$define GetFileExMaxInfoLevel 1
declare import,GetFileAttributesExA(LPCSTR lpFileName,GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation),BOOL
declare import,GetFileAttributesExW(LPCWSTR lpFileName,GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation),BOOL
declare import,GetCompressedFileSizeA(LPCSTR lpFileName,pointer lpFileSizeHigh),DWORD
declare import,GetCompressedFileSizeW(LPCWSTR lpFileName,pointer lpFileSizeHigh),DWORD
declare import,DeleteFileA(LPCSTR lpFileName),BOOL
declare import,DeleteFileW(LPCWSTR lpFileName),BOOL
declare import,CheckNameLegalDOS8Dot3A(LPCSTR lpName,LPSTR lpOemName,DWORD OemNameSize,pointer pbNameContainsSpaces,pointer pbNameLegal),BOOL
declare import,CheckNameLegalDOS8Dot3W(LPCWSTR lpName,LPSTR lpOemName,DWORD OemNameSize,pointer pbNameContainsSpaces,pointer pbNameLegal),BOOL
$ifdef UNICODE
declare import,GetFileAttributesEx alias GetFileAttributesExW(LPCWSTR lpFileName,GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation),BOOL
declare import,GetCompressedFileSize alias GetCompressedFileSizeW(LPCWSTR lpFileName,pointer lpFileSizeHigh),DWORD
'declare import,DeleteFile alias DeleteFileW(LPCWSTR lpFileName),BOOL
declare import,CheckNameLegalDOS8Dot3 alias CheckNameLegalDOS8Dot3W(LPCWSTR lpName,LPSTR lpOemName,DWORD OemNameSize,pointer pbNameContainsSpaces,pointer pbNameLegal),BOOL
$else
declare import,GetFileAttributesEx alias GetFileAttributesExA(LPCSTR lpFileName,GET_FILEEX_INFO_LEVELS fInfoLevelId, LPVOID lpFileInformation),BOOL
declare import,GetCompressedFileSize alias GetCompressedFileSizeA(LPCSTR lpFileName,pointer lpFileSizeHigh),DWORD
'declare import,DeleteFile alias DeleteFileA(LPCSTR lpFileName),BOOL
declare import,CheckNameLegalDOS8Dot3 alias CheckNameLegalDOS8Dot3A(LPCSTR lpName,LPSTR lpOemName,DWORD OemNameSize,pointer pbNameContainsSpaces,pointer pbNameLegal),BOOL
$endif

typedef FINDEX_INFO_LEVELS int
$define FindExInfoStandard 0
$define FindExInfoMaxInfoLevel 1

typedef FINDEX_SEARCH_OPS int
$define FindExSearchNameMatch 0
$define FindExSearchLimitToDirectories 1
$define FindExSearchLimitToDevices 2
$define FindExSearchMaxSearchOp 3

$define FIND_FIRST_EX_CASE_SENSITIVE	0x00000001
declare import,FindFirstFileExA(LPCSTR lpFileName,FINDEX_INFO_LEVELS fInfoLevelId, LPVOID lpFindFileData,FINDEX_SEARCH_OPS fSearchOp,LPVOID lpSearchFilter,DWORD dwAdditionalFlags),HANDLE
declare import,FindFirstFileExW(LPCWSTR lpFileName,FINDEX_INFO_LEVELS fInfoLevelId, LPVOID lpFindFileData,FINDEX_SEARCH_OPS fSearchOp,LPVOID lpSearchFilter,DWORD dwAdditionalFlags),HANDLE
declare import,FindFirstFileA(LPCSTR lpFileName,pointer lpFindFileData),HANDLE
declare import,FindFirstFileW(LPCWSTR lpFileName,pointer lpFindFileData),HANDLE
declare import,FindNextFileA(HANDLE hFindFile,pointer lpFindFileData),BOOL
declare import,FindNextFileW(HANDLE hFindFile,pointer lpFindFileData),BOOL
declare import,SearchPathA(LPCSTR lpPath,LPCSTR lpFileName, LPCSTR lpExtension,DWORD nBufferLength,LPSTR lpBuffer,pointer lpFilePart),DWORD
declare import,SearchPathW(LPCWSTR lpPath,LPCWSTR lpFileName, LPCWSTR lpExtension,DWORD nBufferLength,LPWSTR lpBuffer,pointer lpFilePart),DWORD
declare import,CopyFileA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName,BOOL bFailIfExists),BOOL
declare import,CopyFileW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName,BOOL bFailIfExists),BOOL
$ifdef UNICODE
declare import,FindFirstFileEx alias FindFirstFileExW(LPCWSTR lpFileName,FINDEX_INFO_LEVELS fInfoLevelId, LPVOID lpFindFileData,FINDEX_SEARCH_OPS fSearchOp,LPVOID lpSearchFilter,DWORD dwAdditionalFlags),HANDLE
declare import,FindFirstFile alias FindFirstFileW(LPCWSTR lpFileName,pointer lpFindFileData),HANDLE
declare import,FindNextFile alias FindNextFileW(HANDLE hFindFile,pointer lpFindFileData),BOOL
declare import,SearchPath alias SearchPathW(LPCWSTR lpPath,LPCWSTR lpFileName, LPCWSTR lpExtension,DWORD nBufferLength,LPWSTR lpBuffer,pointer lpFilePart),DWORD
'declare import,CopyFile alias CopyFileW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName,BOOL bFailIfExists),BOOL
$else
declare import,FindFirstFileEx alias FindFirstFileExA(LPCSTR lpFileName,FINDEX_INFO_LEVELS fInfoLevelId, LPVOID lpFindFileData,FINDEX_SEARCH_OPS fSearchOp,LPVOID lpSearchFilter,DWORD dwAdditionalFlags),HANDLE
declare import,FindFirstFile alias FindFirstFileA(LPCSTR lpFileName,pointer lpFindFileData),HANDLE
declare import,FindNextFile alias FindNextFileA(HANDLE hFindFile,pointer lpFindFileData),BOOL
declare import,SearchPath alias SearchPathA(LPCSTR lpPath,LPCSTR lpFileName, LPCSTR lpExtension,DWORD nBufferLength,LPSTR lpBuffer,pointer lpFilePart),DWORD
'declare import,CopyFile alias CopyFileA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName,BOOL bFailIfExists),BOOL
$endif


typedef LPPROGRESS_ROUTINE int
/*(*LPPROGRESS_ROUTINE)(LARGE_INTEGER TotalFileSize,LARGE_INTEGER TotalBytesTransferred,LARGE_INTEGER StreamSize,LARGE_INTEGER StreamBytesTransferred,DWORD dwStreamNumber,DWORD dwCallbackReason,HANDLE hSourceFile,HANDLE hDestinationFile, LPVOID lpData),DWORD;*/
declare import,CopyFileExA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,pointer pbCancel,DWORD dwCopyFlags),BOOL
declare import,CopyFileExW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,pointer pbCancel,DWORD dwCopyFlags),BOOL
declare import,MoveFileA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName),BOOL
declare import,MoveFileW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName),BOOL
declare import,MoveFileExA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName,DWORD dwFlags),BOOL
declare import,MoveFileExW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName,DWORD dwFlags),BOOL
declare import,MoveFileWithProgressA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,DWORD dwFlags),BOOL
declare import,MoveFileWithProgressW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,DWORD dwFlags),BOOL
$ifdef UNICODE
declare import,CopyFileEx alias CopyFileExW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,pointer pbCancel,DWORD dwCopyFlags),BOOL
declare import,MoveFile alias MoveFileW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName),BOOL
declare import,MoveFileEx alias MoveFileExW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName,DWORD dwFlags),BOOL
declare import,MoveFileWithProgress alias MoveFileWithProgressW(LPCWSTR lpExistingFileName,LPCWSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,DWORD dwFlags),BOOL
$else
declare import,CopyFileEx alias CopyFileExA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,pointer pbCancel,DWORD dwCopyFlags),BOOL
declare import,MoveFile alias MoveFileA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName),BOOL
declare import,MoveFileEx alias MoveFileExA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName,DWORD dwFlags),BOOL
declare import,MoveFileWithProgress alias MoveFileWithProgressA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName, LPPROGRESS_ROUTINE lpProgressRoutine, LPVOID lpData,DWORD dwFlags),BOOL
$endif

$define MOVEFILE_REPLACE_EXISTING	0x00000001
$define MOVEFILE_COPY_ALLOWED	0x00000002
$define MOVEFILE_DELAY_UNTIL_REBOOT	0x00000004
$define MOVEFILE_WRITE_THROUGH	0x00000008
$define MOVEFILE_CREATE_HARDLINK	0x00000010
$define MOVEFILE_FAIL_IF_NOT_TRACKABLE	0x00000020
declare import,ReplaceFileA(LPCSTR lpReplacedFileName,LPCSTR lpReplacementFileName, LPCSTR lpBackupFileName,DWORD dwReplaceFlags,LPVOID lpExclude,LPVOID lpReserved),BOOL
declare import,ReplaceFileW(LPCWSTR lpReplacedFileName,LPCWSTR lpReplacementFileName, LPCWSTR lpBackupFileName,DWORD	dwReplaceFlags,LPVOID lpExclude,LPVOID lpReserved),BOOL
' API call to create hard links.
declare import,CreateHardLinkA(LPCSTR lpFileName,LPCSTR lpExistingFileName,pointer lpSecurityAttributes),BOOL
declare import,CreateHardLinkW(LPCWSTR lpFileName,LPCWSTR lpExistingFileName,pointer lpSecurityAttributes),BOOL
$ifdef UNICODE
declare import,ReplaceFile alias ReplaceFileW(LPCWSTR lpReplacedFileName,LPCWSTR lpReplacementFileName, LPCWSTR lpBackupFileName,DWORD	dwReplaceFlags,LPVOID lpExclude,LPVOID lpReserved),BOOL
declare import,CreateHardLink alias CreateHardLinkW(LPCWSTR lpFileName,LPCWSTR lpExistingFileName,pointer lpSecurityAttributes),BOOL
$else
declare import,ReplaceFile alias ReplaceFileA(LPCSTR lpReplacedFileName,LPCSTR lpReplacementFileName, LPCSTR lpBackupFileName,DWORD dwReplaceFlags,LPVOID lpExclude,LPVOID lpReserved),BOOL
declare import,CreateHardLink alias CreateHardLinkA(LPCSTR lpFileName,LPCSTR lpExistingFileName,pointer lpSecurityAttributes),BOOL
$endif

' API call to enumerate for streams within a file

typedef STREAM_INFO_LEVELS int

$define FindStreamInfoStandard 0
$define FindStreamInfoMaxInfoLevel 1

type WIN32_FIND_STREAM_DATA
	LARGE_INTEGER StreamSize
	iwstring cStreamName[ MAX_PATH + 36 ]
endtype
declare import,FindFirstStreamW(LPCWSTR lpFileName,STREAM_INFO_LEVELS InfoLevel, LPVOID lpFindStreamData,DWORD dwFlags),HANDLE
declare import,FindNextStreamW(HANDLE hFindStream, LPVOID lpFindStreamData),BOOL
declare import,CreateNamedPipeA(LPCSTR lpName,DWORD dwOpenMode,DWORD dwPipeMode,DWORD nMaxInstances,DWORD nOutBufferSize,DWORD nInBufferSize,DWORD nDefaultTimeOut,pointer lpSecurityAttributes),HANDLE
declare import,CreateNamedPipeW(LPCWSTR lpName,DWORD dwOpenMode,DWORD dwPipeMode,DWORD nMaxInstances,DWORD nOutBufferSize,DWORD nInBufferSize,DWORD nDefaultTimeOut,pointer lpSecurityAttributes),HANDLE
declare import,GetNamedPipeHandleStateA(HANDLE hNamedPipe,pointer lpState,pointer lpCurInstances,pointer lpMaxCollectionCount,pointer lpCollectDataTimeout,LPSTR lpUserName,DWORD nMaxUserNameSize),BOOL
declare import,GetNamedPipeHandleStateW(HANDLE hNamedPipe,pointer lpState,pointer lpCurInstances,pointer lpMaxCollectionCount,pointer lpCollectDataTimeout,LPWSTR lpUserName,DWORD nMaxUserNameSize),BOOL
declare import,CallNamedPipeA(LPCSTR lpNamedPipeName,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesRead,DWORD nTimeOut),BOOL
declare import,CallNamedPipeW(LPCWSTR lpNamedPipeName,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesRead,DWORD nTimeOut),BOOL
declare import,WaitNamedPipeA(LPCSTR lpNamedPipeName,DWORD nTimeOut),BOOL
declare import,WaitNamedPipeW(LPCWSTR lpNamedPipeName,DWORD nTimeOut),BOOL
declare import,SetVolumeLabelA(LPCSTR lpRootPathName, LPCSTR lpVolumeName),BOOL
declare import,SetVolumeLabelW(LPCWSTR lpRootPathName, LPCWSTR lpVolumeName),BOOL
declare import,GetVolumeInformationA(LPCSTR lpRootPathName,LPSTR lpVolumeNameBuffer,DWORD nVolumeNameSize,pointer lpVolumeSerialNumber,pointer lpMaximumComponentLength,pointer lpFileSystemFlags,LPSTR lpFileSystemNameBuffer,DWORD nFileSystemNameSize),BOOL
declare import,GetVolumeInformationW(LPCWSTR lpRootPathName,LPWSTR lpVolumeNameBuffer,DWORD nVolumeNameSize,pointer lpVolumeSerialNumber,pointer lpMaximumComponentLength,pointer lpFileSystemFlags,LPWSTR lpFileSystemNameBuffer,DWORD nFileSystemNameSize),BOOL
$ifdef UNICODE
declare import,CreateNamedPipe alias CreateNamedPipeW(LPCWSTR lpName,DWORD dwOpenMode,DWORD dwPipeMode,DWORD nMaxInstances,DWORD nOutBufferSize,DWORD nInBufferSize,DWORD nDefaultTimeOut,pointer lpSecurityAttributes),HANDLE
declare import,GetNamedPipeHandleState alias GetNamedPipeHandleStateW(HANDLE hNamedPipe,pointer lpState,pointer lpCurInstances,pointer lpMaxCollectionCount,pointer lpCollectDataTimeout,LPWSTR lpUserName,DWORD nMaxUserNameSize),BOOL
declare import,CallNamedPipe alias CallNamedPipeW(LPCWSTR lpNamedPipeName,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesRead,DWORD nTimeOut),BOOL
declare import,WaitNamedPipe alias WaitNamedPipeW(LPCWSTR lpNamedPipeName,DWORD nTimeOut),BOOL
declare import,SetVolumeLabel alias SetVolumeLabelW(LPCWSTR lpRootPathName, LPCWSTR lpVolumeName),BOOL
declare import,GetVolumeInformation alias GetVolumeInformationW(LPCWSTR lpRootPathName,LPWSTR lpVolumeNameBuffer,DWORD nVolumeNameSize,pointer lpVolumeSerialNumber,pointer lpMaximumComponentLength,pointer lpFileSystemFlags,LPWSTR lpFileSystemNameBuffer,DWORD nFileSystemNameSize),BOOL
$else
declare import,CreateNamedPipe alias CreateNamedPipeA(LPCSTR lpName,DWORD dwOpenMode,DWORD dwPipeMode,DWORD nMaxInstances,DWORD nOutBufferSize,DWORD nInBufferSize,DWORD nDefaultTimeOut,pointer lpSecurityAttributes),HANDLE
declare import,GetNamedPipeHandleState alias GetNamedPipeHandleStateA(HANDLE hNamedPipe,pointer lpState,pointer lpCurInstances,pointer lpMaxCollectionCount,pointer lpCollectDataTimeout,LPSTR lpUserName,DWORD nMaxUserNameSize),BOOL
declare import,CallNamedPipe alias CallNamedPipeA(LPCSTR lpNamedPipeName,LPVOID lpInBuffer,DWORD nInBufferSize,LPVOID lpOutBuffer,DWORD nOutBufferSize,pointer lpBytesRead,DWORD nTimeOut),BOOL
declare import,WaitNamedPipe alias WaitNamedPipeA(LPCSTR lpNamedPipeName,DWORD nTimeOut),BOOL
declare import,SetVolumeLabel alias SetVolumeLabelA(LPCSTR lpRootPathName, LPCSTR lpVolumeName),BOOL
declare import,GetVolumeInformation alias GetVolumeInformationA(LPCSTR lpRootPathName,LPSTR lpVolumeNameBuffer,DWORD nVolumeNameSize,pointer lpVolumeSerialNumber,pointer lpMaximumComponentLength,pointer lpFileSystemFlags,LPSTR lpFileSystemNameBuffer,DWORD nFileSystemNameSize),BOOL
$endif
declare import,SetFileApisToOEM()
declare import,SetFileApisToANSI()
declare import,AreFileApisANSI(),BOOL
declare import,CancelIo(HANDLE hFile),BOOL

' Event logging APIs
declare import,CloseEventLog(HANDLE hEventLog),BOOL
declare import,DeregisterEventSource(HANDLE hEventLog),BOOL
declare import,NotifyChangeEventLog(HANDLE	hEventLog,HANDLE	hEvent),BOOL
declare import,GetNumberOfEventLogRecords(HANDLE hEventLog,pointer NumberOfRecords),BOOL
declare import,GetOldestEventLogRecord(HANDLE hEventLog,pointer OldestRecord),BOOL
declare import,GetEventLogInformation(HANDLE hEventLog,DWORD dwInfoLevel,LPVOID lpBuffer,DWORD cbBufSize,pointer pcbBytesNeeded),BOOL
declare import,ClearEventLogA(HANDLE hEventLog, LPCSTR lpBackupFileName),BOOL
declare import,ClearEventLogW(HANDLE hEventLog, LPCWSTR lpBackupFileName),BOOL
declare import,BackupEventLogA(HANDLE hEventLog,LPCSTR lpBackupFileName),BOOL
declare import,BackupEventLogW(HANDLE hEventLog,LPCWSTR lpBackupFileName),BOOL
declare import,OpenEventLogA(LPCSTR lpUNCServerName,LPCSTR lpSourceName),HANDLE
declare import,OpenEventLogW(LPCWSTR lpUNCServerName,LPCWSTR lpSourceName),HANDLE
declare import,RegisterEventSourceA(LPCSTR lpUNCServerName,LPCSTR lpSourceName),HANDLE
declare import,RegisterEventSourceW(LPCWSTR lpUNCServerName,LPCWSTR lpSourceName),HANDLE
declare import,OpenBackupEventLogA(LPCSTR lpUNCServerName,LPCSTR lpFileName),HANDLE
declare import,OpenBackupEventLogW(LPCWSTR lpUNCServerName,LPCWSTR lpFileName),HANDLE
declare import,ReadEventLogA(HANDLE hEventLog,DWORD dwReadFlags,DWORD dwRecordOffset,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer pnBytesRead,pointer pnMinNumberOfBytesNeeded),BOOL
declare import,ReadEventLogW(HANDLE hEventLog,DWORD dwReadFlags,DWORD dwRecordOffset,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer pnBytesRead,pointer pnMinNumberOfBytesNeeded),BOOL
declare import,ReportEventA(HANDLE hEventLog,USHORT wType,USHORT wCategory,DWORD dwEventID,pointer lpUserSid,USHORT wNumStrings,DWORD dwDataSize,pointer lpStrings,LPVOID lpRawData),BOOL
declare import,ReportEventW(HANDLE hEventLog,USHORT wType,USHORT wCategory,DWORD dwEventID,pointer lpUserSid,USHORT wNumStrings,DWORD dwDataSize,pointer lpStrings,LPVOID lpRawData),BOOL
$ifdef UNICODE
declare import,ClearEventLog alias ClearEventLogW(HANDLE hEventLog, LPCWSTR lpBackupFileName),BOOL
declare import,BackupEventLog alias BackupEventLogW(HANDLE hEventLog,LPCWSTR lpBackupFileName),BOOL
declare import,OpenEventLog alias OpenEventLogW(LPCWSTR lpUNCServerName,LPCWSTR lpSourceName),HANDLE
declare import,RegisterEventSource alias RegisterEventSourceW(LPCWSTR lpUNCServerName,LPCWSTR lpSourceName),HANDLE
declare import,OpenBackupEventLog alias OpenBackupEventLogW(LPCWSTR lpUNCServerName,LPCWSTR lpFileName),HANDLE
declare import,ReadEventLog alias ReadEventLogW(HANDLE hEventLog,DWORD dwReadFlags,DWORD dwRecordOffset,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer pnBytesRead,pointer pnMinNumberOfBytesNeeded),BOOL
declare import,ReportEvent alias ReportEventA(HANDLE hEventLog,USHORT wType,USHORT wCategory,DWORD dwEventID,pointer lpUserSid,USHORT wNumStrings,DWORD dwDataSize,pointer lpStrings,LPVOID lpRawData),BOOL
$else
declare import,ClearEventLog alias ClearEventLogA(HANDLE hEventLog, LPCSTR lpBackupFileName),BOOL
declare import,BackupEventLog alias BackupEventLogA(HANDLE hEventLog,LPCSTR lpBackupFileName),BOOL
declare import,OpenEventLog alias OpenEventLogA(LPCSTR lpUNCServerName,LPCSTR lpSourceName),HANDLE
declare import,RegisterEventSource alias RegisterEventSourceA(LPCSTR lpUNCServerName,LPCSTR lpSourceName),HANDLE
declare import,OpenBackupEventLog alias OpenBackupEventLogA(LPCSTR lpUNCServerName,LPCSTR lpFileName),HANDLE
declare import,ReadEventLog alias ReadEventLogA(HANDLE hEventLog,DWORD dwReadFlags,DWORD dwRecordOffset,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,pointer pnBytesRead,pointer pnMinNumberOfBytesNeeded),BOOL
declare import,ReportEvent alias ReportEventA(HANDLE hEventLog,USHORT wType,USHORT wCategory,DWORD dwEventID,pointer lpUserSid,USHORT wNumStrings,DWORD dwDataSize,pointer lpStrings,LPVOID lpRawData),BOOL
$endif

$define EVENTLOG_FULL_INFO	0

type EVENTLOG_FULL_INFORMATION
	DWORD	dwFull
endtype

' Security APIs
declare import,DuplicateToken(HANDLE ExistingTokenHandle,SECURITY_IMPERSONATION_LEVEL ImpersonationLevel,pointer DuplicateTokenHandle),BOOL
declare import,GetKernelObjectSecurity(HANDLE Handle,SECURITY_INFORMATION RequestedInformation,pointer pSecurityDescriptor,DWORD nLength,pointer lpnLengthNeeded),BOOL
declare import,ImpersonateNamedPipeClient(HANDLE hNamedPipe),BOOL
declare import,ImpersonateSelf(SECURITY_IMPERSONATION_LEVEL ImpersonationLevel),BOOL
declare import,RevertToSelf(),BOOL
declare import,SetThreadToken(pointer Thread, HANDLE Token),BOOL
declare import,AccessCheck(pointer pSecurityDescriptor,HANDLE ClientToken,DWORD DesiredAccess,pointer GenericMapping,pointer PrivilegeSet,pointer PrivilegeSetLength,pointer GrantedAccess,pointer AccessStatus),BOOL
declare import,AccessCheckByType(pointer pSecurityDescriptor,pointer PrincipalSelfSid,HANDLE ClientToken,DWORD DesiredAccess,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,pointer PrivilegeSet,pointer PrivilegeSetLength,pointer GrantedAccess,pointer AccessStatus),BOOL
declare import,AccessCheckByTypeResultList(pointer pSecurityDescriptor,pointer PrincipalSelfSid,HANDLE ClientToken,DWORD DesiredAccess,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,pointer PrivilegeSet,pointer PrivilegeSetLength,pointer GrantedAccessList,pointer AccessStatusList),BOOL
declare import,OpenProcessToken(HANDLE ProcessHandle,DWORD DesiredAccess,pointer TokenHandle),BOOL
declare import,OpenThreadToken(HANDLE ThreadHandle,DWORD DesiredAccess,BOOL OpenAsSelf,pointer TokenHandle),BOOL
declare import,GetTokenInformation(HANDLE TokenHandle,TOKEN_INFORMATION_CLASS TokenInformationClass,LPVOID TokenInformation,DWORD TokenInformationLength,pointer ReturnLength),BOOL
declare import,SetTokenInformation(HANDLE TokenHandle,TOKEN_INFORMATION_CLASS TokenInformationClass,LPVOID TokenInformation,DWORD TokenInformationLength),BOOL
declare import,AdjustTokenPrivileges(HANDLE TokenHandle,BOOL DisableAllPrivileges,pointer NewState,DWORD BufferLength,pointer PreviousState,pointer ReturnLength),BOOL
declare import,AdjustTokenGroups(HANDLE TokenHandle,BOOL ResetToDefault,pointer NewState,DWORD BufferLength,pointer PreviousState,pointer ReturnLength),BOOL
declare import,PrivilegeCheck(HANDLE ClientToken,pointer RequiredPrivileges,pointer pfResult),BOOL

declare import,AccessCheckAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPSTR ObjectTypeName, LPSTR ObjectName,pointer SecurityDescriptor,DWORD DesiredAccess,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPWSTR ObjectTypeName, LPWSTR ObjectName,pointer SecurityDescriptor,DWORD DesiredAccess,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmByHandleA(LPCSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmByHandleW(LPCWSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,ObjectOpenAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPSTR ObjectTypeName, LPSTR ObjectName,pointer pSecurityDescriptor,HANDLE ClientToken,DWORD DesiredAccess,DWORD GrantedAccess,pointer Privileges,BOOL ObjectCreation,BOOL AccessGranted,pointer GenerateOnClose),BOOL
declare import,ObjectOpenAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPWSTR ObjectTypeName, LPWSTR ObjectName,pointer pSecurityDescriptor,HANDLE ClientToken,DWORD DesiredAccess,DWORD GrantedAccess,pointer Privileges,BOOL ObjectCreation,BOOL AccessGranted,pointer GenerateOnClose),BOOL
declare import,ObjectPrivilegeAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,DWORD DesiredAccess,pointer Privileges,BOOL AccessGranted),BOOL
declare import,ObjectPrivilegeAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,DWORD DesiredAccess,pointer Privileges,BOOL AccessGranted),BOOL
declare import,ObjectCloseAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,ObjectCloseAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,ObjectDeleteAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,ObjectDeleteAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,PrivilegedServiceAuditAlarmA(LPCSTR SubsystemName,LPCSTR ServiceName,HANDLE ClientToken,pointer Privileges,BOOL AccessGranted),BOOL
declare import,PrivilegedServiceAuditAlarmW(LPCWSTR SubsystemName,LPCWSTR ServiceName,HANDLE ClientToken,pointer Privileges,BOOL AccessGranted),BOOL
$ifdef UNICODE
declare import,AccessCheckAndAuditAlarm alias AccessCheckAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPWSTR ObjectTypeName, LPWSTR ObjectName,pointer SecurityDescriptor,DWORD DesiredAccess,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeAndAuditAlarm alias AccessCheckByTypeAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarm alias AccessCheckByTypeResultListAndAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmByHandle alias AccessCheckByTypeResultListAndAuditAlarmByHandleW(LPCWSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,LPCWSTR ObjectTypeName, LPCWSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,ObjectOpenAuditAlarm alias ObjectOpenAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,LPWSTR ObjectTypeName, LPWSTR ObjectName,pointer pSecurityDescriptor,HANDLE ClientToken,DWORD DesiredAccess,DWORD GrantedAccess,pointer Privileges,BOOL ObjectCreation,BOOL AccessGranted,pointer GenerateOnClose),BOOL
declare import,ObjectPrivilegeAuditAlarm alias ObjectPrivilegeAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,DWORD DesiredAccess,pointer Privileges,BOOL AccessGranted),BOOL
declare import,ObjectCloseAuditAlarm alias ObjectCloseAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,ObjectDeleteAuditAlarm alias ObjectDeleteAuditAlarmW(LPCWSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,PrivilegedServiceAuditAlarm alias PrivilegedServiceAuditAlarmW(LPCWSTR SubsystemName,LPCWSTR ServiceName,HANDLE ClientToken,pointer Privileges,BOOL AccessGranted),BOOL
$else
declare import,AccessCheckAndAuditAlarm alias AccessCheckAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPSTR ObjectTypeName, LPSTR ObjectName,pointer SecurityDescriptor,DWORD DesiredAccess,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeAndAuditAlarm alias AccessCheckByTypeAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatus,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarm alias AccessCheckByTypeResultListAndAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,AccessCheckByTypeResultListAndAuditAlarmByHandle alias AccessCheckByTypeResultListAndAuditAlarmByHandleA(LPCSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,LPCSTR ObjectTypeName, LPCSTR ObjectName,pointer SecurityDescriptor,pointer PrincipalSelfSid,DWORD DesiredAccess,AUDIT_EVENT_TYPE AuditType,DWORD Flags,pointer ObjectTypeList,DWORD ObjectTypeListLength,pointer GenericMapping,BOOL ObjectCreation,pointer GrantedAccess,pointer AccessStatusList,pointer pfGenerateOnClose),BOOL
declare import,ObjectOpenAuditAlarm alias ObjectOpenAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,LPSTR ObjectTypeName, LPSTR ObjectName,pointer pSecurityDescriptor,HANDLE ClientToken,DWORD DesiredAccess,DWORD GrantedAccess,pointer Privileges,BOOL ObjectCreation,BOOL AccessGranted,pointer GenerateOnClose),BOOL
declare import,ObjectPrivilegeAuditAlarm alias ObjectPrivilegeAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,HANDLE ClientToken,DWORD DesiredAccess,pointer Privileges,BOOL AccessGranted),BOOL
declare import,ObjectCloseAuditAlarm alias ObjectCloseAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,ObjectDeleteAuditAlarm alias ObjectDeleteAuditAlarmA(LPCSTR SubsystemName,LPVOID HandleId,BOOL GenerateOnClose),BOOL
declare import,PrivilegedServiceAuditAlarm alias PrivilegedServiceAuditAlarmA(LPCSTR SubsystemName,LPCSTR ServiceName,HANDLE ClientToken,pointer Privileges,BOOL AccessGranted),BOOL
$endif
declare import,IsWellKnownSid(pointer pSid,WELL_KNOWN_SID_TYPE WellKnownSidType),BOOL
declare import,CreateWellKnownSid(WELL_KNOWN_SID_TYPE WellKnownSidType,pointer DomainSid,pointer pSid,pointer cbSid),BOOL
declare import,EqualDomainSid(pointer pSid1,pointer pSid2,pointer pfEqual),BOOL
declare import,GetWindowsAccountDomainSid(pointer pSid,pointer pDomainSid,pointer cbDomainSid),BOOL
declare import,IsValidSid(pointer pSid),BOOL
declare import,EqualSid(pointer pSid1,pointer pSid2),BOOL
declare import,EqualPrefixSid(pointer pSid1,pointer pSid2),BOOL
declare import,GetSidLengthRequired(UCHAR nSubAuthorityCount),DWORD
declare import,AllocateAndInitializeSid(pointer pIdentifierAuthority,BYTE nSubAuthorityCount,DWORD nSubAuthority0,DWORD nSubAuthority1,DWORD nSubAuthority2,DWORD nSubAuthority3,DWORD nSubAuthority4,DWORD nSubAuthority5,DWORD nSubAuthority6,DWORD nSubAuthority7,pointer pSid),BOOL
declare import,FreeSid(pointer pSid),PVOID
declare import,InitializeSid(pointer Sid,pointer pIdentifierAuthority,BYTE nSubAuthorityCount),BOOL
declare import,GetSidIdentifierAuthority(pointer pSid),pointer'SID_IDENTIFIER_AUTHORITY*
declare import,GetSidSubAuthority(pointer pSid,DWORD nSubAuthority),pointer'pointer
declare import,GetSidSubAuthorityCount(pointer pSid),pointer'pointer
declare import,GetLengthSid(pointer pSid),DWORD
declare import,CopySid(DWORD nDestinationSidLength,pointer pDestinationSid,pointer pSourceSid),BOOL
declare import,AreAllAccessesGranted(DWORD GrantedAccess,DWORD DesiredAccess),BOOL
declare import,AreAnyAccessesGranted(DWORD GrantedAccess,DWORD DesiredAccess),BOOL
declare import,MapGenericMask(pointer AccessMask,pointer GenericMapping)
declare import,IsValidAcl(pointer pAcl),BOOL
declare import,InitializeAcl(pointer pAcl,DWORD nAclLength,DWORD dwAclRevision),BOOL
declare import,GetAclInformation(pointer pAcl,LPVOID pAclInformation,DWORD nAclInformationLength,ACL_INFORMATION_CLASS dwAclInformationClass),BOOL
declare import,SetAclInformation(pointer pAcl,LPVOID pAclInformation,DWORD nAclInformationLength,ACL_INFORMATION_CLASS dwAclInformationClass),BOOL
declare import,AddAce(pointer pAcl,DWORD dwAceRevision,DWORD dwStartingAceIndex,LPVOID pAceList,DWORD nAceListLength),BOOL
declare import,DeleteAce(pointer pAcl,DWORD dwAceIndex),BOOL
declare import,GetAce(pointer pAcl,DWORD dwAceIndex,pointer pAce),BOOL
declare import,AddAccessAllowedAce(pointer pAcl,DWORD dwAceRevision,DWORD AccessMask,pointer pSid),BOOL
declare import,AddAccessAllowedAceEx(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD AccessMask,pointer pSid),BOOL
declare import,AddAccessDeniedAce(pointer pAcl,DWORD dwAceRevision,DWORD AccessMask,pointer pSid),BOOL
declare import,AddAccessDeniedAceEx(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD AccessMask,pointer pSid),BOOL
declare import,AddAuditAccessAce(pointer pAcl,DWORD dwAceRevision,DWORD dwAccessMask,pointer pSid,BOOL bAuditSuccess,BOOL bAuditFailure),BOOL
declare import,AddAuditAccessAceEx(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD dwAccessMask,pointer pSid,BOOL bAuditSuccess,BOOL bAuditFailure),BOOL
declare import,AddAccessAllowedObjectAce(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD AccessMask,pointer ObjectTypeGuid,pointer InheritedObjectTypeGuid,pointer pSid),BOOL
declare import,AddAccessDeniedObjectAce(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD AccessMask,pointer ObjectTypeGuid,pointer InheritedObjectTypeGuid,pointer pSid),BOOL
declare import,AddAuditAccessObjectAce(pointer pAcl,DWORD dwAceRevision,DWORD AceFlags,DWORD AccessMask,pointer ObjectTypeGuid,pointer InheritedObjectTypeGuid,pointer pSid,BOOL bAuditSuccess,BOOL bAuditFailure),BOOL
declare import,FindFirstFreeAce(pointer pAcl,pointer pAce),BOOL
declare import,InitializeSecurityDescriptor(pointer pSecurityDescriptor,DWORD dwRevision),BOOL
declare import,IsValidSecurityDescriptor(pointer pSecurityDescriptor),BOOL
declare import,GetSecurityDescriptorLength(pointer pSecurityDescriptor),DWORD
declare import,GetSecurityDescriptorControl(pointer pSecurityDescriptor,pointer pControl,pointer lpdwRevision),BOOL
declare import,SetSecurityDescriptorControl(pointer pSecurityDescriptor,SECURITY_DESCRIPTOR_CONTROL ControlBitsOfInterest,SECURITY_DESCRIPTOR_CONTROL ControlBitsToSet),BOOL
declare import,SetSecurityDescriptorDacl(pointer pSecurityDescriptor,BOOL bDaclPresent,pointer pDacl,BOOL bDaclDefaulted),BOOL
declare import,GetSecurityDescriptorDacl(pointer pSecurityDescriptor,pointer lpbDaclPresent,pointer pDacl,pointer lpbDaclDefaulted),BOOL
declare import,SetSecurityDescriptorSacl(pointer pSecurityDescriptor,BOOL bSaclPresent,pointer pSacl,BOOL bSaclDefaulted),BOOL
declare import,GetSecurityDescriptorSacl(pointer pSecurityDescriptor,pointer lpbSaclPresent,pointer pSacl,pointer lpbSaclDefaulted),BOOL
declare import,SetSecurityDescriptorOwner(pointer pSecurityDescriptor,pointer pOwner,BOOL bOwnerDefaulted),BOOL
declare import,GetSecurityDescriptorOwner(pointer pSecurityDescriptor,pointer pOwner,pointer lpbOwnerDefaulted),BOOL
declare import,SetSecurityDescriptorGroup(pointer pSecurityDescriptor,pointer pGroup,BOOL bGroupDefaulted),BOOL
declare import,GetSecurityDescriptorGroup(pointer pSecurityDescriptor,pointer pGroup,pointer lpbGroupDefaulted),BOOL
declare import,SetSecurityDescriptorRMControl(pointer SecurityDescriptor,pointer RMControl),DWORD
declare import,GetSecurityDescriptorRMControl(pointer SecurityDescriptor,pointer RMControl),DWORD
declare import,CreatePrivateObjectSecurity(pointer ParentDescriptor,pointer CreatorDescriptor,pointer NewDescriptor,BOOL IsDirectoryObject, HANDLE Token,pointer GenericMapping),BOOL
declare import,ConvertToAutoInheritPrivateObjectSecurity(pointer ParentDescriptor,pointer CurrentSecurityDescriptor,pointer NewSecurityDescriptor,pointer ObjectType,BOOLEAN IsDirectoryObject,pointer GenericMapping),BOOL
declare import,CreatePrivateObjectSecurityEx(pointer ParentDescriptor,pointer CreatorDescriptor,pointer NewDescriptor,pointer ObjectType,BOOL IsContainerObject,ULONG AutoInheritFlags, HANDLE Token,pointer GenericMapping),BOOL
declare import,CreatePrivateObjectSecurityWithMultipleInheritance(pointer ParentDescriptor,pointer CreatorDescriptor,pointer NewDescriptor,pointer ObjectTypes,ULONG GuidCount,BOOL IsContainerObject,ULONG AutoInheritFlags, HANDLE Token,pointer GenericMapping),BOOL
declare import,SetPrivateObjectSecurity(SECURITY_INFORMATION SecurityInformation,pointer ModificationDescriptor,pointer ObjectsSecurityDescriptor,pointer GenericMapping, HANDLE Token),BOOL
declare import,SetPrivateObjectSecurityEx(SECURITY_INFORMATION SecurityInformation,pointer ModificationDescriptor,pointer ObjectsSecurityDescriptor,ULONG AutoInheritFlags,pointer GenericMapping, HANDLE Token),BOOL
declare import,GetPrivateObjectSecurity(pointer ObjectDescriptor,SECURITY_INFORMATION SecurityInformation,pointer ResultantDescriptor,DWORD DescriptorLength,pointer ReturnLength),BOOL
declare import,DestroyPrivateObjectSecurity(pointer ObjectDescriptor),BOOL
declare import,MakeSelfRelativeSD(pointer pAbsoluteSecurityDescriptor,pointer pSelfRelativeSecurityDescriptor,pointer lpdwBufferLength),BOOL
declare import,MakeAbsoluteSD(pointer pSelfRelativeSecurityDescriptor,pointer pAbsoluteSecurityDescriptor,pointer lpdwAbsoluteSecurityDescriptorSize,pointer pDacl,pointer lpdwDaclSize,pointer pSacl,pointer lpdwSaclSize,pointer pOwner,pointer lpdwOwnerSize,pointer pPrimaryGroup,pointer lpdwPrimaryGroupSize),BOOL
declare import,MakeAbsoluteSD2(pointer pSelfRelativeSecurityDescriptor,pointer lpdwBufferSize),BOOL
declare import,SetKernelObjectSecurity(HANDLE Handle,SECURITY_INFORMATION SecurityInformation,pointer SecurityDescriptor),BOOL
declare import,SetFileSecurityA(LPCSTR lpFileName,SECURITY_INFORMATION SecurityInformation,pointer pSecurityDescriptor),BOOL
declare import,SetFileSecurityW(LPCWSTR lpFileName,SECURITY_INFORMATION SecurityInformation,pointer pSecurityDescriptor),BOOL
declare import,GetFileSecurityA(LPCSTR lpFileName,SECURITY_INFORMATION RequestedInformation,pointer pSecurityDescriptor,DWORD nLength,pointer lpnLengthNeeded),BOOL
declare import,GetFileSecurityW(LPCWSTR lpFileName,SECURITY_INFORMATION RequestedInformation,pointer pSecurityDescriptor,DWORD nLength,pointer lpnLengthNeeded),BOOL
declare import,FindFirstChangeNotificationA(LPCSTR lpPathName,BOOL bWatchSubtree,DWORD dwNotifyFilter),HANDLE
declare import,FindFirstChangeNotificationW(LPCWSTR lpPathName,BOOL bWatchSubtree,DWORD dwNotifyFilter),HANDLE
$ifdef UNICODE
declare import,SetFileSecurity alias SetFileSecurityW(LPCWSTR lpFileName,SECURITY_INFORMATION SecurityInformation,pointer pSecurityDescriptor),BOOL
declare import,GetFileSecurity alias GetFileSecurityW(LPCWSTR lpFileName,SECURITY_INFORMATION RequestedInformation,pointer pSecurityDescriptor,DWORD nLength,pointer lpnLengthNeeded),BOOL
declare import,FindFirstChangeNotification alias FindFirstChangeNotificationW(LPCWSTR lpPathName,BOOL bWatchSubtree,DWORD dwNotifyFilter),HANDLE
$else
declare import,SetFileSecurity alias SetFileSecurityA(LPCSTR lpFileName,SECURITY_INFORMATION SecurityInformation,pointer pSecurityDescriptor),BOOL
declare import,GetFileSecurity alias GetFileSecurityA(LPCSTR lpFileName,SECURITY_INFORMATION RequestedInformation,pointer pSecurityDescriptor,DWORD nLength,pointer lpnLengthNeeded),BOOL
declare import,FindFirstChangeNotification alias FindFirstChangeNotificationA(LPCSTR lpPathName,BOOL bWatchSubtree,DWORD dwNotifyFilter),HANDLE
$endif
declare import,FindNextChangeNotification(HANDLE hChangeHandle),BOOL
declare import,FindCloseChangeNotification(HANDLE hChangeHandle),BOOL
declare import,ReadDirectoryChangesW(HANDLE hDirectory,LPVOID lpBuffer,DWORD nBufferLength,BOOL bWatchSubtree,DWORD dwNotifyFilter,pointer lpBytesReturned,pointer lpOverlapped, LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine),BOOL
declare import,VirtualLock(LPVOID lpAddress,SIZE_T dwSize),BOOL
declare import,VirtualUnlock(LPVOID lpAddress,SIZE_T dwSize),BOOL
declare import,MapViewOfFileEx(HANDLE hFileMappingObject,DWORD dwDesiredAccess,DWORD dwFileOffsetHigh,DWORD dwFileOffsetLow,SIZE_T dwNumberOfBytesToMap, LPVOID lpBaseAddress),LPVOID
declare import,SetPriorityClass(HANDLE hProcess,DWORD dwPriorityClass),BOOL
declare import,GetPriorityClass(HANDLE hProcess),DWORD
declare import,IsBadReadPtr(pointer lp,UINT_PTR ucb),BOOL
declare import,IsBadWritePtr(LPVOID lp,UINT_PTR ucb),BOOL
declare import,IsBadHugeReadPtr(pointer lp,UINT_PTR ucb),BOOL
declare import,IsBadHugeWritePtr(LPVOID lp,UINT_PTR ucb),BOOL
declare import,IsBadCodePtr(FARPROC lpfn),BOOL
declare import,AllocateLocallyUniqueId(pointer Luid),BOOL
declare import,IsBadStringPtrA(LPCSTR lpsz,UINT_PTR ucchMax),BOOL
declare import,IsBadStringPtrW(LPCWSTR lpsz,UINT_PTR ucchMax),BOOL
declare import,LookupAccountSidA(LPCSTR lpSystemName,pointer Sid,LPSTR Name,pointer cchName,LPSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupAccountSidW(LPCWSTR lpSystemName,pointer Sid,LPWSTR Name,pointer cchName,LPWSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupAccountNameA(LPCSTR lpSystemName,LPCSTR lpAccountName,pointer Sid,pointer cbSid,LPSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupAccountNameW(LPCWSTR lpSystemName,LPCWSTR lpAccountName,pointer Sid,pointer cbSid,LPWSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupPrivilegeValueA(LPCSTR lpSystemName,LPCSTR lpName,pointer lpLuid),BOOL
declare import,LookupPrivilegeValueW(LPCWSTR lpSystemName,LPCWSTR lpName,pointer lpLuid),BOOL
declare import,LookupPrivilegeNameA(LPCSTR lpSystemName,pointer lpLuid,LPSTR lpName,pointer cchName),BOOL
declare import,LookupPrivilegeNameW(LPCWSTR lpSystemName,pointer lpLuid,LPWSTR lpName,pointer cchName),BOOL
declare import,LookupPrivilegeDisplayNameA(LPCSTR lpSystemName,LPCSTR lpName,LPSTR lpDisplayName,pointer cchDisplayName,pointer lpLanguageId),BOOL
declare import,LookupPrivilegeDisplayNameW(LPCWSTR lpSystemName,LPCWSTR lpName,LPWSTR lpDisplayName,pointer cchDisplayName,pointer lpLanguageId),BOOL
declare import,BuildCommDCBA(LPCSTR lpDef,pointer lpDCB),BOOL
declare import,BuildCommDCBW(LPCWSTR lpDef,pointer lpDCB),BOOL
declare import,BuildCommDCBAndTimeoutsA(LPCSTR lpDef,pointer lpDCB,pointer lpCommTimeouts),BOOL
declare import,BuildCommDCBAndTimeoutsW(LPCWSTR lpDef,pointer lpDCB,pointer lpCommTimeouts),BOOL
declare import,CommConfigDialogA(LPCSTR lpszName, HWND hWnd,pointer lpCC),BOOL
declare import,CommConfigDialogW(LPCWSTR lpszName, HWND hWnd,pointer lpCC),BOOL
declare import,GetDefaultCommConfigA(LPCSTR lpszName,pointer lpCC,pointer lpdwSize),BOOL
declare import,GetDefaultCommConfigW(LPCWSTR lpszName,pointer lpCC,pointer lpdwSize),BOOL
declare import,SetDefaultCommConfigA(LPCSTR lpszName,pointer lpCC,DWORD dwSize),BOOL
declare import,SetDefaultCommConfigW(LPCWSTR lpszName,pointer lpCC,DWORD dwSize),BOOL
$ifdef UNICODE
declare import,IsBadStringPtr alias IsBadStringPtrW(LPCWSTR lpsz,UINT_PTR ucchMax),BOOL
declare import,LookupAccountSid alias LookupAccountSidW(LPCWSTR lpSystemName,pointer Sid,LPWSTR Name,pointer cchName,LPWSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupAccountName alias LookupAccountNameW(LPCWSTR lpSystemName,LPCWSTR lpAccountName,pointer Sid,pointer cbSid,LPWSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupPrivilegeValue alias LookupPrivilegeValueW(LPCWSTR lpSystemName,LPCWSTR lpName,pointer lpLuid),BOOL
declare import,LookupPrivilegeName alias LookupPrivilegeNameW(LPCWSTR lpSystemName,pointer lpLuid,LPWSTR lpName,pointer cchName),BOOL
declare import,LookupPrivilegeDisplayName alias LookupPrivilegeDisplayNameW(LPCWSTR lpSystemName,LPCWSTR lpName,LPWSTR lpDisplayName,pointer cchDisplayName,pointer lpLanguageId),BOOL
declare import,BuildCommDCB alias BuildCommDCBW(LPCWSTR lpDef,pointer lpDCB),BOOL
declare import,BuildCommDCBAndTimeouts alias BuildCommDCBAndTimeoutsW(LPCWSTR lpDef,pointer lpDCB,pointer lpCommTimeouts),BOOL
declare import,CommConfigDialog alias CommConfigDialogW(LPCWSTR lpszName, HWND hWnd,pointer lpCC),BOOL
declare import,GetDefaultCommConfig alias GetDefaultCommConfigW(LPCWSTR lpszName,pointer lpCC,pointer lpdwSize),BOOL
declare import,SetDefaultCommConfig alias SetDefaultCommConfigW(LPCWSTR lpszName,pointer lpCC,DWORD dwSize),BOOL
$else
declare import,IsBadStringPtr alias IsBadStringPtrA(LPCSTR lpsz,UINT_PTR ucchMax),BOOL
declare import,LookupAccountSid alias LookupAccountSidA(LPCSTR lpSystemName,pointer Sid,LPSTR Name,pointer cchName,LPSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupAccountName alias LookupAccountNameA(LPCSTR lpSystemName,LPCSTR lpAccountName,pointer Sid,pointer cbSid,LPSTR ReferencedDomainName,pointer cchReferencedDomainName,pointer peUse),BOOL
declare import,LookupPrivilegeValue alias LookupPrivilegeValueA(LPCSTR lpSystemName,LPCSTR lpName,pointer lpLuid),BOOL
declare import,LookupPrivilegeName alias LookupPrivilegeNameA(LPCSTR lpSystemName,pointer lpLuid,LPSTR lpName,pointer cchName),BOOL
declare import,LookupPrivilegeDisplayName alias LookupPrivilegeDisplayNameA(LPCSTR lpSystemName,LPCSTR lpName,LPSTR lpDisplayName,pointer cchDisplayName,pointer lpLanguageId),BOOL
declare import,BuildCommDCB alias BuildCommDCBA(LPCSTR lpDef,pointer lpDCB),BOOL
declare import,BuildCommDCBAndTimeouts alias BuildCommDCBAndTimeoutsA(LPCSTR lpDef,pointer lpDCB,pointer lpCommTimeouts),BOOL
declare import,CommConfigDialog alias CommConfigDialogA(LPCSTR lpszName, HWND hWnd,pointer lpCC),BOOL
declare import,GetDefaultCommConfig alias GetDefaultCommConfigA(LPCSTR lpszName,pointer lpCC,pointer lpdwSize),BOOL
declare import,SetDefaultCommConfig alias SetDefaultCommConfigA(LPCSTR lpszName,pointer lpCC,DWORD dwSize),BOOL
$endif

$ifndef _MAC
$define MAX_COMPUTERNAME_LENGTH 15
$else
$define MAX_COMPUTERNAME_LENGTH 31
$endif
declare import,GetComputerNameA(LPSTR lpBuffer,pointer nSize),BOOL
declare import,GetComputerNameW(LPWSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerNameA(LPCSTR lpComputerName),BOOL
declare import,SetComputerNameW(LPCWSTR lpComputerName),BOOL
$ifdef UNICODE
declare import,GetComputerName alias GetComputerNameW(LPWSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerName alias SetComputerNameW(LPCWSTR lpComputerName),BOOL
$else
declare import,GetComputerName alias GetComputerNameA(LPSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerName alias SetComputerNameA(LPCSTR lpComputerName),BOOL
$endif

typedef COMPUTER_NAME_FORMAT int
$define ComputerNameNetBIOS 0
$define ComputerNameDnsHostname 1
$define ComputerNameDnsDomain 2
$define ComputerNameDnsFullyQualified 3
$define ComputerNamePhysicalNetBIOS 4
$define ComputerNamePhysicalDnsHostname 5
$define ComputerNamePhysicalDnsDomain 6
$define ComputerNamePhysicalDnsFullyQualified 7
$define ComputerNameMax 8
declare import,GetComputerNameExA(COMPUTER_NAME_FORMAT NameType,LPSTR lpBuffer,pointer nSize),BOOL
declare import,GetComputerNameExW(COMPUTER_NAME_FORMAT NameType,LPWSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerNameExA(COMPUTER_NAME_FORMAT NameType,LPCSTR lpBuffer),BOOL
declare import,SetComputerNameExW(COMPUTER_NAME_FORMAT NameType,LPCWSTR lpBuffer),BOOL
declare import,DnsHostnameToComputerNameA(LPCSTR Hostname,LPSTR ComputerName,pointer nSize),BOOL
declare import,DnsHostnameToComputerNameW(LPCWSTR Hostname,LPWSTR ComputerName,pointer nSize),BOOL
declare import,GetUserNameA(LPSTR lpBuffer,pointer pcbBuffer),BOOL
declare import,GetUserNameW(LPWSTR lpBuffer,pointer pcbBuffer),BOOL
$ifdef UNICODE
declare import,GetComputerNameEx alias GetComputerNameExW(COMPUTER_NAME_FORMAT NameType,LPWSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerNameEx alias SetComputerNameExW(COMPUTER_NAME_FORMAT NameType,LPCWSTR lpBuffer),BOOL
declare import,DnsHostnameToComputerName alias DnsHostnameToComputerNameW(LPCWSTR Hostname,LPWSTR ComputerName,pointer nSize),BOOL
declare import,GetUserName alias GetUserNameW(LPWSTR lpBuffer,pointer pcbBuffer),BOOL
$else
declare import,GetComputerNameEx alias GetComputerNameExA(COMPUTER_NAME_FORMAT NameType,LPSTR lpBuffer,pointer nSize),BOOL
declare import,SetComputerNameEx alias SetComputerNameExA(COMPUTER_NAME_FORMAT NameType,LPCSTR lpBuffer),BOOL
declare import,DnsHostnameToComputerName alias DnsHostnameToComputerNameA(LPCSTR Hostname,LPSTR ComputerName,pointer nSize),BOOL
declare import,GetUserName alias GetUserNameA(LPSTR lpBuffer,pointer pcbBuffer),BOOL
$endif

' Logon Support APIs

$define LOGON32_LOGON_INTERACTIVE	2
$define LOGON32_LOGON_NETWORK	3
$define LOGON32_LOGON_BATCH	4
$define LOGON32_LOGON_SERVICE	5
$define LOGON32_LOGON_UNLOCK	7
$define LOGON32_LOGON_NETWORK_CLEARTEXT 8
$define LOGON32_LOGON_NEW_CREDENTIALS	9

$define LOGON32_PROVIDER_DEFAULT	0
$define LOGON32_PROVIDER_WINNT35	1
$define LOGON32_PROVIDER_WINNT40	2
$define LOGON32_PROVIDER_WINNT50	3
declare import,ImpersonateLoggedOnUser(HANDLE	hToken),BOOL
declare import,LogonUserA(LPCSTR lpszUsername, LPCSTR lpszDomain,LPCSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken),BOOL
declare import,LogonUserW(LPCWSTR lpszUsername, LPCWSTR lpszDomain,LPCWSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken),BOOL
declare import,LogonUserExA(LPCSTR lpszUsername, LPCSTR lpszDomain,LPCSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken,pointer ppLogonSid,pointer ppProfileBuffer,pointer pdwProfileLength, pointer pQuotaLimits),BOOL
declare import,LogonUserExW(LPCWSTR lpszUsername, LPCWSTR lpszDomain,LPCWSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken,pointer ppLogonSid,pointer ppProfileBuffer,pointer pdwProfileLength, pointer pQuotaLimits),BOOL
declare import,CreateProcessAsUserA(HANDLE hToken, LPCSTR lpApplicationName,opt LPSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
declare import,CreateProcessAsUserW(HANDLE hToken, LPCWSTR lpApplicationName,opt LPWSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$ifdef UNICODE
declare import,LogonUser alias LogonUserW(LPCWSTR lpszUsername, LPCWSTR lpszDomain,LPCWSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken),BOOL
declare import,LogonUserEx alias LogonUserExW(LPCWSTR lpszUsername, LPCWSTR lpszDomain,LPCWSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken,pointer ppLogonSid,pointer ppProfileBuffer,pointer pdwProfileLength, pointer pQuotaLimits),BOOL
declare import,CreateProcessAsUser alias CreateProcessAsUserW(HANDLE hToken, LPCWSTR lpApplicationName, LPWSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$else
declare import,LogonUser alias LogonUserA(LPCSTR lpszUsername, LPCSTR lpszDomain,LPCSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken),BOOL
declare import,LogonUserEx alias LogonUserExA(LPCSTR lpszUsername, LPCSTR lpszDomain,LPCSTR lpszPassword,DWORD dwLogonType,DWORD dwLogonProvider,pointer phToken,pointer ppLogonSid,pointer ppProfileBuffer,pointer pdwProfileLength, pointer pQuotaLimits),BOOL
declare import,CreateProcessAsUser alias CreateProcessAsUserA(HANDLE hToken, LPCSTR lpApplicationName, LPSTR lpCommandLine,pointer lpProcessAttributes,pointer lpThreadAttributes,BOOL bInheritHandles,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
$endif
' LogonFlags
$define LOGON_WITH_PROFILE	0x00000001
$define LOGON_NETCREDENTIALS_ONLY	0x00000002
$define LOGON_ZERO_PASSWORD_BUFFER	0x80000000
declare import,CreateProcessWithLogonW(LPCWSTR lpUsername, LPCWSTR lpDomain,LPCWSTR lpPassword,DWORD dwLogonFlags, LPCWSTR lpApplicationName, LPWSTR lpCommandLine,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
declare import,CreateProcessWithTokenW(HANDLE hToken,DWORD dwLogonFlags, LPCWSTR lpApplicationName, LPWSTR lpCommandLine,DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,pointer lpStartupInfo,pointer lpProcessInformation),BOOL
declare import,ImpersonateAnonymousToken(HANDLE ThreadHandle),BOOL
declare import,DuplicateTokenEx(HANDLE hExistingToken,DWORD dwDesiredAccess,pointer lpTokenAttributes,SECURITY_IMPERSONATION_LEVEL ImpersonationLevel,TOKEN_TYPE TokenType,pointer phNewToken),BOOL
declare import,CreateRestrictedToken(HANDLE ExistingTokenHandle,DWORD Flags,DWORD DisableSidCount,pointer SidsToDisable,DWORD DeletePrivilegeCount,pointer PrivilegesToDelete,DWORD RestrictedSidCount,pointer SidsToRestrict,pointer NewTokenHandle),BOOL
declare import,IsTokenRestricted(HANDLE TokenHandle),BOOL
declare import,IsTokenUntrusted(HANDLE TokenHandle),BOOL
declare import,CheckTokenMembership(HANDLE TokenHandle,pointer SidToCheck,pointer IsMember),BOOL

' Thread pool API's

'typedef WAITORTIMERCALLBACK WAITORTIMERCALLBACKFUNC
typedef WAITORTIMERCALLBACK int
declare import,RegisterWaitForSingleObject(pointer phNewWaitObject,HANDLE hObject,WAITORTIMERCALLBACK Callback, PVOID Context,ULONG dwMilliseconds,ULONG dwFlags),BOOL
declare import,RegisterWaitForSingleObjectEx(HANDLE hObject,WAITORTIMERCALLBACK Callback, PVOID Context,ULONG dwMilliseconds,ULONG dwFlags),HANDLE
declare import,UnregisterWait(HANDLE WaitHandle),BOOL
declare import,UnregisterWaitEx(HANDLE WaitHandle, HANDLE CompletionEvent),BOOL
declare import,QueueUserWorkItem(LPTHREAD_START_ROUTINE Function, PVOID Context,ULONG Flags),BOOL
declare import,BindIoCompletionCallback(HANDLE FileHandle,LPOVERLAPPED_COMPLETION_ROUTINE Function,ULONG Flags),BOOL
declare import,CreateTimerQueue(),HANDLE
declare import,CreateTimerQueueTimer(pointer phNewTimer, HANDLE TimerQueue,WAITORTIMERCALLBACK Callback, PVOID Parameter,DWORD DueTime,DWORD Period,ULONG Flags),BOOL
declare import,ChangeTimerQueueTimer(HANDLE TimerQueue, HANDLE hTimer,ULONG DueTime,ULONG Period),BOOL
declare import,DeleteTimerQueueTimer(HANDLE TimerQueue,HANDLE hTimer, HANDLE CompletionEvent),BOOL
declare import,DeleteTimerQueueEx(HANDLE TimerQueue, HANDLE CompletionEvent),BOOL
declare import,SetTimerQueueTimer(HANDLE TimerQueue,WAITORTIMERCALLBACK Callback, PVOID Parameter,DWORD DueTime,DWORD Period,BOOL PreferIo),HANDLE
declare import,CancelTimerQueueTimer(HANDLE TimerQueue,HANDLE hTimer),BOOL
declare import,DeleteTimerQueue(HANDLE TimerQueue),BOOL

' Plug-and-Play API's

$define HW_PROFILE_GUIDLEN	39	' 36-characters plus NULL terminator
$define MAX_PROFILE_LEN	80

$define DOCKINFO_UNDOCKED	(0x1)
$define DOCKINFO_DOCKED	(0x2)
$define DOCKINFO_USER_SUPPLIED	(0x4)
$define DOCKINFO_USER_UNDOCKED	(DOCKINFO_USER_SUPPLIED | DOCKINFO_UNDOCKED)
$define DOCKINFO_USER_DOCKED	(DOCKINFO_USER_SUPPLIED | DOCKINFO_DOCKED)

type HW_PROFILE_INFOA
	DWORD	dwDockInfo
	istring szHwProfileGuid[HW_PROFILE_GUIDLEN]
	istring szHwProfileName[MAX_PROFILE_LEN]
endtype
type HW_PROFILE_INFOW
	DWORD	dwDockInfo
	iwstring szHwProfileGuid[HW_PROFILE_GUIDLEN]
	iwstring szHwProfileName[MAX_PROFILE_LEN]
endtype
declare import,GetCurrentHwProfileA(pointer lpHwProfileInfo),BOOL
declare import,GetCurrentHwProfileW(pointer lpHwProfileInfo),BOOL
$ifdef UNICODE
type HW_PROFILE_INFO
	DWORD	dwDockInfo
	iwstring szHwProfileGuid[HW_PROFILE_GUIDLEN]
	iwstring szHwProfileName[MAX_PROFILE_LEN]
endtype
declare import,GetCurrentHwProfile alias GetCurrentHwProfileW(pointer lpHwProfileInfo),BOOL
$else
type HW_PROFILE_INFO
	DWORD	dwDockInfo
	istring szHwProfileGuid[HW_PROFILE_GUIDLEN]
	istring szHwProfileName[MAX_PROFILE_LEN]
endtype
declare import,GetCurrentHwProfile alias GetCurrentHwProfileA(pointer lpHwProfileInfo),BOOL
$endif
' Performance counter API's
declare import,QueryPerformanceCounter(pointer lpPerformanceCount),BOOL
declare import,QueryPerformanceFrequency(pointer lpFrequency),BOOL
declare import,GetVersionExA(pointer lpVersionInformation),BOOL
declare import,GetVersionExW(pointer lpVersionInformation),BOOL
declare import,VerifyVersionInfoA(pointer lpVersionInformation,DWORD dwTypeMask,DWORDLONG dwlConditionMask),BOOL
declare import,VerifyVersionInfoW(pointer lpVersionInformation,DWORD dwTypeMask,DWORDLONG dwlConditionMask),BOOL
$ifdef UNICODE
declare import,GetVersionEx alias GetVersionExW(pointer lpVersionInformation),BOOL
declare import,VerifyVersionInfo alias VerifyVersionInfoW(pointer lpVersionInformation,DWORD dwTypeMask,DWORDLONG dwlConditionMask),BOOL
$else
declare import,GetVersionEx alias GetVersionExA(pointer lpVersionInformation),BOOL
declare import,VerifyVersionInfo alias VerifyVersionInfoA(pointer lpVersionInformation,DWORD dwTypeMask,DWORDLONG dwlConditionMask),BOOL
$endif

' DOS and OS/2 Compatible Error Code definitions returned by the Win32 Base
' API functions.

$ifndef __winerror_inc__
$include "winerror.inc"
$endif

/* Abnormal termination codes */

$define TC_NORMAL	0
$define TC_HARDERR	1
$define TC_GP_TRAP	2
$define TC_SIGNAL	3

' Power Management APIs

$define AC_LINE_OFFLINE	0x00
$define AC_LINE_ONLINE	0x01
$define AC_LINE_BACKUP_POWER	0x02
$define AC_LINE_UNKNOWN	0xFF

$define BATTERY_FLAG_HIGH	0x01
$define BATTERY_FLAG_LOW	0x02
$define BATTERY_FLAG_CRITICAL	0x04
$define BATTERY_FLAG_CHARGING	0x08
$define BATTERY_FLAG_NO_BATTERY	0x80
$define BATTERY_FLAG_UNKNOWN	0xFF

$define BATTERY_PERCENTAGE_UNKNOWN	0xFF

$define BATTERY_LIFE_UNKNOWN	0xFFFFFFFF

type SYSTEM_POWER_STATUS
	BYTE ACLineStatus
	BYTE BatteryFlag
	BYTE BatteryLifePercent
	BYTE Reserved1
	DWORD BatteryLifeTime
	DWORD BatteryFullLifeTime
endtype
declare import,GetSystemPowerStatus(pointer lpSystemPowerStatus),BOOL
declare import,SetSystemPowerState(BOOL fSuspend,BOOL fForce),BOOL

' Very Large Memory API Subset
declare import,AllocateUserPhysicalPages(HANDLE hProcess,pointer NumberOfPages,pointer PageArray),BOOL
declare import,FreeUserPhysicalPages(HANDLE hProcess,pointer NumberOfPages,pointer PageArray),BOOL
declare import,MapUserPhysicalPages(PVOID VirtualAddress,ULONG_PTR NumberOfPages,pointer PageArray),BOOL
declare import,MapUserPhysicalPagesScatter(pointer VirtualAddresses,ULONG_PTR NumberOfPages,pointer PageArray),BOOL
declare import,AssignProcessToJobObject(HANDLE hJob,HANDLE hProcess),BOOL
declare import,TerminateJobObject(HANDLE hJob,UINT uExitCode),BOOL
declare import,QueryInformationJobObject(HANDLE hJob,JOBOBJECTINFOCLASS JobObjectInformationClass,LPVOID lpJobObjectInformation,DWORD cbJobObjectInformationLength,pointer lpReturnLength),BOOL
declare import,SetInformationJobObject(HANDLE hJob,JOBOBJECTINFOCLASS JobObjectInformationClass,LPVOID lpJobObjectInformation,DWORD cbJobObjectInformationLength),BOOL
declare import,IsProcessInJob(HANDLE ProcessHandle, HANDLE JobHandle,pointer Result),BOOL
declare import,CreateJobSet(ULONG NumJob,pointer UserJobSet,ULONG Flags),BOOL
declare import,AddVectoredExceptionHandler(ULONG First,PVECTORED_EXCEPTION_HANDLER Handler),PVOID
declare import,RemoveVectoredExceptionHandler(PVOID Handle),ULONG
declare import,AddVectoredContinueHandler(ULONG First,PVECTORED_EXCEPTION_HANDLER Handler),PVOID
declare import,RemoveVectoredContinueHandler(PVOID Handle),ULONG
declare import,CreateJobObjectA(pointer lpJobAttributes, LPCSTR lpName),HANDLE
declare import,CreateJobObjectW(pointer lpJobAttributes, LPCWSTR lpName),HANDLE
declare import,OpenJobObjectA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
declare import,OpenJobObjectW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
$ifdef UNICODE
declare import,CreateJobObject alias CreateJobObjectW(pointer lpJobAttributes, LPCWSTR lpName),HANDLE
declare import,OpenJobObject alias OpenJobObjectW(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCWSTR lpName),HANDLE
$else
declare import,CreateJobObject alias CreateJobObjectA(pointer lpJobAttributes, LPCSTR lpName),HANDLE
declare import,OpenJobObject alias OpenJobObjectA(DWORD dwDesiredAccess,BOOL bInheritHandle,LPCSTR lpName),HANDLE
$endif
' New Volume Mount Point API.
declare import,FindVolumeClose(HANDLE hFindVolume),BOOL
declare import,FindVolumeMountPointClose(HANDLE hFindVolumeMountPoint),BOOL
declare import,FindFirstVolumeA(LPSTR lpszVolumeName,DWORD cchBufferLength),HANDLE
declare import,FindFirstVolumeW(LPWSTR lpszVolumeName,DWORD cchBufferLength),HANDLE
declare import,FindNextVolumeA(HANDLE hFindVolume,LPSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,FindNextVolumeW(HANDLE hFindVolume,LPWSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,FindFirstVolumeMountPointA(LPCSTR lpszRootPathName,LPSTR lpszVolumeMountPoint,DWORD cchBufferLength),HANDLE
declare import,FindFirstVolumeMountPointW(LPCWSTR lpszRootPathName,LPWSTR lpszVolumeMountPoint,DWORD cchBufferLength),HANDLE
declare import,FindNextVolumeMountPointA(HANDLE hFindVolumeMountPoint,LPSTR lpszVolumeMountPoint,DWORD cchBufferLength),BOOL
declare import,FindNextVolumeMountPointW(HANDLE hFindVolumeMountPoint,LPWSTR lpszVolumeMountPoint,DWORD cchBufferLength),BOOL
declare import,SetVolumeMountPointA(LPCSTR lpszVolumeMountPoint,LPCSTR lpszVolumeName),BOOL
declare import,SetVolumeMountPointW(LPCWSTR lpszVolumeMountPoint,LPCWSTR lpszVolumeName),BOOL
declare import,DeleteVolumeMountPointA(LPCSTR lpszVolumeMountPoint),BOOL
declare import,DeleteVolumeMountPointW(LPCWSTR lpszVolumeMountPoint),BOOL
declare import,GetVolumeNameForVolumeMountPointA(LPCSTR lpszVolumeMountPoint,LPSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,GetVolumeNameForVolumeMountPointW(LPCWSTR lpszVolumeMountPoint,LPWSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathNameA(LPCSTR lpszFileName,LPSTR lpszVolumePathName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathNameW(LPCWSTR lpszFileName,LPWSTR lpszVolumePathName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathNamesForVolumeNameA(LPCSTR lpszVolumeName,LPCH lpszVolumePathNames,DWORD cchBufferLength,pointer lpcchReturnLength),BOOL
declare import,GetVolumePathNamesForVolumeNameW(LPCWSTR lpszVolumeName,LPWCH lpszVolumePathNames,DWORD cchBufferLength,pointer lpcchReturnLength),BOOL
$ifdef UNICODE
declare import,FindFirstVolume alias FindFirstVolumeW(LPWSTR lpszVolumeName,DWORD cchBufferLength),HANDLE
declare import,FindNextVolume alias FindNextVolumeW(HANDLE hFindVolume,LPWSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,FindFirstVolumeMountPoint alias FindFirstVolumeMountPointW(LPCWSTR lpszRootPathName,LPWSTR lpszVolumeMountPoint,DWORD cchBufferLength),HANDLE
declare import,FindNextVolumeMountPoint alias FindNextVolumeMountPointW(HANDLE hFindVolumeMountPoint,LPWSTR lpszVolumeMountPoint,DWORD cchBufferLength),BOOL
declare import,SetVolumeMountPoint alias SetVolumeMountPointW(LPCWSTR lpszVolumeMountPoint,LPCWSTR lpszVolumeName),BOOL
declare import,DeleteVolumeMountPoint alias DeleteVolumeMountPointW(LPCWSTR lpszVolumeMountPoint),BOOL
declare import,GetVolumeNameForVolumeMountPoint alias GetVolumeNameForVolumeMountPointW(LPCWSTR lpszVolumeMountPoint,LPWSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathName alias GetVolumePathNameW(LPCWSTR lpszFileName,LPWSTR lpszVolumePathName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathNamesForVolumeName alias GetVolumePathNamesForVolumeNameW(LPCWSTR lpszVolumeName,LPWCH lpszVolumePathNames,DWORD cchBufferLength,pointer lpcchReturnLength),BOOL
$else
declare import,FindFirstVolume alias FindFirstVolumeA(LPSTR lpszVolumeName,DWORD cchBufferLength),HANDLE
declare import,FindNextVolume alias FindNextVolumeA(HANDLE hFindVolume,LPSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,FindFirstVolumeMountPoint alias FindFirstVolumeMountPointA(LPCSTR lpszRootPathName,LPSTR lpszVolumeMountPoint,DWORD cchBufferLength),HANDLE
declare import,FindNextVolumeMountPoint alias FindNextVolumeMountPointA(HANDLE hFindVolumeMountPoint,LPSTR lpszVolumeMountPoint,DWORD cchBufferLength),BOOL
declare import,SetVolumeMountPoint alias SetVolumeMountPointA(LPCSTR lpszVolumeMountPoint,LPCSTR lpszVolumeName),BOOL
declare import,DeleteVolumeMountPoint alias DeleteVolumeMountPointA(LPCSTR lpszVolumeMountPoint),BOOL
declare import,GetVolumeNameForVolumeMountPoint alias GetVolumeNameForVolumeMountPointA(LPCSTR lpszVolumeMountPoint,LPSTR lpszVolumeName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathName alias GetVolumePathNameA(LPCSTR lpszFileName,LPSTR lpszVolumePathName,DWORD cchBufferLength),BOOL
declare import,GetVolumePathNamesForVolumeName alias GetVolumePathNamesForVolumeNameA(LPCSTR lpszVolumeName,LPCH lpszVolumePathNames,DWORD cchBufferLength,pointer lpcchReturnLength),BOOL
$endif
$define ACTCTX_FLAG_PROCESSOR_ARCHITECTURE_VALID	(0x00000001)
$define ACTCTX_FLAG_LANGID_VALID	(0x00000002)
$define ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID	(0x00000004)
$define ACTCTX_FLAG_RESOURCE_NAME_VALID	(0x00000008)
$define ACTCTX_FLAG_SET_PROCESS_DEFAULT	(0x00000010)
$define ACTCTX_FLAG_APPLICATION_NAME_VALID	(0x00000020)
$define ACTCTX_FLAG_SOURCE_IS_ASSEMBLYREF	(0x00000040)
$define ACTCTX_FLAG_HMODULE_VALID	(0x00000080)

type ACTCTXA
	ULONG	cbSize
	DWORD	dwFlags
	LPCSTR	lpSource
	USHORT	wProcessorArchitecture
	LANGID	wLangId
	LPCSTR	lpAssemblyDirectory
	LPCSTR	lpResourceName
	LPCSTR	lpApplicationName
	HMODULE	hModule
endtype
type ACTCTXW
	ULONG	cbSize
	DWORD	dwFlags
	LPCWSTR	lpSource
	USHORT	wProcessorArchitecture
	LANGID	wLangId
	LPCWSTR	lpAssemblyDirectory
	LPCWSTR	lpResourceName
	LPCWSTR	lpApplicationName
	HMODULE	hModule
endtype
$ifdef UNICODE
type ACTCTX
	ULONG	cbSize
	DWORD	dwFlags
	pointer	lpSource
	USHORT	wProcessorArchitecture
	LANGID	wLangId
	pointer	lpAssemblyDirectory
	pointer	lpResourceName
	pointer	lpApplicationName
	HMODULE	hModule
endtype
$else
type ACTCTX /*removed {*/
	ULONG	cbSize
	DWORD	dwFlags
	pointer	lpSource
	USHORT	wProcessorArchitecture
	LANGID	wLangId
	pointer	lpAssemblyDirectory
	pointer	lpResourceName
	pointer	lpApplicationName
	HMODULE	hModule
endtype
$endif
declare import,CreateActCtxA(pointer pActCtx),HANDLE
declare import,CreateActCtxW(pointer pActCtx),HANDLE
$ifdef UNICODE
declare import,CreateActCtx alias CreateActCtxW(pointer pActCtx),HANDLE
$else
declare import,CreateActCtx alias CreateActCtxA(pointer pActCtx),HANDLE
$endif
declare import,AddRefActCtx(HANDLE hActCtx)
declare import,ReleaseActCtx(HANDLE hActCtx)
declare import,ZombifyActCtx(HANDLE hActCtx),BOOL
declare import,ActivateActCtx(HANDLE hActCtx,pointer lpCookie),BOOL

$define DEACTIVATE_ACTCTX_FLAG_FORCE_EARLY_DEACTIVATION(0x00000001)
declare import,DeactivateActCtx(DWORD dwFlags,ULONG_PTR ulCookie),BOOL
declare import,GetCurrentActCtx(pointer lphActCtx),BOOL

type ACTCTX_SECTION_KEYED_DATA_2600
	ULONG cbSize
	ULONG ulDataFormatVersion
	PVOID lpData
	ULONG ulLength
	PVOID lpSectionGlobalData
	ULONG ulSectionGlobalDataLength
	PVOID lpSectionBase
	ULONG ulSectionTotalLength
	HANDLE hActCtx
	ULONG ulAssemblyRosterIndex
endtype

type ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA
	PVOID lpInformation
	PVOID lpSectionBase
	ULONG ulSectionLength
	PVOID lpSectionGlobalDataBase
	ULONG ulSectionGlobalDataLength
endtype

type ACTCTX_SECTION_KEYED_DATA
	ULONG cbSize
	ULONG ulDataFormatVersion
	PVOID lpData
	ULONG ulLength
	PVOID lpSectionGlobalData
	ULONG ulSectionGlobalDataLength
	PVOID lpSectionBase
	ULONG ulSectionTotalLength
	HANDLE hActCtx
	ULONG ulAssemblyRosterIndex
' 2600 stops here
	ULONG ulFlags
	ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA AssemblyMetadata
endtype

$define FIND_ACTCTX_SECTION_KEY_RETURN_HACTCTX(0x00000001)
$define FIND_ACTCTX_SECTION_KEY_RETURN_FLAGS	(0x00000002)
$define FIND_ACTCTX_SECTION_KEY_RETURN_ASSEMBLY_METADATA(0x00000004)
declare import,FindActCtxSectionGuid(DWORD dwFlags,pointer lpExtensionGuid,ULONG ulSectionId,pointer lpGuidToFind,pointer ReturnedData),BOOL
declare import,FindActCtxSectionStringA(DWORD dwFlags,pointer lpExtensionGuid,ULONG ulSectionId,LPCSTR lpStringToFind,pointer ReturnedData),BOOL
declare import,FindActCtxSectionStringW(DWORD dwFlags,pointer lpExtensionGuid,ULONG ulSectionId,LPCWSTR lpStringToFind,pointer ReturnedData),BOOL
$ifdef UNICODE
declare import,FindActCtxSectionString alias FindActCtxSectionStringW(DWORD dwFlags,pointer lpExtensionGuid,ULONG ulSectionId,LPCWSTR lpStringToFind,pointer ReturnedData),BOOL
$else
declare import,FindActCtxSectionString alias FindActCtxSectionStringA(DWORD dwFlags,pointer lpExtensionGuid,ULONG ulSectionId,LPCSTR lpStringToFind,pointer ReturnedData),BOOL
$endif
type ACTIVATION_CONTEXT_BASIC_INFORMATION
	HANDLE	hActCtx
	DWORD	dwFlags
endtype

$define ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED 1

$define QUERY_ACTCTX_FLAG_USE_ACTIVE_ACTCTX(0x00000004)
$define QUERY_ACTCTX_FLAG_ACTCTX_IS_HMODULE(0x00000008)
$define QUERY_ACTCTX_FLAG_ACTCTX_IS_ADDRESS(0x00000010)
$define QUERY_ACTCTX_FLAG_NO_ADDREF	(0x80000000)

/*
' switch(ulInfoClass)
'	case ActivationContextBasicInformation:
'	pvSubInstance == NULL
'	pvBuffer is of type PACTIVATION_CONTEXT_BASIC_INFORMATION
'	case ActivationContextDetailedInformation:
'	pvSubInstance == NULL
'	pvBuffer is of type PACTIVATION_CONTEXT_DETAILED_INFORMATION
'	case AssemblyDetailedInformationInActivationContext:
'	pvSubInstance is of type pointer
'	* pvSubInstance < ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAssemblyCount
'	pvBuffer is of type PACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION
'	case FileInformationInAssemblyOfAssemblyInActivationContext:
'	pvSubInstance is of type PACTIVATION_CONTEXT_QUERY_INDEX
'	pvSubInstance->ulAssemblyIndex < ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAssemblyCount
'	pvSubInstance->ulFileIndexInAssembly < ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulFileCount
'	pvBuffer is of type PASSEMBLY_FILE_DETAILED_INFORMATION
' String are placed after the structs.
*/
declare import,QueryActCtxW(DWORD dwFlags,HANDLE hActCtx, PVOID pvSubInstance,ULONG ulInfoClass,PVOID pvBuffer,SIZE_T cbBuffer,pointer pcbWrittenOrRequired),BOOL

typedef PQUERYACTCTXW_FUNC int
/*typedef(* PQUERYACTCTXW_FUNC)(DWORD dwFlags,HANDLE hActCtx, PVOID pvSubInstance,ULONG ulInfoClass,(cbBuffer,*pcbWrittenOrRequired)PVOID pvBuffer,SIZE_T cbBuffer,opt SIZE_T* pcbWrittenOrRequired),BOOL;*/
declare import,ProcessIdToSessionId(DWORD dwProcessId,pointer pSessionId),BOOL
declare import,WTSGetActiveConsoleSessionId(),DWORD
declare import,IsWow64Process(HANDLE hProcess,pointer Wow64Process),BOOL
declare import,GetLogicalProcessorInformation(pointer Buffer,pointer ReturnedLength),BOOL

' NUMA Information routines.
declare import,GetNumaHighestNodeNumber(pointer HighestNodeNumber),BOOL
declare import,GetNumaProcessorNode(UCHAR Processor,pointer NodeNumber),BOOL
declare import,GetNumaNodeProcessorMask(UCHAR Node,pointer ProcessorMask),BOOL
declare import,GetNumaAvailableMemoryNode(UCHAR Node,pointer AvailableBytes),BOOL

'$include "winbase.inl"

$endif

